-- name=int_dialog_dailybonus
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.this      = "obj_int_dialog_dailybonus";
  private.window    = "anm_int_dialog_dailybonus_window";
  private.btn_claim = "btn_int_dialog_dailybonus_accept";

  private.Adapt();
  private.CreateButtons();

  private.slot_animfuncs = {
    { "slottype1_tonextday", "slottype1_tocomplete" },
    { "slottype2_tonextday", "slottype2_tocomplete" },
    { "slottype2_tonextday", "slottype2_tocomplete" },
    { "slottype2_tonextday", "slottype2_tocomplete" },
    { "slottype3_tonextday", "slottype3_tocomplete" }
  };

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  private.app_w       = int.W();
  private.app_h       = int.H();
  private.orientation = int.Orientation();

  int.Center_Object( private.this );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  int.Button_Create(
    private.btn_claim,
    {
      title  = "str_int_dialog_dailybonus_accept",
      design = "medium",
      color  = "green",
      sound  = "bottom_button"
    },
    function()
      
      private.Claim();
      
    end
  );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( current_day, rewards )

  local objects = {};
  
  table.insert( objects, { "anm_int_dialog_dailybonus_window",
  {
    title       = ne.strings.Get( "str_int_dialog_dailybonus_caption" ),
    description = ne.strings.Get( "str_int_dialog_dailybonus_description" )
  } } );
  
  local str_today = "str_int_dialog_dailybonus_today";
  local str_nextday = "str_int_dialog_dailybonus_next_day";
  local str_complete = "str_int_dialog_dailybonus_day_complete";
  
  for day = 1, 5 do

    local reward  = rewards[ day ];
    local str_day = ne.strings.Get( "str_int_dialog_dailybonus_day", day );

    if ( reward.type == "chest" ) then

      ne.obj.Clone(
        "obj_int_dialog_dailybonus_"..reward.type,
        day,
        1,
        "anm_int_dialog_dailybonus_slot"..day
      );

      table.insert( objects, { "obj_int_dialog_dailybonus_"..reward.type..day,
      {
        name     = "obj_int_dialog_dailybonus_reward"..day,
        anim_tag = "chest" } } );

      table.insert( objects, { "spr_int_dialog_dailybonus_"..reward.type..day,
      {
        name     = "spr_int_dialog_dailybonus_reward"..day,
        animfunc = reward.name.."_static" } } );

    else

      ne.obj.Clone(
        "obj_int_dialog_dailybonus_"..reward.type,
        day,
        1,
        "anm_int_dialog_dailybonus_slot"..day
      );

      table.insert( objects, { "obj_int_dialog_dailybonus_"..reward.type..day,
      {
        name     = "obj_int_dialog_dailybonus_reward"..day,
        anim_tag = "reward1" } } );

      table.insert( objects, { "spr_int_dialog_dailybonus_"..reward.type..day,
      {
        name     = "spr_int_dialog_dailybonus_reward"..day,
        res      = "assets/content/"..reward.content.."/"..reward.name } } );

    end;
    
    if ( current_day < day ) then

      table.insert( objects, { "anm_int_dialog_dailybonus_slot"..day,
      {
        input     = false,
        animfunc  = private.slot_animfuncs[ day ][ 1 ],
        frame     = 0,
        day_in    = str_day,
        day_out   = str_day,
        complete  = str_complete,
        label     = str_nextday,
        count_in  = tostring( "#"..reward.count ),
        count_out = tostring( "#"..reward.count )
      } } );

    end;

    if ( current_day == day ) then

      table.insert( objects, { "anm_int_dialog_dailybonus_slot"..day,
      {
        input     = true,
        animfunc  = private.slot_animfuncs[ day ][ 2 ],
        frame     = 0,
        day_in    = str_day,
        day_out   = str_day,
        complete  = str_complete,
        label     = str_today,
        count_in  = tostring( "#"..reward.count ),
        count_out = tostring( "#"..reward.count )
      } } );

      common.TapSet(
        "anm_int_dialog_dailybonus_slot"..day,
        { func_true = function()

          ObjSet( "anm_int_dialog_dailybonus_slot"..day, { input = false } );
          private.Claim();
          
        end }
      );

      private.tap_reciever = "anm_int_dialog_dailybonus_slot"..day;

    end;

    if ( current_day > day ) then

      table.insert( objects, { "anm_int_dialog_dailybonus_slot"..day,
      {
        input     = false,
        animfunc  = private.slot_animfuncs[ day ][ 2 ],
        frame     = 78,
        day_in    = str_day,
        day_out   = str_day,
        complete  = str_complete,
        count_in  = tostring( "#"..reward.count ),
        count_out = tostring( "#"..reward.count )
      } } );

    end;

  end;
  
  ObjMultiSet( objects );

end;
--------------------------------------------------------------------------------
function private.Cleanup ()

  common.TapClear( private.tap_reciever );

  for day = 1, 5 do

    ObjDelete( "obj_int_dialog_dailybonus_reward"..day );

  end;

  private.Skin_Detach( private.hero );

  int.Input_On( private.btn_claim );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    current_day,
    rewards,
    func_claim,
    func_toppanel_show,
    func_dialog_hide,
    func_skin_attach,
    func_skin_detach
  )

  private.active = true;

  current_day = math.floor( current_day );
  
  ------------------------------------------------------------------------------
  private.Claim = function ()

    int.Input_Off( private.btn_claim );

    AnimPlay(
      private.window,
      "btnoff_"..private.orientation,
      ""
    );

    local next_day = current_day + 1;

    if ( next_day > 5 ) then

      next_day = 1;

    end;

    AnimPlay(
      "anm_int_dialog_dailybonus_flash",
      "flash"..current_day,
      ""
    );

    if ( current_day < 5 ) then

      AnimPlay(
        "anm_int_dialog_dailybonus_dummy",
        "dummy_complete",
        function ()

          int.Receive_Gold( "obj_int_dialog_dailybonus_reward"..current_day );

        end
      );

    end;

    AnimPlay(
      "anm_int_dialog_dailybonus_slot"..current_day,
      private.slot_animfuncs[ current_day ][ 2 ],
      function ()

        func_claim( current_day );

        AnimPlay(
          "anm_int_dialog_dailybonus_slot"..next_day,
          private.slot_animfuncs[ next_day ][ 1 ],
          function()

            func_dialog_hide();

          end
        );

      end
    );    

  end;
  ------------------------------------------------------------------------------

  private.Skin_Attach = func_skin_attach;
  private.Skin_Detach = func_skin_detach;

  -- JK: Setup hero
  private.hero = private.Skin_Attach( private.window );

  ObjSet( private.hero,
  {
    animfunc = "dialog",
    playing  = true,
    anim_tag = "hero" } );

  private.SetDefault( current_day, rewards );

  AnimPlay(
    private.window,
    "appear_"..private.orientation,
    function()

      AnimPlay( private.window, "static_"..private.orientation, "" );

    end
  );

  int.Dialog_Open( "dailybonus", function ()

    func_toppanel_show();

  end );

  cmn.PlaySnd( "dailybonus_dialog_open" );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  int.Dialog_Close( "dailybonus", function ()
    
    private.Cleanup();

    if ( func_OnHide ) then

      func_OnHide();

    end;

  end );

end;
--------------------------------------------------------------------------------