-- name=int_dialog_deficient
--------------------------------------------------------------------------------
function public.Init ()

  int.Center_Object( "obj_int_dialog_deficient", 0, -240 );  

  int.Button_Create(
    "btn_int_dialog_deficient_goto",
    {
      design = "medium",
      color  = "green",
      sound  = "simply_click"
    },
    function()
      
      if ( private.Accept ) then

        private.Accept();

      end;
      
    end
  );
  
  int.Button_Create(
    "btn_int_dialog_deficient_close",
    {
      design = "close",
      sound  = "simply_click",
    },
    function()
      
      private.Reject();
      
    end
  );
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    deficient_data,
    func_accept,
    func_reject,
    func_skin_attach,
    func_skin_detach,
    solution
  )

  private.Accept = func_accept;
  private.Reject = func_reject;

  private.Hero_SkinAttach = func_skin_attach;
  private.Hero_SkinDetach = func_skin_detach;

  private.SetDefault( deficient_data, solution );

  int.Dialog_Open( "deficient" );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_end )

  int.Dialog_Close( "deficient", function ()

    private.Hero_SkinDetach( private.player_skin );

    func_end();
  
  end );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.SetDefault ( deficient_data, solution )

  private.player_skin = private.Hero_SkinAttach( "obj_int_dialog_deficient_character" );
  
  AnimPlay("anm_int_dialog_deficient_message_resources", "res_"..#deficient_data, "");
  
  local objects = {};
  
  table.insert(objects, {"anm_int_dialog_deficient_message_resources", {
    count_1 = int.NumberForm(deficient_data[ 1 ].count)
  }});
  
  if( #deficient_data >= 2 ) then
    table.insert(objects, {"anm_int_dialog_deficient_message_resources", {
      count_2 = int.NumberForm(deficient_data[ 2 ].count)
  }});
  end;
  
  if( #deficient_data == 3 ) then
    table.insert(objects, {"anm_int_dialog_deficient_message_resources", {
      count_3 = int.NumberForm(deficient_data[ 3 ].count)
    }});
  end;

  for i = 1, 3 do

    table.insert( objects, { "obj_int_dialog_deficient_message_resource_"..i, { active = false, visible = false } } );

  end;

  local currency;

  for i = 1, #deficient_data do

    local name  = deficient_data[ i ].name;
    local count = deficient_data[ i ].count;

    table.insert( objects, 
    { 
      "obj_int_dialog_deficient_message_resource_"..i, { active = true, visible = true }
    } );

    if ( not name:find( "resource" ) ) then

      currency  = "item";

      local res = common.GetItemResource( "fragment", name, true );

      table.insert( objects, 
      { 
        "spr_int_dialog_deficient_message_resource_"..i.."_icon",
        {
          res     = res,
          active  = true,
          visible = true }
      } );

      table.insert( objects, { "anm_int_dialog_deficient_message_resource_"..i.."_icon",  { active = false, visible = false } } );

    else

      table.insert( objects, 
      { 
        "anm_int_dialog_deficient_message_resource_"..i.."_icon",
        {
          active   = true,
          visible  = true,
          animfunc = int.Icon_Animfunc( name ),
          playing  = true }
      } );

      table.insert( objects, { "spr_int_dialog_deficient_message_resource_"..i.."_icon", { active = false, visible = false } } );

    end;

  end;

  if ( not currency ) then

    currency = "resources";

  end;

  table.insert( objects, { "obj_int_dialog_deficient_character", { active = true, visible = true } } ); 
  table.insert( objects, { "btn_int_dialog_deficient_goto",      { active = true, visible = true, input = true } } ); 

  local caption = "str_int_dialog_deficient_caption";
  local title   = "str_int_dialog_deficient_message_title";

  if ( currency == "item" ) then

    local postfix = "_item";

    caption = caption .. postfix;
    title   = title   .. postfix;

    table.insert( objects, { "anm_int_dialog_deficient_window", 
      { speak = StringGet("str_int_dialog_deficient_message_"..currency.."_"..solution, "item") 
      } } ); 

  elseif ( currency == "resources" ) then

    table.insert( objects, { "anm_int_dialog_deficient_window", 
      { speak = StringGet("str_int_dialog_deficient_message_"..currency.."_"..solution, StringGet("str_resource_name_"..currency) ) 
    } } ); 

  end;

    table.insert( objects, { "anm_int_dialog_deficient_window", { 
      title = caption, 
      desc = title 
    } } );

  ObjMultiSet( objects );
  
  int.Button_SetText(
    "btn_int_dialog_deficient_goto",
    "str_int_dialog_deficient_goto_"..currency.."_"..solution
  );

  private.Hero_PlayAnim();

end;
--------------------------------------------------------------------------------
function private.Hero_PlayAnim ()

  AnimPlay( private.player_skin, "static", private.Hero_PlayAnim );

end;
--------------------------------------------------------------------------------