-- name=int_dialog_language
function  public.__InitModule ()

  private.orientation = int.Orientation();

  private.scc_size =
  {
    portrait  = { w = 550, h = 600 }, 
    landscape = { w = 550, h = 600 } 
  };

  private.window_area =
  {
    portrait  = { -230, -320, 460, 640 },
    landscape = { -230, -320, 460, 640 }
  };
  
end;
--------------------------------------------------------------------------------
function  public.__InitObjects ()

  int.Center_Object( "obj_int_dialog_language" );

  int_window.SetArea( "obj_int_dialog_language",
                      private.window_area[ private.orientation ] );

  int.Button_Create( "btn_int_dialog_language_close",
    {
      design = "close"
    },
    function () private.Hide(); end
  );

  local size = private.scc_size[ private.orientation ];

  ObjSet( "scc_int_dialog_language",
  {
    inputrect_init = true,
    inputrect_x   = - size.w / 2,
    inputrect_y   = - size.h / 2,
    inputrect_w   =   size.w,
    inputrect_h   =   size.h,

    croprect_init = true,
    croprect_x    = - size.w / 2,
    croprect_y    = - size.h / 2,
    croprect_w    =   size.w,
    croprect_h    =   size.h
  } );

  ObjSet( "anm_int_dialog_language_window",
  {
    animfunc = "static_"..private.orientation,
    title    = "str_int_dialog_language_title",
    tt_desc  = "str_int_dialog_language_desc"
  } );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function  public.Show ( language, list, func_select )

  private.FuncSelect = func_select;

  private.SetDefaults( language, list, func_select );

  int_window.Show( "int_dialog_language", function ()
    int.Dialog_Open( "language" );
  end ); 

end;
--------------------------------------------------------------------------------
function private.Hide ( func_after )

  func_after = func_after or function () end;

  int.Dialog_Close( "language", function ()

    int_window.Hide( "int_dialog_language", func_after );

  end );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.SetDefaults ( language, list )

  local objects = {};
  
  local slot_name = "int_dialog_language_slot";
  local anm_name  = "anm_"..slot_name;
  local spr_name  = "spr_"..slot_name; 
  
  for l = 1, #list do
    
    local postfix = "_"..list[ l ];
    
    if not ( private.created ) then
      m_object.Clone( anm_name, 
                    "scc_int_dialog_language", 
                    postfix, true );      
    end;
                 
    local animfunc = tern( language == list[ l ] )( "language_active", "language" );
    m_object.Set( anm_name..postfix, {
      tt_language = "str_int_dialog_language"..postfix,
      animfunc    = animfunc
    }, objects );
    m_object.Set( spr_name.."_flag"..postfix, {
      res = "assets/content/interface/int_dialog_options/"..list[ l ]
    }, objects );

    int.Control_EventsSet( anm_name..postfix, 
    { 
      func_on_click = function () private.FuncSelect( list[ l ] ); end 
    } );    
    
  end;
  
  ObjMultiSet( objects );
  
  private.created = true;

end;