-- name=int_dialog_map_build_market
function  public.__InitModule ()
  
  private.orientation = int.Orientation();  

  private.window_area = {
    [ "portrait"  ] = { -275, -350, 550, 600 },
    [ "landscape" ] = { -275, -300, 550, 600 }
  };
  
end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  local area = private.window_area[ private.orientation ];
  int_window.SetArea( "obj_int_dialog_map_build_market", area );
  
  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    gold_count,
    func_accept,
    func_close,
    func_top_panel_show,
    func_top_panel_hide
  )

  private.active = true;
  
  private.Accept        = func_accept;
  private.Close         = func_close; 
  private.TopPanel_Hide = func_top_panel_hide;

  int.Dialog_Open(
    "map_build_market",
    func_top_panel_show
  );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_execute )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  private.TopPanel_Hide();

  int.Dialog_Close(
    "map_build_market",
    func_execute
  );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  int.Center_Object( "obj_int_dialog_map_build_market" );

  ObjSet( "anm_int_dialog_map_build_market_window",
    {
      animfunc    = "static_" .. private.orientation,
      title       = StringGet( "str_int_dialog_map_build_market_caption" ),
      description = StringGet( "str_int_dialog_map_build_market_description" )
    }
  );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  int.Button_Create(
    "btn_int_dialog_map_build_market_close",
    {
      design = "close",
    },
    function()
      
      private.Close();
      
    end
  );
  
  int.Button_Create(
  "btn_int_dialog_map_build_market_accept",
    {
      title  = "str_int_dialog_map_build_market_accept",
      color  = "green",
      design = "medium",
    },
    function()
      
      private.Accept();
      private.Close();
      
    end
  );  

end;
--------------------------------------------------------------------------------
