-- name=int_dialog_map_changeskin
--------------------------------------------------------------------------------
function  public.__InitModule ()

  private.af =
  {
    exchange = "exchange",
    static   = "static"
  };

  if ( int.Landscape() ) then

    private.af.exchange = private.af.exchange .. "_landscape";
    private.af.static   = private.af.static   .. "_landscape";

  end;

  private.window = "anm_int_dialog_map_changeskin_window";

  private.skin_objs =
  {
    old = "obj_int_dialog_map_changeskin_skins_old",
    new = "obj_int_dialog_map_changeskin_skins_new",
    eff = "obj_int_dialog_map_changeskin_skins_eff"
  };

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  int.Center_Object( "obj_int_dialog_map_changeskin" );

  local str = "str_int_dialog_map_changeskin_";

  ObjSet( private.window, { description = StringGet( str.."description" ) } )
  
  int.Button_Create(
    "btn_int_dialog_map_changeskin_claim",
    {
      color  = "green",
      design = "medium",
      title  = str.."button"
    },
    function() private.FuncClaim(); end
  );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    old_skin,
    new_skin,
    new_skin_info,
    func_skins_attach, 
    func_skins_detach,
    func_claim
  )

  private.active          = true;
  private.FuncClaim       = func_claim;
  private.FuncSkinsDetach = func_skins_detach;

  local anm_old = func_skins_attach( private.skin_objs.old, old_skin );
  local anm_new = func_skins_attach( private.skin_objs.new, new_skin );
  local anm_eff = func_skins_attach( private.skin_objs.eff, new_skin );
  
  private.skin_anims =
  {
    old = anm_old,
    new = anm_new,
    eff = anm_eff
  };

  local title = StringGet( "str_skins_"..new_skin_info.name );

  ObjMultiSet( 
  {
    { private.window, { title = title } },
    { anm_old, { animfunc = "disappear", frame = 0, playing = false } },
    { anm_new, { animfunc = "appear",    frame = 0, playing = false } },
    { anm_eff, { animfunc = "appear_fx", frame = 0, playing = false } }
  } );

  int.Dialog_Open( "map_changeskin", private.Animate );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_close )

  if ( not private.active ) then return; end;

  private.active = false;

  int.Dialog_Close( "map_changeskin", function ()

    private.FuncSkinsDetach( private.skin_anims.old );
    private.FuncSkinsDetach( private.skin_anims.new );
    private.FuncSkinsDetach( private.skin_anims.eff );
    private.skin_anims = nil;

    if ( func_close ) then func_close(); end;

  end );

end;
--------------------------------------------------------------------------------
function private.Animate ()

  local anm = private.skin_anims;
  local af  = private.af;

  int.Lock( false ); -- HACK: unlock after v_map Reward_Show

  cmn.PlaySnd("get_new_skin");
  
  AnimPlay( "anm_int_dialog_map_changeskin_dummy", "dummy",
  function ()

    AnimPlay( anm.old, "disappear", "" );
    AnimPlay( anm.new, "appear",
    function ()
      AnimPlay( anm.new, "static", "" );
    end );
    
    AnimPlay( anm.eff, "appear_fx", "" );
    AnimStop( "anm_int_dialog_map_changeskin_dummy" );

  end );

  AnimPlay( private.window, af.exchange,
  function ()
    AnimPlay( private.window, af.static, "" );
  end );

end;
--------------------------------------------------------------------------------