-- name=int_dialog_map_chest
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  private.Adapt();
  private.CreateButtons();

  private.strings = {
    title_booster = ne.strings.Get( "str_int_dialog_map_chest_caption_booster" ),
    title_gold    = ne.strings.Get( "str_int_dialog_map_chest_caption_gold" )
  };

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show ( chest_name, chest_content, func_open, func_close )

  if ( private.active ) then

    return;

  end;

  private.active = true;

  private.Close = func_close;

  private.SetDefault( chest_content );

  int.Dialog_Open( "map_chest", func_open );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_preclose, func_close )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  if ( func_preclose ) then

    func_preclose();

  end;

  int.Dialog_Close( "map_chest", function()

    if ( func_close ) then

      func_close();

    end;

  end );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  private.this = "obj_int_dialog_map_chest";

  int.Center_Object( private.this );

end;
--------------------------------------------------------------------------------
function private.CreateButtons ()

  int.Button_Create(
    "btn_int_dialog_map_chest_accept",
    {
      title  = "str_int_dialog_map_chest_accept",
      design = "medium",
      color  = "green",
      sound  = "simply_click"
    },
    function()
      
      private.Close();
      
    end
  );
  
  int.Button_Create(
    "btn_int_dialog_map_chest_close",
    {
      design = "close"
    },
    function()
      
      private.Close();
      
    end
  );

  common.TapSet( "obj_int_dialog_map_chest_content",
  {
    func_true = function ()

      private.Close();

    end
  } );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( chest_content )

  local multiset = {};

  m_object.Set(
    "spr_int_dialog_map_chest_content_icon",
    {
      res = "assets/content/boosters/"..chest_content.name
    },
    multiset
  );

  if ( chest_content.type == "booster" ) then
    
    m_object.Set(
      "anm_int_dialog_map_chest_window",
      {
        title         = private.strings.title_booster,
        reward_title  = StringGet( "str_item_"..chest_content.name.."_caption" ),
        reward_count  = "x"..chest_content.count,
        reward_desc   = StringGet( "str_item_"..chest_content.name.."_description" )
      },
      multiset
    );

  end;

  if ( chest_content.type == "gold" ) then

    m_object.Set(
      "anm_int_dialog_map_chest_window",
      {
        title        = private.strings.title_gold,
        reward_title = StringGet( "str_item_gold_caption" ),
        reward_count = "x"..chest_content.count,
        reward_desc  = StringGet( "str_item_gold_description" )
      },
      multiset
    );

  end;

  m_object.Multiset( multiset );

end;
--------------------------------------------------------------------------------