-- name=int_dialog_notifications
--------------------------------------------------------------------------------
function public.Init ()
  
  int_control.Add( "int_dialog_notifications" );
 
  private.Adapt();
  private.CreateButtons();

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  local app_w = int.W();
  local app_h = int.H();
  
  ObjMultiSet( {
    { "obj_int_dialog_notifications", {
      pos_x = app_w / 2,
      pos_y = app_h / 2
    } },
    { "spr_int_dialog_notifications_bg_black", {
      scale_x = app_w / 64,
      scale_y = app_h / 64,
    } },
    { "anm_int_dialog_notifications", {
      title       = ne.strings.Get( "str_int_dialog_notifications_title" ),
      reward_desc = ne.strings.Get( "str_int_dialog_notifications_desc" )
    } },
    { "anm_int_dialog_notifications_popup", {
      tt_message = ne.strings.Get( "str_int_dialog_notifications_popup" )
    } }
  } );

  
end;
--------------------------------------------------------------------------------
function private.CreateButtons ()
  
  int.Button_Create(
    "btn_int_dialog_notifications_close",
    {
      design = "close"
    },
    function() end
  );
  
  int.Button_Create(
    "btn_int_dialog_notifications_ok",
    {
      design = "medium",
      color  = "green",
      title  = "str_int_dialog_notifications_ok"
    },
    function() end
  );
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show ( reward, ok_handler, close_handler )
  
  int_control.Attach( "int_dialog_notifications" );
  
  ObjSet( "obj_int_dialog_notifications", { input = true, visible = true } ); 
  
  ObjSet( "anm_int_dialog_notifications",
          { reward_count = int.NumberForm( reward ) } );
  
  int.Button_EventSet( "btn_int_dialog_notifications_ok",
    function()
       ok_handler();
       close_handler();
    end );
  
  int.Button_EventSet( "btn_int_dialog_notifications_close", close_handler );
  
end;
--------------------------------------------------------------------------------
function public.Hide ( func_after )
  
  int_control.Detach( "int_dialog_notifications" );
  
  ObjSet( "obj_int_dialog_notifications", { input = false, visible = false } );
  
  if ( func_after ) then func_after(); end;

end;
--------------------------------------------------------------------------------