-- name=int_dialog_stage_shuffle
--------------------------------------------------------------------------------
function public.__InitObjects ()

  int_control.Add( "int_dialog_stage_shuffle" );

  private.SetPanelForm();

end;
--------------------------------------------------------------------------------
function public.Show ( x, y, func_effect )

  int_control.Attach( "int_dialog_stage_shuffle" );
  
  local y_beg = -y;
  local y_end =  y;
  
  ObjSet( "obj_int_dialog_stage_shuffle",
  {
    pos_x = x,
    pos_y = y_beg
  } );

  local func_end = function()

    ObjSet( "obj_int_dialog_stage_shuffle",
    {
      input       = true,
      event_mdown = private.Hide
    } );

    if ( func_effect ) then

      func_effect();

    end;

  end;

  local animtime = 0.3;
  local tme = 0.8;

  ObjAnimate( "obj_int_dialog_stage_shuffle", "pos_y", 0, 0, private.Hide,
  {
    ( 0     * animtime ), 2, y_beg,
    ( tme   * animtime ), 2, y_end + 30,
    ( tme*2 * animtime ), 3, y_end,
    ( tme*6 * animtime ), 3, y_end,
    ( tme*7 * animtime ), 3, y_end + 30,
    ( tme*8 * animtime ), 1, y_beg
  } );

  ObjAnimate( "obj_int_dialog_stage_shuffle", "alp", 0, 0, func_end,
  {
    ( 0     * animtime ), 2, 1,
    ( tme   * animtime ), 2, 1,
    ( tme*2 * animtime ), 2, 1,
  } );

  ObjAnimate( "obj_int_dialog_stage_shuffle", "scale_x", 0, 0, 
    function()

     cmn.PlaySnd( "stripemenu_outside" );

    end,
    {
      ( 0     * animtime ), 0, 1,
      ( tme*6 * animtime ), 0, 1
    } );

  cmn.PlaySnd( "stripemenu_inside" );

end;
--------------------------------------------------------------------------------
function private.Hide ()

  ObjStopAnimate( "obj_int_dialog_stage_shuffle", "pos_y" );
  ObjStopAnimate( "obj_int_dialog_stage_shuffle", "scale_x" );

  ObjSet( "obj_int_dialog_stage_shuffle", { input = false } );

  int_control.Detach( "int_dialog_stage_shuffle" );

end;
--------------------------------------------------------------------------------
function private.SetPanelForm ()

  local screen_w = int.W();
  local screen_h = int.H();

  ObjSet( "obj_int_dialog_stage_shuffle",
  {
    pos_x = 0.5 * screen_w,
    pos_y = - 0.5 * screen_h
  } );

end;
--------------------------------------------------------------------------------