-- name=int_dialog_stage_targets
--------------------------------------------------------------------------------
function public.__InitObjects ()

  private.SetPanelForm();

end;
--------------------------------------------------------------------------------
function public.Show ( state, targets, enemy_name, section, func_close )

  if ( private.active ) then

    return;

  end;

  private.Close       = func_close;
  private.active      = true;
  private.targets_num = #targets;
  
  if ( private.targets_num < 1 ) then private.targets_num = 1; end;
  
  private.SetDefault( state, targets, enemy_name, section );

  ObjSet( "obj_int_dialog_stage_targets", { active = true, input = false, visible = true } );

  local func_end = function ()

    ObjSet( "obj_int_dialog_stage_targets", { input = true } );

    ObjAnimate( "obj_int_dialog_stage_targets", "alp", 0, 0, 
    function () 
      
      local func_tap = common.TapGet( "obj_int_dialog_stage_targets" ).func_true;

      if ( func_tap ) then

        func_tap();

      end;

    end, 
    { 
      0.0, 0, 1, 
      2.0, 0, 1 
    } );

  end;

  AnimPlay( "anm_int_dialog_stage_targets", "show_"..private.targets_num, func_end );  

end;
--------------------------------------------------------------------------------
function private.Hide ( func_execute )

  if not ( private.active ) then

    return;

  end;

  private.active = false;

  ObjSet( "obj_int_dialog_stage_targets", { input = false } );

  local func_end = function ()

    ObjSet( "obj_int_dialog_stage_targets", { active = false, visible = false } );

    if ( func_execute ) then

      func_execute();  

    end;

  end

  AnimPlay( "anm_int_dialog_stage_targets", "hide_"..private.targets_num, func_end );  

end;
--------------------------------------------------------------------------------
function private.SetPanelForm ()

  local screen_w = GetAppWidth();
  local screen_h = GetAppHeight();

  ObjSet( "obj_int_dialog_stage_targets",
  {
    pos_x = 0.5 * screen_w,
    pos_y = 0.5 * screen_h,
    inputrect_w = screen_w,
    inputrect_h = screen_h,
    inputrect_x = - 0.5 * screen_w,
    inputrect_y = - 0.5 * screen_h
  } );

end;
--------------------------------------------------------------------------------
function private.SetDefault ( state, targets, enemy_name, section )

  ObjStopAnimate( "obj_int_dialog_stage_targets", "alp" );

  AnimStop( "anm_int_dialog_stage_targets" );

  common.TapSet( "obj_int_dialog_stage_targets",
  {
    func_true = function ()

      private.Hide( private.Close );

      cmn.PlaySnd( "button_click" );

    end
  } );

  local multiset_table = {};

  for i = 1, 3 do

    table.insert( multiset_table,
    {
      "obj_int_dialog_stage_targets_"..i,
      {
        active  = false,
        visible = false 
      }
    } );

  end;

  if ( enemy_name ) then

    table.insert( multiset_table,
    { "obj_int_dialog_stage_targets_1", { active = true, visible = true } } );
    
    table.insert( multiset_table,
    { "txt_int_dialog_stage_targets_1_message",
      {
        text = "str_int_dialog_stage_targets_killenemy",
        param0 = StringGet( "str_enemy_name_"..enemy_name )
      }
    } );

    table.insert( multiset_table,
    { "anm_int_dialog_stage_targets",
      {
        state    = StringGet( "str_int_dialog_stage_targets_defeat_enemy" ),
        multiply = ""
      }
    } );

    ObjMultiSet( multiset_table );

    return;

  end;

  for i = 1, #targets do

    table.insert( multiset_table, { "obj_int_dialog_stage_targets_"..i, { active = true, visible = true } } );

    table.insert( multiset_table, { "txt_int_dialog_stage_targets_"..i.."_message", { text = "str_int_dialog_stage_targets_"..string.lower( targets[ i ].type ), param0 = int.NumberForm( targets[ i ].count, true ) } } );

    if ( targets[ i ].type ~= "GainScore" ) then
      
      if ( targets[ i ].type == "DropItem" ) then
        
        local section_number = string.match( section, "%d+" );

        table.insert( multiset_table, { "spr_int_dialog_stage_targets_"..i.."_icon", { res = "assets/content/"..section.."/icon_key_"..section_number } } );

      else
        
        table.insert( multiset_table, { "spr_int_dialog_stage_targets_"..i.."_icon", { res = "assets/content/items/icon_"..string.lower( targets[ i ].name ) } } );
      
      end;  
        
      if ( targets[ i ].type == "DestroyCell" ) or
         ( targets[ i ].type == "DestroyGem"  ) then

        table.insert( multiset_table, { "txt_int_dialog_stage_targets_"..i.."_message", { text = "str_int_dialog_stage_targets_"..string.lower( targets[ i ].type ).."_"..string.lower( targets[ i ].name ), param0 = int.NumberForm( targets[ i ].count, true ) } } );
      
      end;
      
    end;  

  end;

  ObjMultiSet( multiset_table );

  multiset_table = {};

  for i = 1, #targets do

    local scale = ObjGet( "txt_int_dialog_stage_targets_"..i.."_message" ).scale_x;

    table.insert( multiset_table, { "txt_int_dialog_stage_targets_"..i.."_message", { scale_y = scale } } );

  end;

  local str_multiply = "";
  if ( state > 1 ) then
    str_multiply = StringGet( "str_int_dialog_stage_targets_multiply_"..state );
  end;

  table.insert( multiset_table,
  { "anm_int_dialog_stage_targets",
    {
      state    = StringGet( "str_int_dialog_stage_targets_state", state ),
      multiply = str_multiply
    }
  } );

  ObjMultiSet( multiset_table );

end;
--------------------------------------------------------------------------------