-- name=int_dialog_stage_win
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  int.Button_Create(
    "btn_int_dialog_stage_win_next",
    {
      title  = "str_dialog_stage_win_next",
      color  = "green",
      design = "medium",
      sound  = "simply_click",
    },
    function()
      
      private.FuncAccept();
      
    end
  );
  
  ObjSet( "anm_int_dialog_stage_win_window", 
  { title = StringGet( "str_dialog_stage_win_caption" ) } );

  int.Center_Object( "obj_int_dialog_stage_win" );

end;
--------------------------------------------------------------------------------
function public.Show (
  stage_name,
  stage_type,
  stage_score,
  func_skin_attach,
  func_skin_detach,
  func_accept,
  social_panel
  )

  private.FuncAccept     = func_accept;
  private.FuncSkinAttach = func_skin_attach;
  private.FuncSkinDetach = func_skin_detach;

  private.SetDefault();
      
  private.hero_anm_name = private.FuncSkinAttach(
    "obj_int_dialog_stage_win_hero"
  );
  
  ObjMultiSet( {
    { "anm_int_dialog_stage_win_window_content",
      {
        score_title = tern( stage_type == "ride" )( 
          "str_dialog_stage_win_score", 
          "str_dialog_stage_win_fight"
        ),
        score_count = tern( stage_type == "ride" )( 
          function () return int.NumberForm( stage_score, true ); end,
          function () 
            return StringGet( "str_dialog_stage_win_moves", 
                              int.NumberForm( stage_score, true ) );
          end 
        )()
      }
    }
  } );

  private.SetPanelForm( social_panel );
  
  int.Dialog_Open( "stage_win", function ()
    cmn.PlaySnd( "win_stage" );
  end );
  
  local rnd;
  tmr_func = function()
    
    ObjSet( "tmr_int_dialog_stage_win_snd", { time = 4, playing = true, endtrig = function ()
      
      rnd = math.random( 1, 2 );
      cmn.PlaySnd( "win_stage_"..rnd );
      
      tmr_func();
    
    end});
  
  end;
  
  AnimPlay( "anm_int_dialog_stage_win_window", "appear_portrait", function ()
    
    rnd = math.random( 1, 2 );
    cmn.PlaySnd( "win_stage_"..rnd );
    
    AnimPlay( "anm_int_dialog_stage_win_window", "static_portrait_start", function ()
      
      rnd = math.random( 1, 2 );
      cmn.PlaySnd( "win_stage_"..rnd );
      
      tmr_func();
      
      AnimPlay( "anm_int_dialog_stage_win_window", "static_portrait", "" );
      
    end);
  end);

end;
--------------------------------------------------------------------------------
function public.Hide ( func_close )
  
  AnimPlay("anm_int_dialog_stage_win_window", "disappear_portrait", "");
  
  int.Dialog_Close( "stage_win", function ()
    
    private.FuncSkinDetach( private.hero_anm_name );
    private.hero_anm_name = nil;
    
    ObjSet( "tmr_int_dialog_stage_win_snd", { time = 0, playing = false});
              
    int_window.Hide( "int_dialog_stage_win", function () 
      
      if ( func_close ) then
        func_close();
      end;
      
    end);
    
  end);

end;
--------------------------------------------------------------------------------
function public.ShowHero ( stage_type )
  
  if ( "ride" == stage_type ) then

    ObjSet( private.hero_anm_name, { 
      res      = "assets/content/hero/anm_hero_ride",
      animfunc = "win_cycle",
      playing  = true
    } );

  else

    ObjSet( private.hero_anm_name, { 
      res      = "assets/content/hero/anm_hero_fight",
      animfunc = "win",
      playing  = true
    } );

  end;

  --AnimPlay( private.hero_anm_name, "hero_appear", "" );

end;
--------------------------------------------------------------------------------
function private.SetDefault ()

  --ObjAnimate( "btn_int_dialog_stage_win_next", "scale_xy", 1, 0, "",
  --{ 
    --0.0, 3, 1.00, 1.00,
    --1.0, 3, 1.08, 1.08,
    --2.0, 3, 1.00, 1.00
  --} );

end;
--------------------------------------------------------------------------------
function private.SetPanelForm ( social_panel )

  local screen_w = GetAppWidth();
  local screen_h = GetAppHeight();

  if ( social_panel ) then

    ObjMultiSet( {      
      { "obj_int_dialog_stage_win",
        {
          pos_x = screen_w/2,
          pos_y = screen_h / 2 - 60
        }
      }
    } );

  else

    ObjMultiSet( {      
      { "obj_int_dialog_stage_win",
        {
          pos_x = screen_w/2,
          pos_y = screen_h / 2
        }
      }
    } );

  end;

end;
--------------------------------------------------------------------------------