-- name=int_dialog_story
--------------------------------------------------------------------------------
function public.__InitObjects ()

  int_window.RegisterAsFullscreen( "int_dialog_story" );
  
  private.Adapt();

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Adapt ()

  private.app_w = int.W();
  private.app_h = int.H();

  int.Center_Object( "obj_int_dialog_story" );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show ( story_data, func_close )

  private.Close = func_close;

  local objects = {};

  table.insert( objects, { "obj_int_dialog_story",
  {
    active  = true,
    visible = true,
    input   = false } } );
    
  table.insert( objects, 
    { "anm_int_dialog_story_movie", { res = story_data.res } }
  );

  ObjMultiSet( objects );

  private.active = true;

  local orientation = int.Orientation();
  local anim_object = "anm_int_dialog_story";
  local movie_name  = "anm_int_dialog_story_movie";
  local movie_func  = "action_"..orientation;
  
  local func_end_anim = function ()

    ObjSet( "obj_int_dialog_story", { input = true } );

    AnimPlay( anim_object, "static_medium", "" );

    AnimPlay( movie_name, movie_func, function ()

      cmn.StopMusic( story_data.aud );
      cmn.StopSnd( story_data.aud );

      func_close();

    end );

    cmn.StopMusic( "fight" );
    cmn.PlayMusic( story_data.aud );
    cmn.PlaySnd( story_data.aud );
  
  end;

  AnimPlay( anim_object, "open_medium", func_end_anim );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_OnHide )

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  ObjSet( "obj_int_dialog_story", { input = false } );

  local anim_object = "anm_int_dialog_story";

  local func_end_anim = function ()

    ObjSet( "obj_int_dialog_story", { visible = false, active = false } );

    if ( func_OnHide ) then

      func_OnHide();

    end;

  end;

  AnimPlay( anim_object, "close_medium", func_end_anim );

end;
--------------------------------------------------------------------------------