-- name=int_dialog_update
--------------------------------------------------------------------------------
function public.Init ()

  private.this = {
    dialog = "int_dialog_update",
    window = "anm_int_dialog_update",
    button = "btn_int_dialog_update_get"
  };
  
  private.strings = {
    reward = "str_dialog_update_reward_message",
    replay = "str_dialog_update_replay_message"
  }
  
  int.Center_Object( "obj_int_dialog_update" );

  int.Button_Create(
    private.this.button,
    {
      color  = "green",
      design = "medium",
      sound  = "ok_info"
    },
    function()
      
      private.Hide();
     
    end
  );

  m_object.Set(
    "anm_int_dialog_update",
    {
      title = ne.strings.Get( "str_dialog_update_caption" )
    }
  );
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show (
    dialog_type,
    message,
    func_skin_attach,
    func_skin_detach,
    func_obtain
  )

  local multiset = {};
  
  private.Hero_SkinAttach = func_skin_attach;
  private.Hero_SkinDetach = func_skin_detach;
  private.Obtain          = func_obtain;

  local animfunc = {
    reward = "static",
    replay = "static_replay"
  };
  
  int.Button_SetText(
    private.this.button,
    "str_dialog_update_"..dialog_type.."_button",
    multiset
  );
  
  m_object.Set(
    private.this.window,
    {
      animfunc       = animfunc[ dialog_type ],
      playing        = true,
      tt_description = private.strings [ dialog_type ],
    },
    multiset
  );
  
  m_object.Multiset( multiset );
  
  if ( private.Hero_SkinAttach ) then
  
    private.skin = private.Hero_SkinAttach( "obj_int_dialog_update_character" );
    
    AnimPlay(
      private.skin,
      "skinview_fun1", -- FIXME: need animfunc?
      function ()
        
        AnimPlay( private.skin, "dialog", "" );
        
      end
    );
    
  end;

  int_window.Show( private.this.dialog );

  cmn.PlaySnd( "app_info" );

end;
--------------------------------------------------------------------------------
function private.Hide ()

  int_window.Hide( private.this.dialog );
  
  if ( private.Hero_SkinDetach ) then
  
    private.Hero_SkinDetach( private.skin );
  
  end;

  if ( private.Obtain ) then

    private.Obtain();
 
  end;

end;
--------------------------------------------------------------------------------