-- name=int_hero
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.skin_parts = {
  
    fight = {
      "sword",
      "palm_r",
      "arm_r",
      "shoulder_r",
      "helm_ft",
      "head",
      "helm_bk",
      "feather",
      "foot_r",
      "leg_r",
      "body",
      "palm_l",
      "shoulder_l",
      "foot_l",
      "leg_l",
      "arm_r_fun",
      "belt",
      "nose"
      },
      
    ride ={
      "sword",
      "palm_r",
      "arm_r",
      "shoulder_r",
      "helm_ft",
      "head",
      "helm_bk",
      "feather",
      "leg_r",
      "body",
      "palm_l",
      "shoulder_l",
      "leg_l",
      "foot2_r",
      "foot2_l",
      "foot3_r",
      "foot3_l",
      "palm2_l",
      "palm3_l",
      "palm_l_fun",
      "arm_r_fun",
      "belt",
      "nose"
    },
    
    nextskinview ={
      "sword",
      "palm_r",
      "arm_r",
      "shoulder_r",
      "helm_ft",
      "head",
      "helm_bk",
      "leg_r",
      "body",
      "palm_l",
      "shoulder_l",
      "leg_l",
      "foot2_r",
      "foot2_l",
      "foot3_r",
      "foot3_l",
      "palm2_l",
      "palm3_l",
      "palm_l_fun",
      "arm_r_fun",
      "belt",
      "nose"
    }  
  };

end;
--------------------------------------------------------------------------------
-- function ... ()
--------------------------------------------------------------------------------
function public.Skin_Attach ( destination, skin_type, skin_name, skin_content )
  
  skin_type = tern( private.skin_parts[ skin_type ] )( skin_type, "ride" );

  local multiset = {};
  local postfix  = "_"..destination;
  local source   = "anm_int_hero_"..skin_type;
  local skin_res = "assets/content/"..skin_content.."/anm_skin_"..skin_name;
  
  m_object.Clone(
    source,
    destination,
    postfix,
    1
  );

  local dest_name = string.sub( destination, 5 );
  local anm_name  = "anm_"..dest_name.."_hero";

  m_object.Set(
    source..postfix,
    {
      name = anm_name
    },
    multiset
  );

  for p, part_name in pairs( private.skin_parts[ skin_type ] ) do

    m_object.Set(
      source.."_"..part_name..postfix,
      {
        name     = anm_name.."_"..part_name,
        res      = skin_res, 
        animfunc = part_name, 
        playing  = true
      },
      multiset
    );
    
  end;

  m_object.Multiset( multiset );

  return anm_name;

end;
--------------------------------------------------------------------------------
function public.Skin_Detach ( anm_name )

  m_object.Delete( anm_name );

end;
--------------------------------------------------------------------------------