-- name=int_panel_map_achievement
--------------------------------------------------------------------------------
function public.__InitObjects ()
  
  common.TapSet( "anm_int_panel_map_achievement",
  {
    func_true = function ()
    
    ObjSet( "anm_int_panel_map_achievement", { input = false } );
      
    AnimPlay( "anm_int_panel_map_achievement", "close", function ()
   
      private.Hide( function ()
      
        private.OnHide();
        private.ShowAchievents();
        
      end );

      cmn.PlaySnd( "button_click" );
    
    end ); 
    
  end
  } );

end;
--------------------------------------------------------------------------------
function public.Show ( parent_name, achievement_level, func_on_close, func_achievements )
  
  if ( private.active ) then

    return;

  end;

  private.OnHide         = func_on_close;
  private.ShowAchievents = func_achievements;

  private.active = true;
  
  ObjAttach( "int_panel_map_achievement", parent_name );
  
  private.SetDefault( achievement_level );

  ObjSet( "obj_int_panel_map_achievement", 
    { active = true, input = true, visible = true, 
      pos_y = ( - 0.5 * ObjGet( parent_name ).inputrect_h or - 50 ) } );

  local func_end = function ()

    ObjSet( "anm_int_panel_map_achievement", { input = true } );
    
  end;

  AnimPlay( "anm_int_panel_map_achievement", "appear", function ()

    private.Hide( private.OnHide );

  end );
  
  ObjAnimate( "anm_int_panel_map_achievement", "alp", 0, 0, func_end, 
  {
    0.0, 0, 1,
    0.3, 0, 1
  } );
  
  cmn.PlaySnd( "achievement_popup_show" );

end;
--------------------------------------------------------------------------------
function public.Hide ( func_execute )
  
  private.Hide( func_execute, true );
  
end;
--------------------------------------------------------------------------------
function private.Hide ( func_execute, instant )

  if not ( private.active ) then

    return;

  end;

  private.active = false;

  if ( instant ) then
    
    ObjSet( "anm_int_panel_map_achievement", { 
      animfunc = "appear",
      frame    = 0,
      playing  = false
    } );
    
  end;
  
  ObjSet( "obj_int_panel_map_achievement", { input = false } );

  local func_end = function ()

    ObjSet( "obj_int_panel_map_achievement", { active = false, visible = false } );
    
    ObjDetach( "int_panel_map_achievement" );

    if ( func_execute ) then

      func_execute();  

    end;

  end;

  func_end();

end;
--------------------------------------------------------------------------------
function private.SetDefault ( achievement_level )

  AnimStop( "anm_int_panel_map_achievement" );

  local multiset_table = {};

  table.insert( multiset_table, { "spr_int_panel_map_achievement_cup", 
  { 
    res = "assets/content/items/achievement_"..achievement_level
  } } );
  
  table.insert( multiset_table, { "anm_int_panel_map_achievement", 
  { 
    res = "assets/content/interface/int_dialog_top/anim/anm_int_panel_map_achievement",
    completed = StringGet( "str_int_panel_map_achievement_completed" ) 
  } } );
  
  ObjMultiSet( multiset_table );

end;
--------------------------------------------------------------------------------