-- name=int_popup_stage_score
--------------------------------------------------------------------------------
function public.__InitModule ()

  private.this = {
    int = "int_popup_stage_score"
  };

  private.score_offset = 30;

end;
--------------------------------------------------------------------------------
function public.__InitObjects ()

  int_control.Add( private.this.int );

  -- JK: Generating 32 labels
  private.labels = {};

  for i = 1, 32 do

    private.Label_GenerateNew();

  end;
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show ( pos_x, pos_y, color, value )

  local popup_number = private.Label_GetFreeNumber();
  local popup_name   = private.labels[ popup_number ].name;

  private.labels[ popup_number ].free = false;

  local function func_end ()
  
    private.labels[ popup_number ].free = true;

    m_object.Disable( popup_name, true );

  end;
  
  m_object.Set(
    popup_name,
    {
      animfunc = "score",
      tt_score = int.NumberForm( value, true ),
      playing  = true,
      frame    = 0,
      active   = true,
      visible  = true,
      pos_x    = pos_x + private.score_offset,
      pos_y    = pos_y - private.score_offset,
      color_r  = color.r,
      color_g  = color.g,
      color_b  = color.b,
      endtrig  = func_end
    }
  );

end;
--------------------------------------------------------------------------------
function public.Attach ()

  int_control.Attach( private.this.int );

end;
--------------------------------------------------------------------------------
function public.Detach ()

  int_control.Detach( private.this.int );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Label_GenerateNew ()
  
  local index = #private.labels + 1;

  m_object.Clone(
    "anm_int_popup_stage_score",
    "obj_int_popup_stage_score",
    "_"..index
  );

  table.insert(
    private.labels,
    {
      name = "anm_int_popup_stage_score_"..index,
      free = true
    }
  );
  
end;
--------------------------------------------------------------------------------
function private.Label_GetFreeNumber ()
  
  for p, popup in pairs( private.labels ) do
    
    if ( popup.free ) then
      
      return p;
      
    end;
    
  end;
  
  private.Label_GenerateNew();

  return #private.labels;
  
end;
--------------------------------------------------------------------------------