-- name=int_subtitles
--********************************************************************************************************************
--********************************************************************************************************************
function public.Init ()

  int_control.Add( "int_subtitles" );

  private.anim_time = 0.3;

  private.app_w = GetAppWidth();
  private.app_h = GetAppHeight();

  local app_w = private.app_w;
  local app_h = private.app_h;

  ObjMultiSet( {
    { "int_subtitles", { pos_x = 0.5 * app_w, pos_y = 0.5 * app_h } },
    { "grd_int_subtitles_bg_top", { pos_y = - 0.5 * app_h + 80 } },
    { "grd_int_subtitles_bg_bot", { pos_y =   0.5 * app_h - 80 } },
    { "obj_int_subtitles_text",   { pos_y =   0.5 * app_h - 50 } },
    { "obj_int_subtitles_skip",   { pos_y = - 0.5 * app_h + 50, pos_x = 0.5 * app_w - 90 } },
  } );

  common.TapSet( "obj_int_subtitles_skip", 
  {
    func_true = function ()

      private.Skip_AnimateClose( function () 

        private.Skip( function ()
        
          private.Skip_AnimateOpen( private.FuncAfter )
          
        end );

      end );  

    end;
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function public.Show ( subtitles_name, time_table, func_skip, func_after )

  private.Skip      = func_skip;
  private.FuncAfter = func_after;

  int_control.Attach( "int_subtitles" );

  ObjSet( "obj_int_subtitles", { active = true, visible = true, alp = 0 } );

  private.SetDefaults( subtitles_name, time_table );

  private.active = true;

  local tme = private.anim_time;

  local func_end = function ()
  
    private.Timer();

  end;

  ObjSet( "txt_int_subtitles_skip", { text = "str_subtitle_skip" } );

  ObjAnimate( "obj_int_subtitles", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0.0, 
    tme, 0, 1.0 
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Hide ( func_close )

  private.active = false;

  local tme = private.anim_time;

  local func_end = function ()
  
    int_control.Detach( "int_subtitles" );

    if ( func_close ) then

      func_close();

    end;

  end;

  ObjAnimate( "obj_int_subtitles", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1.0, 
    tme, 0, 0.0 
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Subtitle_ShowNext ()

  local tme = private.anim_time;

  local func_end = function ()
  
    ObjAnimate( "obj_int_subtitles_text", "alp", 0, 0, function ()

      if ( private.current == #private.time + 1 ) then

        private.Hide();

      end;

    end, 
    { 
      0.0, 0, 1.0, 
      tme, 0, 0.0 
    } );

  end;

  ObjMultiSet( {
    { "txt_int_subtitles", { text = "str_subtitle_"..private.subtitles.."_"..private.current } }
  } );
  
  int.Text_FontsizeByHeight( "txt_int_subtitles", 80, 26 );

  ObjAnimate( "obj_int_subtitles_text", "alp", 0, 0, func_end, 
  { 
    0.0,       0, 0.0, 
    tme,       0, 1.0,
    tme + 2.5, 0, 1.0 
  } );

  private.current = private.current + 1;

  private.Timer();

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Timer ()

  if ( private.current < #private.time + 1 ) then
  
    local time = ( private.time[ private.current ] - ( private.time[ private.current - 1 ] or 0 ) );

    ObjMultiSet( {
      { "tmr_int_subtitles", { time = time, playing = true, endtrig = private.Subtitle_ShowNext } }
    } );

  end;

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Skip_AnimateClose ( func_skip )

  GridPlay( "grd_int_subtitles_bg_top", func_skip );
  GridPlay( "grd_int_subtitles_bg_bot", "" );

  local tme = private.anim_time;

  ObjMultiSet( {
    { "tmr_int_subtitles", { time = 0, playing = false, endtrig = function () end } },
    { "obj_int_subtitles_skip", { input = false, active = false, visible = false } }
  } );

  ObjAnimate( "obj_int_subtitles_text", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "obj_int_subtitles_text" ).alp, 
    tme, 0, 0.0
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.Skip_AnimateOpen ( func_end )

  local app_w = private.app_w;
  local app_h = private.app_h;
  
  local frame_1 = {
     8, { pos_y = 0 },
     9, { pos_y = 0 },
    10, { pos_y = 0 },
    11, { pos_y = 0 },

    12, { pos_y = 22 },
    13, { pos_y = 22 },
    14, { pos_y = 22 },
    15, { pos_y = 22 }
  };
  
  local frame_0 = {
     8, { pos_y = 0.5 * app_h },
     9, { pos_y = 0.5 * app_h },
    10, { pos_y = 0.5 * app_h },
    11, { pos_y = 0.5 * app_h },

    12, { pos_y = 0.5 * app_h + 22 },
    13, { pos_y = 0.5 * app_h + 22 },
    14, { pos_y = 0.5 * app_h + 22 },
    15, { pos_y = 0.5 * app_h + 22 }
  };

  GridSet( "grd_int_subtitles_bg_top", 0, frame_0 );
  GridSet( "grd_int_subtitles_bg_bot", 0, frame_0 );

  GridSet( "grd_int_subtitles_bg_top", 1, frame_1 );
  GridSet( "grd_int_subtitles_bg_bot", 1, frame_1 );

  GridPlay( "grd_int_subtitles_bg_top", function () private.Hide( func_end ); end );
  GridPlay( "grd_int_subtitles_bg_bot", "" );

end;
--********************************************************************************************************************
--********************************************************************************************************************
function private.SetDefaults ( subtitles_name, time_table )

  private.current = 1;

  private.time = time_table;
  
  private.subtitles = subtitles_name;

  local app_w = private.app_w;
  local app_h = private.app_h;

  local frame_0 = {
     0, { pos_x = - ( 0.5 * app_w + 22 ) },
     1, { pos_x = - ( 0.5 * app_w +  0 ) },
     2, { pos_x =   ( 0.5 * app_w + 22 ) },
     3, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     4, { pos_x = - ( 0.5 * app_w + 22 ) },
     5, { pos_x = - ( 0.5 * app_w +  0 ) },
     6, { pos_x =   ( 0.5 * app_w + 22 ) },
     7, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     8, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0 },
     9, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0 },
    10, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0 },
    11, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0 },

    12, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 22 },
    13, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 22 },
    14, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 22 },
    15, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 22 }
  };
  
  local frame_1 = {
     0, { pos_x = - ( 0.5 * app_w + 22 ) },
     1, { pos_x = - ( 0.5 * app_w +  0 ) },
     2, { pos_x =   ( 0.5 * app_w + 22 ) },
     3, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     4, { pos_x = - ( 0.5 * app_w + 22 ) },
     5, { pos_x = - ( 0.5 * app_w +  0 ) },
     6, { pos_x =   ( 0.5 * app_w + 22 ) },
     7, { pos_x =   ( 0.5 * app_w +  0 ) },
  
     8, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h },
     9, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h },
    10, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h },
    11, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h },

    12, { pos_x = - ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h + 22 },
    13, { pos_x = - ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h + 22 },
    14, { pos_x =   ( 0.5 * app_w + 22 ), pos_y = 0.5 * app_h + 22 },
    15, { pos_x =   ( 0.5 * app_w +  0 ), pos_y = 0.5 * app_h + 22 }
  };  
  
  GridSet( "grd_int_subtitles_bg_top", 0, frame_0 );
  GridSet( "grd_int_subtitles_bg_bot", 0, frame_0 );

  GridSet( "grd_int_subtitles_bg_top", 1, frame_1 );
  GridSet( "grd_int_subtitles_bg_bot", 1, frame_1 );

  ObjMultiSet( {
    { "grd_int_subtitles_bg_top", { frame = 0 } },
    { "grd_int_subtitles_bg_bot", { frame = 0 } },
    { "obj_int_subtitles_text", { alp = 0 } },
    { "obj_int_subtitles_skip", { input = true, active = true, visible = true } },
    { "txt_int_subtitles", { maxwidth = math.ceil( 0.85 * app_w ) } }
  } );

end;
--********************************************************************************************************************
--********************************************************************************************************************