-- name=m_content
function public.Init ()

  private.section        = nil;
  private.empty_manifest = false;

  local query =
  {
    query      = "find_all",
    group      = "parts",
    collection = "content_packets"
  };
  
  local packet_list = m_storage.Execute( query ).result;
  
  if ( ( #packet_list == 1 ) and ( packet_list[ 1 ].hash == '0' ) ) or
    ( #packet_list == 0 ) then
    
    private.empty_manifest = true;
    
  end;
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Section_SetCurrent ( section_name )

  private.section = section_name;

end;
--------------------------------------------------------------------------------
function public.Res ( item_type, item_name, postfix )

  local content  = "assets/content/";
  local item_dir = public.GetContent( item_type, item_name );
  
  if ( item_type == "gold" and not item_name:find( "gold_" ) ) then
    item_name = item_name.."_"..( postfix or 1 );
  end;

  return content..item_dir.."/"..item_name;

end;
--------------------------------------------------------------------------------
function public.GetContent ( item_type, item_name )

  if ( item_type == "skinpart" ) then

    return private.Skinpart_GetContent( item_name );

  end;
  
  if ( item_type == "sticker" ) then
    
    return "stickers";
    
  end;

  local section = private.Section_GetCurrent();

  local content = 
  {
    default  = "items",
    quest    = section.."/quests",
    fragment = section.."/fragments",
    booster  = "boosters"
  };

  if ( content[ item_type ] ) then

    return content[ item_type ];

  end;

  return content.default;

end;
--------------------------------------------------------------------------------
function public.IsPacketReady ( packet_name )
  
  if ( private.empty_manifest ) or IsPC() then
    
    return true;
    
  end;
  
  return ContentIsPacketReady( packet_name );
  
end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Skinpart_GetContent ( skinpart_name )
  
  local skin_name = m_skins.GetSkinByPart( skinpart_name );

  return m_skins.GetContent( skin_name );

end;
--------------------------------------------------------------------------------
function private.Section_GetCurrent ()

  if ( private.section ) then

    return private.section;

  end;

  local stage_name = m_storage.Player.Info().stage_last;
  
  local query = {
    query      = "find",
    group      = "static",
    collection = "stages",
    indice     = "name",
    criteria   = { like = stage_name }
  };
  
  return m_storage.Execute( query ).result.section;

end;
--------------------------------------------------------------------------------