-- name=m_hero
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ MODEL ] [ HERO ] "..text );

end;
--------------------------------------------------------------------------------
function public.Init ()

  private.Trace( "Initialized." );

  private.StartInGameWatch();

end;
--------------------------------------------------------------------------------
function public.GetStats ()

  local hero_stats  = m_storage.Settings( "hero" );
  local skins_stats = m_skins.GetStats();

  hero_stats.name   = m_player.GetName();
  hero_stats.gold   = skins_stats.gold;
  hero_stats.moves  = skins_stats.moves;
  hero_stats.score  = skins_stats.score;
  hero_stats.attack = hero_stats.attack + skins_stats.attack;
  hero_stats.health = hero_stats.health + skins_stats.health;
  
  hero_stats.resource1     = skins_stats.resource1;
  hero_stats.resource2     = skins_stats.resource2;
  hero_stats.resource3     = skins_stats.resource3;
  hero_stats.enemy_attack  = skins_stats.enemy_attack;
  hero_stats.enemy_health  = skins_stats.enemy_health;
  hero_stats.fox           = skins_stats.fox;

  return hero_stats;

end;
--------------------------------------------------------------------------------
-- function ***** STATISTICS ***** () end;
--------------------------------------------------------------------------------
function public.GetGameStatistic ()

  local statistic = {};

  statistic.id = m_player.GetUserId();
  statistic.achievements = m_achievements.GetAchievementsStat();
  statistic.quests = m_quests.GetCompleteQuestCount();
  statistic.stages = m_stage.GetStagesStat();

  return statistic;

end;
--------------------------------------------------------------------------------
function private.StartInGameWatch ()

  local token = "wtc_ingame_time";

  if ( not TimeIsWatchExist( token ) ) then

    TimeStartWatch( token, "GAME_TIME" );

  end;

end;
--------------------------------------------------------------------------------
function private.GetInGameTime ()

  local token = "wtc_ingame_time";

  if ( TimeIsWatchExist( token ) ) then

    local time = TimeGetWatchTime( token );

    if ( time > 0 ) then

      return cmn.GetTimeFromSec( time );

    end;

  end;

  return nil;

end;
--------------------------------------------------------------------------------