-- name=m_market
--------------------------------------------------------------------------------
function  public.Init ()

  private.Trace( "Initialized." );

  private.refresh_time = private.Settings( "refresh" );

  common.MessageSubscribe( "Event_Market_RefreshOffers", private.Refresh );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function  public.GetShares_Sell ()

  local query =
  {
    query      = "find",
    group      = "player",
    collection = "market"
  };

  return m_storage.Execute( query ).result.sell;

end;
--------------------------------------------------------------------------------
function  public.IsUnlocked ()

  return private.IsUnlocked();

end;
--------------------------------------------------------------------------------
function  public.TryUnlock ( stage_name )

  if ( private.IsUnlocked() ) then

    return false;

  end;

  if ( private.Settings( "unlock" ) == stage_name ) then

    private.Unlock();
    
    mediator.Notify( "Model_Market_Unlocked" );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------
function private.IsUnlocked ()

  local query =
  {
    query      = "find",
    group      = "player",
    collection = "market"
  };

  return m_storage.Execute( query ).result.unlock;

end;
--------------------------------------------------------------------------------
function private.Unlock ()

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "market",
    set        = { unlock = true }
  };

  return m_storage.Execute( query ).result;

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function  public.IsBuilt ()

  return private.IsBuilt();

end;
--------------------------------------------------------------------------------
function  public.TryBuild ( gold_count )  

  if ( private.IsBuilt() ) then return false; end;

  -- JK: i was like omg market is free now
  if ( gold_count < 1 ) then
    
    private.Build();
    private.Refresh();

    mediator.Notify( "Model_Market_Constructed" );
    
    return true;
    
  end;

  if ( m_player.TryChangeGoldCount( - gold_count ) ) then

    common.Kontagent_LogEvent( "economy", 
    {
      description = "premium_currency_spend",
      category    = "market",
      value       = - gold_count,
      name        = "build"
    } );

    private.Build();
    private.Refresh();
    
    mediator.Notify( "Model_Market_Constructed" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------
function private.IsBuilt ()

  local query =
  {
    query      = "find",
    group      = "player",
    collection = "market"
  };

  return m_storage.Execute( query ).result.build;

end;
--------------------------------------------------------------------------------
function private.Build ()  

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "market",
    set        = { build = true }
  };

  return m_storage.Execute( query ).result;

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Settings ( item ) -- "unlock", "build", "buy", "sell", "refresh"

  return private.Settings( item );

end;
--------------------------------------------------------------------------------
function private.Settings ( item ) -- "unlock", "build", "buy", "sell", "refresh"
  
  return m_storage.Settings( "market" )[ item ];

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Refresh ()

  TimeFinishEvent();
  TimeUnsheduleEvent( "mte_market_refresh" );

  local shares = private.Settings( "sell" );
  local random = {};

  for i = 1, #shares do

    random[ "resource"..i ] = math.random( shares[ i ].min, shares[ i ].max );

  end;

  TimeSheduleEvent(
    "mte_market_refresh",
    "GLOBAL_TIME",
    private.refresh_time,
    "Event_Market_RefreshOffers",
    {}
  );

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "market",
    set        = { sell = random }
  };
  
  m_storage.Execute( query );
  
  mediator.Notify( "Model_Market_Refresh" );

end;
--------------------------------------------------------------------------------
function  public.Refresh_Time ()

  return TimeGetEventRemainingTime( "mte_market_refresh" );

end;
--------------------------------------------------------------------------------
function  public.Offers_Save ( resources )

  local query =
  {
    query      = "update",
    group      = "player",
    collection = "market",
    set        = { sell = resources }
  };

  return m_storage.Execute( query ).result;

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ MODEL ] [ MARKET ] "..text );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Cheater_Refresh ()

  private.Refresh();

end;
--------------------------------------------------------------------------------