-- name=m_settings
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ VIEW ] [ SETTINGS ] "..text );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Init ()

  private.Trace( "Initialized." );

end;
--------------------------------------------------------------------------------
function public.DeleteSave ()

  -- Clear timers and watches.
  local _, time_string = parts.storage.data.Read( "parts/time" );
  local time_collection = wiz.json.Decode( time_string );

  for t = 1, #time_collection.callbacks do
    local timer = time_collection.callbacks[ t ].token;
    parts.time.event.Finish();
    parts.time.event.Unshedule( timer );
  end;

  for w = 1, #time_collection.watches do
    local watch = time_collection.watches[ w ].token;
    parts.time.watch.Stop( watch );
  end;

  -- JK: keep hearts data
  local hearts_data = m_storage.Player.Info().hearts;

  -- JK: clear collections
  local collections = ConfigGetTable( "parts.db" ).writable_collections;

  -- JK: force attach database
  m_storage.Database_Attach();

  for i = 1, #collections do

    local collection = collections[ i ];

    local delete_query = 
    {
      query      = "delete_all",
      collection = collection.name
    };

    m_storage.DbExecute( delete_query );

    if ( #collection.items > 0 ) then

      for j = 1, #collection.items do

        local insert_query = 
        {
          query      = "insert",
          collection = collection.name,
          value      = collection.items[ j ]
        };

        m_storage.DbExecute( insert_query );

      end;

    end;

  end;

  if ( IsPC() ) then

    -- JK: return back donated hearts and restore hearts to default
    hearts_data.count    = 3 + hearts_data.donate;
    hearts_data.facebook = 0;
    
    local hearts_query =
    {
      query      = "update",
      group      = "player",
      collection = "info",
      set        = { hearts = hearts_data }
    };

    m_storage.Execute( hearts_query );

  end;

  parts.storage.data.Write( "sml/allow_sections", 1 );
  
  common.Kontagent_LogEvent( "progress", { name = "reset" } );
  common.Return( true );

end;
--------------------------------------------------------------------------------