-- name=m_tutorial
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ MODEL ] [ TUTORIAL ] "..text );

end;
--------------------------------------------------------------------------------
function public.Init ()

  private.Trace( "Initialized." );
  
  private.completed = {};
  
  local query =
  {
    query      = "find_all",
    group      = "player",
    collection = "tutorial"
  };

  private.completed = m_storage.Execute( query ).result;
  private.enable    = m_storage.Settings( "tutorial_enable" );  

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function public.IsEnable ()
  
  return private.enable;

end;
--------------------------------------------------------------------------------
function public.IsCompleted ( tutorial_name )

  if ( cmn.IsEntityInList( private.completed, { name = tutorial_name }, "name" ) ) then
    
    return true;
    
  end;
  
  return false;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function public.Complete ( tutorial_name )

  if ( public.IsCompleted( tutorial_name ) ) then

    return;

  end;

  local query =
  {
    query      = "insert",
    group      = "player",
    collection = "tutorial",
    value      = 
    {
      name = tutorial_name
    }
  };

  m_storage.Execute( query );
  
  table.insert( private.completed, { name = tutorial_name } );

end;
--------------------------------------------------------------------------------