-- name=v_boosters
--------------------------------------------------------------------------------
function public.Init ()

  ne.mod.LoadLazily( "assets/content/scripts/mod_int_dialog_booster_buy" );
  ne.mod.LoadLazily( "assets/content/scripts/mod_int_panel_booster_sorcery" );

  private.tap_counter = 0;

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Tap ( callpoint, booster_name, stage_name, additional_data )

  return private.Tap( callpoint, booster_name, stage_name, additional_data );

end;
--------------------------------------------------------------------------------
function public.Use ( params, stage_name )

  private.Use( params, stage_name );

end;
--------------------------------------------------------------------------------
function public.ResetTapCounter ()

  private.tap_counter = 0;

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Tap ( callpoint, booster_name, stage_name, additional_data )

  additional_data = additional_data or
  {
    row      = nil,
    col      = nil,
    vertical = nil
  };

  local func_OnTap_Shop = function ()

    local func_end = function ()

      --

    end;

    local func_top_panel_show = function ()

      --

    end;

    local func_top_panel_hide = function ()

      --

    end;

    private.Dialog_Show(
      booster_name,
      nil,
      func_end,
      func_top_panel_show,
      func_top_panel_hide,
      true
    );
  
    return true;

  end;

  local func_OnTap_Other = function ()

    if ( m_boosters.GetCount( booster_name ) == 0 ) then

      local func_end = function ()

        int_panel_stage_boosters.SetInput( true );
        int_panel_stage_settings.SetInput( true );

      end;

      local func_top_panel_show = function ()

        int_panel_map_top.Highlight( "gold" );
        v_map.TopPanel_Show();

      end;

      local func_top_panel_hide = function ()

        v_map.TopPanel_Hide();

      end;

      private.Dialog_Show(
        booster_name,
        stage_name,
        func_end,
        func_top_panel_show,
        func_top_panel_hide
      );

      return false;

    end;

    private.tap_counter = ( private.tap_counter or 0 ) + 1;

    if ( private.tap_counter == 2 ) then

      private.tap_counter = 0;

      common.MessageSend( Event_Match3_BoosterDeactivated );

      return false;

    end;

    common.MessageSend(
      Event_Match3_BoosterActivated,
      {
        name     = booster_name,
        row      = additional_data.row,
        col      = additional_data.col,
        vertical = additional_data.vertical }
    );

    if ( additional_data                                          ) and
       ( ( additional_data.vertical ) or ( additional_data.wind ) ) then

      int_panel_stage_boosters.StartAnim( booster_name );

    end;

    return true;

  end;

  local func_OnTap_Buy = function ()

    local func_end = function ()

      --

    end;

    local func_top_panel_show = function ()

      int_panel_map_top.Highlight( "gold" );
      v_map.TopPanel_Show();

    end;

    local func_top_panel_hide = function ()

      v_map.TopPanel_Hide();

    end;

    private.Dialog_Show(
      booster_name,
      stage_name,
      func_end,
      func_top_panel_show,
      func_top_panel_hide
    );

    return false;

  end;

  local callpoint_funcs = 
  {
    shop   = func_OnTap_Shop,
    stage  = func_OnTap_Other,
    dialog = func_OnTap_Other,
    buy    = func_OnTap_Buy
  };

  return callpoint_funcs[ callpoint ]();

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Use ( params, stage_name )

  private.tap_counter = 0;

  if ( not params.result ) then

    mediator.Notify( "View_Boosters_BoosterUsageFailed", { name = params.name } );

    return;

  end;

  local booster_name = params.name;

  local use_functions = 
  {
    hammer     =   { func = private.Use_ToChip,  effect = true,  use = true  },
    sorcery    =   { func = private.Use_Sorcery, effect = true,  use = false },
    sorcery_last = { func =                nil,  effect = false, use = true  },
    wave       =   { func = private.Use_ToChip,  effect = false, use = true  },
    bomb       =   { func = private.Use_ToChip,  effect = false, use = true  },
    tornado    =   { func = private.Use_ToArea,  effect = true,  use = true  },
    wind       =   { func = private.Use_ToPair,  effect = true,  use = true  },
    cascade    =   { func = private.Use_ToChip,  effect = false, use = true  },
    fireburst  =   { func = private.Use_ToList,  effect = true,  use = true  },
    magicgift  =   { func = private.Use_ToArea,  effect = true,  use = true  },
    heavenhelp =   { func = private.Use_ToArea,  effect = true,  use = true  },
    downright  =   { func =                nil,  effect = false, use = true  },
    nolimits   =   { func = private.Use_ToArea,  effect = true,  use = true  },
    superbomb  =   { func =                nil,  effect = false, use = true  },
    swatter    =   { func = private.Use_ToArea,  effect = true,  use = true  },
    shuffle    =   { func = private.Use_ToArea,  effect = true,  use = true  },
    movesup    =   { func = private.Use_ToArea,  effect = true,  use = true  },
    anticrystal=   { func = private.Use_ToChip,  effect = false, use = true  },
    superhit   =   { func = private.Use_ToArea,  effect = false, use = true  }
  };

  local func_end = function ()

    if ( params.func_end ) then params.func_end(); end;

    ObjDelete( "anm_boosters_action_"..booster_name );
    
    mediator.Notify(
      "View_Boosters_BoosterUsedAnimEnd",
      { name = booster_name }
    );

  end;
  
  if ( use_functions[ booster_name ].use ) then
    
    m_boosters.TryUse( cmn.GetObjectPrefix( booster_name ) or booster_name, stage_name );
    
  end;

  if ( use_functions[ booster_name ].func ) then
    
    ObjClone( "anm_boosters_action", "_"..booster_name, 0, InterfaceName );

    ObjSet( "anm_boosters_action_"..booster_name, { pos_z = 899 } );
    
    use_functions[ booster_name ].func(
      params,
      func_end,
      use_functions[ booster_name ].effect
    );
    
  end;

  mediator.Notify(
    "View_Boosters_BoosterUsed",
    { name = booster_name }
  );
  
end;
--------------------------------------------------------------------------------
function private.Use_ToChip ( params, func_end, effect )

  local booster_name   = params.name;
  local booster_object = "anm_boosters_action_"..booster_name;

  local func_end_anim = function ()

    ObjSet( booster_object,
    {
      active  = false,
      visible = false } );

    if ( func_end ) then

      func_end();

    end;

  end;

  if ( effect ) then

    local animfunc = booster_name;

    if ( params.property ) then

      animfunc = booster_name.."_"..string.lower( params.property );

    end;

    ObjSet( booster_object, 
    { 
      active   = true,
      visible  = true,
      res      = "assets/content/match3/fx/anm_"..booster_name, 
      animfunc = animfunc,
      pos_x    = params.x + 35,
      pos_y    = params.y + 35 
    } );

    AnimPlay( booster_object, animfunc, func_end_anim );

  else

    func_end_anim();

  end;
  
  private.Sound_Play( booster_name );

end;
--------------------------------------------------------------------------------
function private.Use_ToList ( params, func_end, effect )

  local booster_name = params.name;
  local res_name     = booster_name;

  local func_end_anim = function ( data )

    ObjDelete( data.sender );

    if ( tonumber( string.match( data.sender, "%d+" ) ) == #params.chips_list and func_end ) then

      func_end();

    end;

  end;

  for i = 1, #params.chips_list do

    ObjClone(
      "anm_boosters_action",
      "_"..booster_name.."_"..i, 1,
      InterfaceName
    );

    ObjSet( "anm_boosters_action_"..booster_name.."_"..i, 
    { 
      active   = true,
      visible  = true,
      res      = "assets/content/match3/fx/anm_"..res_name, 
      animfunc = booster_name,
      pos_x    = params.chips_list[ i ].x + 35,
      pos_y    = params.chips_list[ i ].y + 35 
    } );

    AnimPlay(
      "anm_boosters_action_"..booster_name.."_"..i,
      booster_name,
      func_end_anim
    );    

  end;

  private.Sound_Play( booster_name );

end;
--------------------------------------------------------------------------------
function private.Use_ToArea ( params, func_end, effect )
  
  if ( effect ) then
    
    local booster_name   = params.name;
    local booster_object = "anm_boosters_action_"..booster_name;

    local x, y = v_match3.GetFieldCenter();

    ObjSet( booster_object, 
    { 
      active   = true,
      visible  = true,
      res      = "assets/content/match3/fx/anm_"..booster_name, 
      animfunc = booster_name,
      pos_x    = x,
      pos_y    = y
    } );

    local func_end_anim = function ()

      ObjSet( booster_object,
      {
        active  = false,
        visible = false } );

      if ( func_end ) then

        func_end();

      end;

    end;

    AnimPlay( booster_object, booster_name, func_end_anim );

    private.Sound_Play( booster_name );
  
  elseif ( func_end ) then

    func_end();
        
  end;
  
end;
--------------------------------------------------------------------------------
function private.Use_ToPair ( params, func_end, effect )

  local booster_name = params.name;

  private.Sound_Play( booster_name );

  if ( func_end ) then

    func_end();

  end;

end;
--------------------------------------------------------------------------------
function private.Use_Sorcery ( params, func_end, effect )

  private.Sorcery_Show( params.x, params.y, func_end );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Sorcery_Show ( x, y, func_end )

  local func_hide = function ( direction )

    private.Sorcery_Hide( x, y, direction, func_end );

  end;

  local func_reject = function ()

    common.MessageSend( Event_Match3_BoosterDeactivated );

    if ( func_end ) then

      func_end();

    end;

  end;
  
  int_panel_booster_sorcery.Show( x, y, func_hide, func_reject ); 

end;
--------------------------------------------------------------------------------
function private.Sorcery_Hide ( x, y, direction, func_end )

  local booster_name   = "sorcery";
  local booster_object = "anm_boosters_action_"..booster_name;

  common.MessageSend(
    Event_Match3_BoosterActivated,
    { name = "sorcery_last", direction = direction }
  );

  local func_end_anim = function ()

    ObjSet( booster_object, { active = false, visible = false } );

    if ( func_end ) then

      func_end();

    end;

  end;

  local animfunc = booster_name.."_"..string.lower( direction );

  ObjSet( booster_object, 
  { 
    active   = true, visible = true,
    res      = "assets/content/match3/fx/anm_"..booster_name, 
    animfunc = animfunc,
    pos_x    = x + 35,
    pos_y    = y + 35 
  } );

  AnimPlay( booster_object, animfunc, func_end_anim );

  private.Sound_Play( booster_name );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Dialog_Show (
    booster_name,
    stage_name,
    func_end,
    func_top_panel_show,
    func_top_panel_hide,
    hide_on_deficient
  )

  private.TopPanel_Hide = func_top_panel_hide;

  local boosters = m_boosters.GetPacks( booster_name );  
  local booster_pack;

  for b = 1, #boosters do

    if ( boosters[ b ].count >= 3 ) then

      booster_pack = boosters[ b ];
      break;

    end;

  end;

  local func_buy = function ()

    if ( m_boosters.TryBuy( booster_name, 1, stage_name ) ) then

      return true;

    end;

    if ( hide_on_deficient ) then

      private.Dialog_Hide( func_end );

    end;

    return false;

  end;

  local func_show = function ()

    func_top_panel_show();

    int_dialog_booster_buy.Show(
      booster_name,
      booster_pack,
      func_buy,
      function () private.Dialog_Hide( func_end ) end
    );

  end;

  int_window.Show( "int_dialog_booster_buy", func_show );

end;
--------------------------------------------------------------------------------
function private.Dialog_Hide ( func_end )

  int_dialog_booster_buy.Hide( function()

    int_window.Hide( "int_dialog_booster_buy" );

    private.TopPanel_Hide();

    if ( func_end ) then

      func_end();

    end;

  end );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Sound_Play ( booster_name )
  
  local path = "assets/content/boosters/aud_booster_"..booster_name;
  
  cmn.PlaySnd( path );
  
end;
--------------------------------------------------------------------------------