-- name=v_dailybonus
--------------------------------------------------------------------------------
function public.Init ()

  loader.Module_Load( "int_dialog_dailybonus" );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Dialog_TryShow ( func_close )

  if ( not m_dailybonus.IsReady() ) then
    
    return;
    
  end;  

  private.Finish();

  local current_day    = m_dailybonus.Day_GetCurrent();
  local current_limits = m_dailybonus.Day_GetPeriodLimits( current_day );

  private.rewards = {};

  --JK: get rewards for current period from settings
  for day = current_limits[ 1 ], current_limits[ 2 ] do

    local reward   = m_dailybonus.Settings( "rewards" )[ day ];
    reward.content = m_content.GetContent( reward.type, reward.name );

    table.insert( private.rewards, reward );

  end;

  current_day = m_dailybonus.Day_ToRelative( current_day );

  ------------------------------------------------------------------------------
  local func_claim = function ( day )
    
    -- JK: continue map update on reward chest closed
    private.Claim( day, func_close );

  end;
  ------------------------------------------------------------------------------
  local func_toppanel_show = function ()

    v_map.TopPanel_Show( true );

  end;
  ------------------------------------------------------------------------------
  local func_dialog_hide = function ()
    
    -- JK: continue map update on dialog closed if reward is not a chest
    if ( private.rewards[ current_day ].type == "chest" ) then
      
      func_close = nil;
      
    end;
    
    private.Dialog_Hide( func_close );

  end;
  ------------------------------------------------------------------------------
  local func_skin_attach = function ( parent )

    return v_hero.Skin_Attach( parent );

  end;
  ------------------------------------------------------------------------------
  local func_skin_detach = function ( anm_name )

    v_hero.Skin_Detach( anm_name );

  end;
  ------------------------------------------------------------------------------
  local func_show = function ()

    int_dialog_dailybonus.Show(
      current_day,
      private.rewards,
      func_claim,
      func_toppanel_show,
      func_dialog_hide,
      func_skin_attach,
      func_skin_detach
    );

  end;
  ------------------------------------------------------------------------------

  int_window.AddWindowToQueue( "int_dialog_dailybonus", func_show );
  
end;
--------------------------------------------------------------------------------
function private.Dialog_Hide ( func_end )

  int_dialog_dailybonus.Hide(
    function ()

      int_window.Hide( "int_dialog_dailybonus", func_end );

    end
  );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Finish ()

  m_dailybonus.Finish();

end;
--------------------------------------------------------------------------------
function private.Claim ( day, func_close )

  if ( private.rewards[ day ].type == "chest" ) then

    v_items.Chest_Show(
      private.rewards[ day ],
      {
        category   = "dailybonus",
        stage_name = private.rewards[ day ].name,
        silent     = true
      },
      nil,
      func_close,
      nil,
      ( func_close ~= nil )
    );

    return;

  end;

  private.Obtain( private.rewards[ day ], day, false );

end;
--------------------------------------------------------------------------------
function private.Obtain ( reward, day, silent )

  m_items.TryObtain( {
    name       = reward.name,
    type       = reward.type,
    count      = reward.count,
    category   = "dailybonus",
    stage_name = "day_"..day,
    silent     = silent
  } );

end;
--------------------------------------------------------------------------------