-- name=v_hearts
--------------------------------------------------------------------------------
function public.Init ()

  loader.Module_Load( "int_dialog_hearts" );

  mediator.Subscribe( "Model_Player_HeartsCountChanged",      private.Update );
  mediator.Subscribe( "Model_Player_HeartsRecoverStart",      private.TimerShow );
  mediator.Subscribe( "View_Social_HeartAsked",               private.TimerAskShow );
  mediator.Subscribe( "Model_Player_HeartsCountChangeFailed", public.Show );

  private.Trace( "Initialized." );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.Show ( func_OnHide )

  local count        = m_player.GetHeartsCount();
  local count_donate = m_player.GetDonateHeartsCount();
  local max_count    = m_hearts.GetMaxHearts();
  local price        = m_hearts.GetHeartsPrice();
  local donate       = m_hearts.GetHeartsDonate();
  local facebook     = false;
  local facebook_timer_token;
  
  if ( IsMobile() ) then
    
    facebook  = m_client.IsOnline() and m_social.IsLogged() and 
      ( #m_social.GetFriends() > 0 );
    facebook_timer_token = v_social.Hearts.GetAskToken();
    
  end;
  ------------------------------------------------------------------------------
  local func_top_panel_show = function ()

    int_panel_map_top.Highlight( "gold" );
    v_map.TopPanel_Show();

  end;
  ------------------------------------------------------------------------------
  local func_top_panel_hide = function ()

    v_map.TopPanel_Hide();

  end;
  ------------------------------------------------------------------------------
  local func_accept = function ()

    return m_hearts.TryBuy();

  end;
  ------------------------------------------------------------------------------
  local func_donate = function ()

    return m_hearts.TryIncreaseMaxHeartsCount();

  end;
  ------------------------------------------------------------------------------
  local func_facebook = function ()

    if ( IsMobile() ) then
  
      v_social.FriendsChoose.TryShow( func_top_panel_show );
      func_top_panel_hide();

    end;
      
  end;
  ------------------------------------------------------------------------------
  local func_close = function ( result )

    if ( IsMobile() ) then
      
      int_panel_social_score.VisualShow();
      
    end;
    
    private.Hide( func_OnHide, result );

  end;
  ------------------------------------------------------------------------------
  local func_skin_attach = function ( parent )

    return v_hero.Skin_Attach( parent );

  end;
  ------------------------------------------------------------------------------
  local func_skin_detach = function ( anm_name )

    v_hero.Skin_Detach( anm_name );

  end;
  ------------------------------------------------------------------------------
  local func_start = function ()

    int_dialog_hearts.Show( 
      count,
      max_count, 
      price,
      count_donate, 
      donate, 
      facebook, 
      facebook_timer_token, 
      func_donate, 
      func_facebook, 
      func_accept, 
      func_close,
      func_top_panel_show,
      func_top_panel_hide,
      func_skin_attach,
      func_skin_detach
    );

  end;

  if ( IsMobile() ) then
    
    int_panel_social_score.VisualHide();
    
  end;
  
  int_window.Show( "int_dialog_hearts", func_start );

  cmn.PlaySnd( "click_energy" );

end;
--------------------------------------------------------------------------------
function private.Hide ( func_OnHide, result )

  local func_close = function ()

    int_window.Hide( "int_dialog_hearts" );

    if ( func_OnHide ) then

      func_OnHide( result );

    end;

  end;

  int_dialog_hearts.Hide( func_close );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function private.Update ( params )    

  int_dialog_hearts.Update(
    params.count,
    params.max,
    m_hearts.GetHeartsPrice(),
    params.reason
  );

end;
--------------------------------------------------------------------------------
function private.TimerShow ()
  
  int_dialog_hearts.Timer_Main_Show();

end;
--------------------------------------------------------------------------------
function private.TimerAskShow ()
  
  int_dialog_hearts.Timer_Social_Show();

end;
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ VIEW ] [ HEARTS ] "..text );

end;
--------------------------------------------------------------------------------