-- name=v_quests
 public.Panel = {};
private.Panel = {};
 public.Questlist = {};
private.Questlist = {};
private.Highlight = {};
--------------------------------------------------------------------------------
function  private.Trace ( text )
  
  common.Trace( "[ VIEW ][ QUESTS ] "..text );
  
end;
--------------------------------------------------------------------------------
function  public.Init ()
  
  private.screen_w = int.W();
 
  loader.Modules_Load({
    "int_panel_questlist",
    "int_panel_darkhole"
  });

  mediator.Subscribe(
    "Model_Quests_QuestStarted",
    private.Questlist.OnQuestStarted
  );

  mediator.Subscribe(
    "Model_Quests_QuestCompleted",
     private.Questlist.OnQuestCompleted
  );

  mediator.Subscribe(
    "Model_Quests_QuestUpdated",
    private.Questlist.OnQuestUpdated
  );
  
  --AL> Каждое второе поражение на одном и том же уровне
  local attempts_count = m_storage.Settings( "quests" ).attempts_to_pop;
  
  mediator.Subscribe( "Model_Stage_AttemptsIncreased", function ( attempts ) 
  
    if ( attempts % attempts_count == 0 ) then
      
      private.Panel.pop = true;
      
    end;
  
  end );
  
  --1st char's quest item
  
  --AL> Получен предмет в шахте
  mediator.Subscribe( "Model_Mines_MineProgressChanged", function ( params )
  
    if ( params.progress == 1 ) then
      
      private.Panel.pop = true;
      
    end;
  
  end );
  ------------------------------------------------------------------------------
  private.Questlist.quests    = {};
  private.Questlist.outdated  = {};
  private.Panel.notification  = 0;
  private.Panel.stage_counter = 0;
  
  --AL> runtime-таблица таблиц, в которых хранятся данные прохода по целям квеста
  private.Highlight.cycling   = {};
  
  int_panel_map_right.Quests_Enable( private.Panel.Tap );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function  public.Panel.Show ()
  
  int_panel_map_right.Quests_Warn( private.Panel.notification )
  
end;
--------------------------------------------------------------------------------
function  public.Panel.Hide ()

end;
--------------------------------------------------------------------------------
function private.Panel.Tap ()

  -- TODO: Fix it in 1.12
  local show_event = false;
  
  int_panel_questlist.Tap( show_event );
  
  private.Panel.notification = 0;
  private.Panel.pop = nil;
  
  int_panel_map_right.Quests_Warn( private.Panel.notification );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function public.StageList_HasReward (
    section_name,
    reward_type,
    reward_name_pattern
  )

  return m_quests.StageList_HasReward(
    section_name,
    reward_type,
    reward_name_pattern
  );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function  public.Questlist.Update ( section_name )

  private.Questlist.Update( section_name );

end;
--------------------------------------------------------------------------------
function  public.Questlist.SetHandlers ( func_open, func_close )

  int_panel_questlist.SetHandlers( 
    func_open, 
    func_close, 
    private.Highlight.Show,
    private.Highlight.Hide
  );
   
end;
--------------------------------------------------------------------------------
function private.Questlist.Update ( section_name )
  
  local section_changed = ( private.section ~= section_name );
  
  if ( #private.Questlist.outdated > 0 ) or ( section_changed ) then
    
    local quests_created = {};
    local quests_updated = {};
    local quests_deleted = {};
    local quests_actual  = m_quests.GetCurrentQuestsInfo( section_name );
    
    if ( section_changed ) then
    
      for q, quest in ipairs( quests_actual ) do
        
        quest = private.Questlist.GetAdditionalData( quest );
        quests_actual[ q ] = quest;
        table.insert( quests_created, quest );
        private.Trace( "(Re)Initializing "..quest.name );
        
      end;
      
      for q, quest in ipairs( private.Questlist.quests ) do
        
        table.insert( quests_deleted, quest );
        
      end;
      
      private.Questlist.quests   = quests_actual;
      private.Questlist.outdated = {};
      
    elseif ( #private.Questlist.outdated > 0 ) then
      
      for o = #private.Questlist.outdated, 1, -1 do
        
        local outdated = private.Questlist.outdated[o];
        
        local q     = cmn.IsEntityInList( 
          quests_actual, 
          { name = outdated.quest }, 
          "name" 
        );
        
        local quest = quests_actual[ q ];
        
        if ( outdated.event == "QuestCompleted" ) then 
          
          table.insert( quests_deleted, { name = outdated.quest } );
          
          local q_delete = cmn.IsEntityInList(
            private.Questlist.quests,
            { name = outdated.quest },
            "name"
          );
          
          if ( q_delete ) then
          
            table.remove( private.Questlist.quests, q_delete );
            
          end;
            
          private.Trace( "Deleting "..outdated.quest );
          
          if ( private.Highlight.cycling[ outdated.quest ] ) then
            private.Highlight.cycling[ outdated.quest ] = nil;
          end;
          
        elseif ( q ) then
          
          quest = private.Questlist.GetAdditionalData( quest );
          
          if ( private.Highlight.cycling[ quest.name ] ) then
            private.Highlight.cycling[ quest.name ] = {};
          end;
          
          if ( outdated.event == "QuestStarted" ) then  
          
            table.insert( quests_created, quest );
            table.insert( private.Questlist.quests, quest );
            private.Trace( "Creating "..quest.name );
            
          elseif ( outdated.event == "QuestUpdated" ) then 
          
            table.insert( quests_updated, quest );
          
            private.Questlist.quests[ 
              cmn.IsEntityInList(
                private.Questlist.quests,
                { name = quest.name },
                "name"
              )
            ] = quest;
            
            private.Trace( "Updating "..quest.name );
          
            -- Подсвечивание панельки после получения первого предмета для перса
            if 
            ( quest.target.type == "QT_StageItemsCollected" ) and
            ( #(quest.list or {}) == 1 ) and
            ( m_characters.IsCharactersQuest( quest.name )) then
              
              private.Panel.pop = true;
              
            end;
            
          end;
          
        end;
        
        table.remove( private.Questlist.outdated, o );
        
      end;
      
    end;
      
    int_panel_questlist.Update( 
      section_name, 
      quests_created,
      quests_updated,
      quests_deleted,
      section_changed
    );
    
  end;

  private.section = section_name;
  
end;
--------------------------------------------------------------------------------
function private.Questlist.GetAdditionalData ( quest )

  local priority;
  
  if ( quest.target.type == "QT_StageCompleted" ) then
    
    if ( quest.target.name:find( "bonus" )) then
      priority = 2;
    else
      
      local stage_data = m_stage.GetStaticData( quest.target.name );
      if ( stage_data.realtype == "fight" ) then
        quest.enemy         = stage_data.state[1].enemy.name;
        quest.enemy_content = stage_data.state[1].enemy.content;
        priority = 0;
      else
        priority = 1;
      end;
      
    end;

  elseif ( quest.target.type == "QT_StageListCompleted" ) or
         ( quest.target.type == "QT_ReachMaxLevelStages" ) then
    
    if ( quest.list and ( #quest.list > 0 )) then
    
      for s, stage in ipairs( quest.target.list ) do
        
        local stage_num = cmn.IsEntityInList( quest.list, stage );
        
        if ( not stage_num ) then
      
          quest.current_stage = stage;
          break;
          
        end;
        
      end;
      
    else
      
      quest.current_stage = quest.target.list[1];
      
    end;
    
  elseif ( quest.target.type == "QT_BuildConstructed" ) then
    priority = 5;
    
  elseif ( quest.target.type == "QT_MineConstructed" ) then
    priority = 6;

  elseif ( quest.target.type == "QT_MarketConstructed" ) then
    priority = 4;

  elseif ( quest.target.type == "QT_StageItemsCollected" ) then
    priority = 3;

  elseif ( quest.target.type == "QT_FragmentCollected" ) then
    priority = 5;
    
  elseif ( quest.target.type == "QT_MineResourceCollected" ) then
    
    local mine_type;
    
    mine_type, quest.target.resource = v_mines.Mine_Type( quest.target.name );

  end;
  
  quest.priority = priority or 10;
  
  return quest;
  
end;
--------------------------------------------------------------------------------
function private.Questlist.OnQuestStarted ( quest_name )

  table.insert( private.Questlist.outdated, { 
    event = "QuestStarted",
    quest = quest_name
  } );

  --FF: Лучше привязываться к типу
  if ( not quest_name:find( "_complete_stage_" ) ) then
    
    private.Panel.notification = private.Panel.notification + 1;
    
  end;
  
end;
--------------------------------------------------------------------------------
function private.Questlist.OnQuestCompleted ( quest )

  table.insert( private.Questlist.outdated, { 
    event = "QuestCompleted",
    quest = quest.name
  } );
  
  --AL> Поппинг на 5 пройденных уровней
  if ( quest.target.type == "QT_StageCompleted" ) then
    private.Panel.stage_counter   = private.Panel.stage_counter + 1;
    if ( private.Panel.stage_counter == 5 ) then
      private.Panel.stage_counter = 0;
      private.Panel.pop           = true;
    end;
  end;

end;
--------------------------------------------------------------------------------
function private.Questlist.OnQuestUpdated ( quest_name )

  table.insert( private.Questlist.outdated, { 
    event = "QuestUpdated",
    quest = quest_name
  } );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Highlight.Show ( quest_name )

  local quest;

  for q = 1, #private.Questlist.quests do

    if ( private.Questlist.quests[ q ].name == quest_name ) then

      quest = private.Questlist.quests[ q ];
      break;

    end;

  end;
  
  local obj_name, input_events, scale, bounce = 
    private.Highlight.GetProperties( quest );
  
  if ( not obj_name ) then return; end;

  local obj_params = ObjGet( obj_name );
  if ( not obj_params.visible ) then return; end;
  
  v_map.Focus( obj_name, 
    {
    time       = 0.2,
    offset     = { x = 0, y = 0 },
    func_after = function ()

      if ( not obj_params.input ) then return; end;

      if ( not input_events ) then
      
        input_events = int.Control_EventsGet( obj_name );
        
        if ( not input_events ) then
        
          local btn_name = "btn"..string.sub( obj_name, 4 );
          input_events = int.Control_EventsGet( btn_name );
          
        end;
        
      end;

      local body_params = ObjGet( "obj_map_body" ) ;
      local map_params  = GetObjPosByObj( "anm_map_"..quest.section );
      local obj_pos     = int.Position( obj_name, "anm_map_"..quest.section );
      obj_params.pos_x  = map_params[1] + obj_pos[1] * body_params.scale_x;
      obj_params.pos_y  = map_params[2] + obj_pos[2] * body_params.scale_y;
      scale             = scale * body_params.scale_x;

      if ( bounce ) then common.Animation_Bounce( obj_name ); end;
        
      int_panel_darkhole.Show(
        obj_params,
        function ()
          input_events.func_on_click();
        end,
        scale
      );

    end
    }
  );
  
  cmn.PlaySnd( "desire" );

end;
--------------------------------------------------------------------------------
function private.Highlight.Hide ()
  
  int_panel_darkhole.Hide();
    
end;
--------------------------------------------------------------------------------
function private.Highlight.GetProperties ( quest )
  
  local name;           -- Map object's name
  local input_events;   -- Object's tap func
  local scale  = 3.0;   -- Highlight hole size
  local bounce = true;  -- Bounce of map object
  
  if ( quest.target.type == "QT_StageCompleted" ) then

    if ( quest.name:find( "bonus" )) then

      name = "obj_map_point_"..quest.target.name;

    else

      local stage_data = m_stage.GetStaticData( quest.target.name );

      if ( stage_data.realtype == "fight" ) then

        name     = 
          "obj_map_enemy_"..quest.enemy.."_"..quest.target.name;
        
        local btn_params = ObjGet( "btn_map_point_"..quest.target.name );
        
        if ( btn_params and btn_params.active and btn_params.input ) then
        
          local obj_btn = "btn_map_point_"..quest.target.name;
          input_events = int.Control_EventsGet( obj_btn );
          
        else
        
          input_events = int.Control_EventsGet( name );
          
        end;
          
        bounce = false;

      else

        name     = "obj_map_point_"..quest.target.name;
        scale    = 1.5;

      end;

    end;

  elseif ( quest.target.type == "QT_SpellCompleted" ) then

    name     = "obj_map_spells_"..quest.target.name;
    scale    = 2.2;
    
  elseif ( quest.target.type == "QT_BuildConstructed" ) then

    name     = "obj_map_builds_"..quest.target.name;
    bounce   = false;
    
  elseif ( quest.target.type == "QT_MineConstructed"       ) or
         ( quest.target.type == "QT_MineResourceCollected" ) then

    name     = "obj_map_mines_"..quest.target.name;

  elseif ( quest.target.type == "QT_MarketConstructed" ) then

    name     = "obj_map_builds_market";

  elseif ( quest.target.type == "QT_StageListCompleted"  ) or
         ( quest.target.type == "QT_ReachMaxLevelStages" ) or
         ( quest.target.type == "QT_StageItemsCollected" ) then

    scale    = 1.5;

    if ( not private.Highlight.cycling[ quest.name ] ) or
       ( #private.Highlight.cycling[ quest.name ] == #quest.target.list - #quest.list ) then
       
      private.Highlight.cycling[ quest.name ] = {};
      
    end;
        
    for t = 1, #quest.target.list do
    
      local done = cmn.IsEntityInList( quest.list, quest.target.list[t] );
      local seen = 
        cmn.IsEntityInList( private.Highlight.cycling[ quest.name ], t );
       
      if ( not done ) and ( not seen ) then

        name = "obj_map_point_"..quest.target.list[t];
        table.insert( private.Highlight.cycling[ quest.name ], t );
        break;

      end;
      
    end;

  elseif ( quest.target.type == "QT_FragmentCollected" ) then

    local build = m_builds.GetBuildNameByFragment( quest.target.list[ 1 ] );
    name        = "obj_map_builds_"..build;
    bounce      = false;

  end;
  
  return name, input_events, scale, bounce;
  
end;