-- name=v_story
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ VIEW ] [ STORY ] "..text );

end;
--------------------------------------------------------------------------------
function public.Init ()

  private.Trace( "Initialized." );

  ne.mod.LoadLazily( "assets/content/scripts/mod_int_dialog_story" );

end;
--------------------------------------------------------------------------------
--function ... () end;
--------------------------------------------------------------------------------
function public.TryShow ( section_name, cond_type, cond_name, func_after )

  if not ( section_name ) then 

    if ( func_after ) then func_after(); end;
    return false;

  end;

  local story_data = m_story.GetData( section_name, cond_type, cond_name );
  local func_story = public.Callback_ShowStory( story_data );

  if ( func_story ) then
  
    func_story( func_after );
    return true;

  elseif ( func_after ) then

    func_after();

  end;
  
  return false;

end;
--------------------------------------------------------------------------------
function public.Callback_ShowStory ( story_data )

  if ( story_data ) then
  
    return function ( func_after )
    
      local function func_close ()
      
        int_dialog_story.Hide( function ()
          int_window.Hide( "int_dialog_story" );
          if ( func_after ) then func_after(); end;
        end );
      
      end;
      
      local function func_show ()
      
        int_dialog_story.Show( story_data, func_close );
      
      end;
      
      int_window.Show( "int_dialog_story", func_show );
    
    end;
  
  end;

  return nil;

end;
--------------------------------------------------------------------------------