-- name=v_tutorial
--------------------------------------------------------------------------------
function private.Trace ( text )

  common.Trace( "[ VIEW ] [ TUTORIAL ] "..text );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function public.Init ()

  int_control.Add( "tutorial" );

  -- ObjCreate( "hub_tutorial", "obj" );
  -- ObjSet(    "hub_tutorial", { pos_z = 99999 } );
  -- ObjAttach( "hub_tutorial", "int_control" );

  private.app_h     = int.H();
  private.app_w     = int.W();
  private.landscape = int.Landscape();

  loader.Module_Load( "int_dialog_tutorial" );

  private.enabled = m_tutorial.IsEnable();
  
  private.list = {};

  private.BACKUP = {};

  private.Add( "intro",          private.intro );
  private.Add( "stage_1_tap",    private.stage_1_tap );
  private.Add( "stage_1_play",   private.stage_1_play );
  private.Add( "stage_1",        private.stage_1 );
  private.Add( "stage_1_win",    private.stage_1_win );
  private.Add( "stage_1_reward", private.stage_1_reward );
  private.Add( "swordstone",     private.swordstone );
  private.Add( "stage_2_tap",    private.stage_2_tap );
  private.Add( "stage_2_play",   private.stage_2_play );
  private.Add( "stage_2_win",    private.stage_2_win );
  private.Add( "stage_2_reward", private.stage_2_reward );
  private.Add( "stage_2",        private.stage_2 );
  private.Add( "quest",          private.quest );
  private.Add( "stage_3_tap",    private.stage_3_tap );
  private.Add( "stage_3_play",   private.stage_3_play );
  private.Add( "stage_3",        private.stage_3 );
  private.Add( "stage_3_win",    private.stage_3_win );
  private.Add( "stage_4_tap",    private.stage_4_tap );
  private.Add( "stage_4_play",   private.stage_4_play );
  private.Add( "stage_4",        private.stage_4 );
  private.Add( "stage_4_win",    private.stage_4_win );
  
    private.Add( "fireflies_album", private.fireflies_album );
    private.Add( "stickerpack",     private.stickerpack );
    private.Add( "stickerpool",     private.stickerpool );
    --private.Add( "stickerpack_buy", private.stickerpack_buy );
    private.Add( "booster_shop", private.booster_shop );
    private.Add( "booster_buy", private.booster_buy );
    
  private.Add( "stage_5_win",    private.stage_5_win );
  private.Add( "stage_6_tap",    private.stage_6_tap );
  private.Add( "stage_6_play",   private.stage_6_play );
  private.Add( "stage_6",        private.stage_6 );
  private.Add( "stage_6_win",    private.stage_6_win );
  private.Add( "dailyquest_countdown", private.dailyquest_countdown );
  private.Add( "stage_7",        private.stage_7 );
  private.Add( "achievements",   private.achievements );
  private.Add( "questlist",      private.questlist );
  private.Add( "questlist_quest", private.questlist_quest );  
  private.Add( "stage_9",        private.stage_9 );
  private.Add( "magicgift",      private.magicgift );
  private.Add( "skin",           private.skin );
  private.Add( "build",          private.build );
  private.Add( "mine",           private.mine );
  private.Add( "stage_14",       private.stage_14 );
  private.Add( "stage_16_tap",   private.stage_16_tap );  
  private.Add( "stage_16",       private.stage_16 );
  private.Add( "spellbook",      private.spellbook );
  private.Add( "heavenhelp",     private.heavenhelp );
  private.Add( "mine_construct", private.mine_construct );
  private.Add( "stage_26",       private.stage_26 );
  private.Add( "nolimits",       private.nolimits );
  private.Add( "stage_44",       private.stage_44 );
  private.Add( "stage_45",       private.stage_45 );
  private.Add( "market_construct", private.market_construct );  
  private.Add( "stage_69",       private.stage_69 );
  private.Add( "downright",      private.downright );
  private.Add( "stage_79_tap",   private.stage_79_tap );    
  private.Add( "stage_79",       private.stage_79 );
  private.Add( "stage_80",       private.stage_80 );
  private.Add( "dragonspeech",   private.dragonspeech );
  private.Add( "worldmap",       private.worldmap );
  private.Add( "stage_111",      private.stage_111 );
  private.Add( "stage_125_tap",  private.stage_125_tap );  
  private.Add( "stage_125",      private.stage_125 );
  private.Add( "stage_221",      private.stage_221 );
  
  private.Add( "count_bomb",     private.count_bomb );
  private.Add( "spiders",        private.spiders );
  private.Add( "fans",           private.fans );
  private.Add( "anticrystal",    private.anticrystal );
  
  --private.Add( "candy",          private.candy   );
  private.Add( "bottles",        private.bottles );
  private.Add( "paint",          private.paint   );

  private.Add( "wind", private.wind );
  private.Add( "snowflakes", private.snowflakes );

  private.Add( "market",         private.market );
  private.Add( "dailyquest",     private.dailyquest );
  private.Add( "dailyquest_win", private.dailyquest_win );
  private.Add( "stickers_duplicates", private.stickers_duplicates );
  private.Add( "bonuspopup",     private.bonuspopup );
  private.Add( "chest",          private.chest );
  private.Add( "fortunewheel",   private.fortunewheel );
  private.Add( "fortunewheel_activate", private.fortunewheel_activate );
  private.Add( "fortunewheel_win",   private.fortunewheel_win );
  
  --private.Add( "robber_cloud",      private.robber_cloud );  
  --private.Add( "resources",         private.resources );  
  --private.Add( "swordstone_cloud",  private.swordstone_cloud );
  --private.Add( "prisoner_cloud",    private.prisoner_cloud );
  --private.Add( "replay",            private.replay );
  
  private.Trace( "Initialized." );    

end;
--------------------------------------------------------------------------------
function public.Start ()
  
  if not ( m_tutorial.IsEnable() ) then
    
    return;
    
  end;
  
  local stages = 
  {
    intro = "stage_1",         
    stage_1_tap = "stage_1",   
    stage_1_play = "stage_1",  
    stage_1 = "stage_1",       
    stage_1_win = "stage_1",   
    stage_1_reward = "stage_1",
    swordstone = "stage_1",    
    stage_2_tap = "stage_2",   
    stage_2_play = "stage_2",  
    stage_2_win = "stage_2",   
    stage_2_reward = "stage_2",
    stage_2 = "stage_2",       
    quest = "stage_2",         
    stage_3_tap = "stage_3",   
    stage_3_play = "stage_3",   
    stage_3 = "stage_3",
    stage_3_win = "stage_3",
    stage_4_tap = "stage_4",
    stage_4_play = "stage_4",
    stage_4 = "stage_4",
    stage_4_win = "stage_4",
    stage_5_win = "stage_5",
    stage_6_tap = "stage_6",
    stage_6_play = "stage_6",
    stage_6 = "stage_6",
    stage_6_win = "stage_6",
    dailyquest_countdown = "stage_6",
    stage_7 = "stage_7",       
    achievements = "stage_7",  
    questlist = "stage_8",      
    stage_9 = "stage_9",       
    magicgift = "stage_10",     
    skin = "stage_10",   
    build = "stage_11",         
    mine = "stage_12",          
    stage_14 = "stage_14",
    booster_shop = "stage_14",
    stage_16_tap = "stage_16",
    stage_16 = "stage_16",      
    spellbook = "stage_18",     
    heavenhelp = "stage_20",    
    mine_construct = "stage_22",
    stage_26 = "stage_26",      
    stage_44 = "stage_44",      
    stage_45 = "stage_45",      
    market_construct = "stage_49",
    stage_69 = "stage_69",      
    downright = "stage_76",
    stage_79_tap = "stage_79",    
    stage_79 = "stage_79",      
    stage_80 = "stage_80",      
    dragonspeech = "stage_108",    
    stage_111 = "stage_111",
    stage_125_tap = "stage_125",    
    stage_125 = "stage_125",
    count_bomb = "stage_230"
  };  
  
  private.started = true;

  for t = 1, #private.list do

    local tutorial = private.list[ t ];

    if ( stages[ tutorial.name ] ) then

      if ( ( m_stage.GetSavedData( stages[ tutorial.name ] ) or {} ).completed ) then

        if ( not m_tutorial.IsCompleted( tutorial.name ) ) then
        
          private.Complete( tutorial.name );
          
        end;

      end;
      
      if ( m_tutorial.IsCompleted( tutorial.name ) ) then
      
        private.Kontagent_Check( tutorial.name );
        
      end;

    end;

    if ( not m_tutorial.IsCompleted( tutorial.name ) ) then

      if ( tutorial.func ) then

        tutorial.func();

      end;

    end;

  end;

  -- Add hook after screen closed
  local function func_closed_hook ( screen )
  
    if ( screen == "scr_stage" ) then

      mediator.Notify( "View_Tutorial_StageClosed" );

    end;
  
  end;

  mediator.Subscribe( screen.Notifications.ScreenClosed, func_closed_hook );

  -- Add hook after screen opened
  local function func_opened_hook ( screen )

    if     ( screen == "scr_map" ) then

      mediator.Notify( "View_Tutorial_MapOpened" );
     
    elseif ( screen == "scr_stage" ) then

      -- JK: tutorials are on first state only
      local stage = m_stage.GetCurrentStageData();
      
      if ( stage.state == 1 ) then
     
        private.cell_scale = v_match3.GetFieldScale();
        private.cell_size  = 0.5 * 70 * ( private.cell_scale or 1.0 );

        mediator.Notify(
          "View_Tutorial_StageOpened",
          stage.name
        );

      end;
     
    end;

  end;

  mediator.Subscribe( screen.Notifications.ScreenOpened, func_opened_hook );

  --mediator.Subscribe( "Model_Stage_StageWon", private.UnsubscribeOld );

end;
--------------------------------------------------------------------------------
function public.Enable ()
  
  if ( private.enabled ) then
    
    return;
    
  end;
  
  for e, event in pairs( private.events ) do
    
    for i = 1, #event do
    
      mediator.Subscribe(
        event[ i ].name,
        event[ i ].handler
      );
      
    end;
    
  end;
  
  private.enabled = true;
  
end;
--------------------------------------------------------------------------------
function public.Disable ()
  
  if ( not private.enabled ) then
    
    return;
    
  end;
  
  for e, event in pairs( private.events ) do
    
    for i = 1, #event do
    
      mediator.Unsubscribe(
        event[ i ].name,
        event[ i ].handler
      );
      
    end;
    
  end;
  
  private.enabled = false;
  
end;
--------------------------------------------------------------------------------
function public.IsStarted ()

  return private.started;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Kontagent_Check ( tutorial_name )
  
  local notifications = 
  {
    intro = { index = 1, list = { "tut_intro" } },
    stage_1_tap = { index = 2, list = { "tut_level_1", "tut_level_1_tap" } },
    stage_1_play = { index = 4, list = { "tut_level_1_play" } },
    stage_1 = { index = 5, list = { "tut_level_1_score", "tut_level_1_swipe" } },
    stage_1_win = { index = 7, list = { "tut_level_1_win" } },
    stage_1_reward = { index = 8, list = { "tut_level_1_reward" } },
    swordstone = { index = 9, list = { "tut_swordstone" } },
    stage_2_tap = { index = 10, list = { "tut_level_2" } },
    stage_2_play = { index = 11, list = { "tut_level_2_play" } },
    stage_2 = { index = 12, list = { "tut_level_2_match4", "tut_level_2_match4done" } },
    stage_2_win = { index = 14, list = { "tut_level_2_win" } },
    stage_2_reward = { index = 15, list = { "tut_level_2_reward" } },
    quest = { index = 16, list = { "tut_cage" } },
    stage_3_tap = { index = 17, list = { "tut_level_3" } },
    stage_3_play = { index = 18, list = { "tut_level_3_play" } },
    stage_3 = { index = 19, list = { "tut_level_3_matchl", "tut_level_3_matchldone" } },
    stage_3_win = { index = 21, list = { "tut_level_3_win" } },    
    stage_4_tap = { index = 22, list = { "tut_level_4" } },
    stage_4_play = { index = 23, list = { "tut_level_4_play" } },
    stage_4 = { index = 24, list = { "tut_level_4_fireflies", "tut_level_4_hammer", "tut_level_4_hammerdone", "tut_level_4_hammeruse" } },
    stage_4_win = { index = 28, list = { "tut_level_4_win" } },
    stage_5_win = { index = 29, list = { "tut_level_5_win" } },     
    stage_6_tap = { index = 30, list = { "tut_level_6" } },
    stage_6_play = { index = 31, list = { "tut_level_6_play" } },
    stage_6 = { index = 32, list = { "tut_level_6_match5", "tut_level_6_match5done" } },
    stage_6_win = { index = 34, list = { "tut_level_6_win" } }
  };    
  
  if ( notifications[ tutorial_name ] ) then
    
    local value = notifications[ tutorial_name ].index;
    
    for n = 1, #notifications[ tutorial_name ].list do
      
      private.Kontagent_LogEvent( "tutorial", 
      {
        value = value,
        level = 0,
        name  = notifications[ tutorial_name ].list[ n ]
      } );

      value = value + 1;
      
    end;
    
  end
  
end;
--------------------------------------------------------------------------------
function private.Kontagent_LogEvent ( event_type, params )
  
  if ( not m_tutorial.IsCompleted( params.name ) ) then
    
    common.Kontagent_LogEvent( event_type, params );
    private.Complete( params.name );
    
  end;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.PendingBegin ( tutorial_name, screen )

  local pending_token = "tutorial_"..tutorial_name;
  
  local func = {
    map   = function () v_map.Pending_Start( pending_token ); end,
    stage = function () v_stage.Pending_Start( pending_token ); end
  };
  
  func[ screen ]();
  
end;
--------------------------------------------------------------------------------
function private.PendingEnd ( tutorial_name, screen )

  local pending_token = "tutorial_"..tutorial_name;
  
  local func = {
    map   = function () v_map.Pending_Complete( pending_token ); end,
    stage = function () v_stage.Pending_Complete( pending_token ); end
  };
  
  func[ screen ]();
  
end;
--------------------------------------------------------------------------------
function private.IsAutoPending ( event_name )
    
  if ( event_name == "View_Tutorial_StageOpened" ) then
  
    return "stage";
  
  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Subscribe ( tutorial_name, event_name, event_handler )

  private.events                  = private.events or {};
  private.events[ tutorial_name ] = private.events[ tutorial_name ] or {};

  table.insert(
    private.events[ tutorial_name ],
    { name = event_name, handler = event_handler }
  );

  mediator.Subscribe( event_name, event_handler );

end;
--------------------------------------------------------------------------------
function private.Unsubscribe ( tutorial_name, event_name, event_handler )

  if ( private.events[ tutorial_name ] ) then

    --JK: if tutorial is unsubscribing from StageOpened, it means it is pending
    local screen = private.IsAutoPending( event_name );
    
    if ( screen ) then
      
      private.auto_pending = { name = tutorial_name, screen = screen };
      private.PendingBegin( tutorial_name, screen );
      
    end;
    
    mediator.Unsubscribe( event_name, event_handler );

  end;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Add ( name, func )

  private.BACKUP[ name ] = {};

  table.insert( private.list, { name = name, func = func } );

end;
--------------------------------------------------------------------------------
function private.Set ( name, tag, data )

  private.BACKUP[ name ][ tag ] = private.BACKUP[ name ][ tag ] or {};

  private.BACKUP[ name ][ tag ].data = data;

end;
--------------------------------------------------------------------------------
function private.Get ( name, tag )

  if ( private.BACKUP[ name ][ tag ] ) then

    return private.BACKUP[ name ][ tag ].data;

  end;

end;
--------------------------------------------------------------------------------
function private.Backup ( name, tag, data )

  private.BACKUP[ name ][ tag ] = private.BACKUP[ name ][ tag ] or {};

  if ( not private.BACKUP[ name ][ tag ].enabled ) then

    private.BACKUP[ name ][ tag ].enabled = true;

    private.BACKUP[ name ][ tag ].data = data;

  end;

end;
--------------------------------------------------------------------------------
function private.Restore ( name, tag )

  if ( private.BACKUP[ name ][ tag ] ) and ( private.BACKUP[ name ][ tag ].enabled ) then

    private.BACKUP[ name ][ tag ].enabled = false;

    return private.BACKUP[ name ][ tag ].data;

  end;

end;
--------------------------------------------------------------------------------
function private.Complete ( tutorial_name )

  m_tutorial.Complete( tutorial_name );
  
  local pending = private.auto_pending;
  
  if ( pending and pending.name == tutorial_name ) then
     
    private.PendingEnd( tutorial_name, pending.screen );
    
  end;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Dialog_ShowInstantly (
    text_id,
    positions,
    hole,
    func_close,
    text_params,
    map_params,
    interface_lock
  )

  ObjSet( "zmv_map", { candrag = false, canzoom = false } );

  local func_start = function ()

    int_dialog_tutorial.Show(
      text_id,
      positions,
      hole,
      func_close,
      text_params,
      interface_lock
    );

  end;

  map_params = map_params or {
    notify = false,
    input  = false,
    active = false };

  int_window.Show(
    "int_dialog_tutorial",
    func_start,
    {
      notify     = map_params.notify,
      map_input  = map_params.input,
      map_active = map_params.active
    } );

end;
--------------------------------------------------------------------------------
function private.Dialog_ShowFromQueue (
    text_id,
    positions,
    hole,
    func_close,
    text_params,
    map_params,
    interface_lock,
    func_scale
  )

  ObjSet( "zmv_map", { candrag = false, canzoom = false } );

  local func_start = function ()

    local func_show = function()

      int_dialog_tutorial.Show(
        text_id,
        positions,
        hole,
        func_close,
        text_params,
        interface_lock
      );

    end;

    if ( func_scale ) then

      func_scale( func_show );

    else

      func_show();

    end;

  end;

  map_params = map_params or
    {
      notify = false,
      input  = false,
      active = false };

  int_window.AddWindowToQueue(
    "int_dialog_tutorial",
    func_start,
    {
      notify     = map_params.notify,
      map_input  = map_params.input,
      map_active = map_params.active
    }
  );

end;
--------------------------------------------------------------------------------
function private.Dialog_Hide ( func_end, fast_hide )

  ObjSet( "zmv_map", { candrag = true, canzoom = true } );

  int_dialog_tutorial.Hide( function()

    int_window.Hide( "int_dialog_tutorial" );

    if ( func_end ) then

      func_end();
  
    end;

  end, 

  fast_hide );

end;
--------------------------------------------------------------------------------
function private.Dialog_Settings ( focus, pref_vertical, pref_horizontal )
  
  -- JK: you can pass position directly
  local focus_pos = focus;
  
  -- JK: or let it auto-detect
  if ( type( focus ) ~= "table" ) then
  
    focus_pos = int.Position( focus );
    
  end;
  
  --DbgTrace( "Focus is @ "..focus_pos[ 1 ].." x "..focus_pos[ 2 ] );
  
  local percent_w = private.app_w / 100;
  local percent_h = private.app_h / 100;
  local landscape = private.landscape;
  
  local dialog_settings = {
    start_x = 130 * percent_w,
    pos_x   = 50  * percent_w,
    pos_y   = 35  * percent_h,
  };
  
  -- JK: if focus is near the edge, place the text in center
  if ( focus_pos[ 1 ] <= 20 * percent_w ) or
     ( focus_pos[ 1 ] >= 80 * percent_w ) or
     ( focus_pos[ 2 ] <= 20 * percent_h ) or
     ( focus_pos[ 2 ] >= 80 * percent_h ) then

    if ( focus_pos[ 1 ] >= 80 * percent_w ) then
     
      dialog_settings.start_x = -30 * percent_w;
     
    end;
    
    if ( focus_pos[ 2 ] <= 20 * percent_h ) or
       ( focus_pos[ 2 ] >= 80 * percent_h ) then
     
      dialog_settings.pos_y = 50 * percent_h;
    
    end;
    
    dialog_settings = private.Dialog_Settings_TrySetPrefs(
      dialog_settings,
      pref_vertical,
      pref_horizontal,
      percent_h,
      percent_w
    );
    
    dialog_settings = private.Dialog_Settings_SetCharacter(
      dialog_settings,
      percent_h,
      percent_w,
      focus_pos
    );
    
    return dialog_settings;
     
  end;
  
  if ( landscape ) then

    dialog_settings.pos_x = 30 * percent_w;
    dialog_settings.pos_y = 30 * percent_h;
    
    if ( focus_pos[ 1 ] < 50 * percent_w ) then
      
      dialog_settings.pos_x  = 70 * percent_w;
      
    end;
    
    if ( focus_pos[ 2 ] < 50 * percent_h ) then
    
      dialog_settings.pos_y = 80 * percent_h;
    
    end;
    
    -- JK: in stage left top quarter must be clean as hero is there
    if ( v_stage.IsActive()               ) and
       ( focus_pos[ 1 ] >= 50 * percent_w ) then
      
      dialog_settings.pos_y = 80 * percent_h;
      
    end;
    
  elseif ( focus_pos[ 2 ] <= 50 * percent_h ) then
    
    dialog_settings.pos_y = 80 * percent_h;
    
  end;
  
  dialog_settings = private.Dialog_Settings_TrySetPrefs(
    dialog_settings,
    pref_vertical,
    pref_horizontal,
    percent_h,
    percent_w
  );
  
  dialog_settings = private.Dialog_Settings_SetCharacter(
    dialog_settings,
    percent_h,
    percent_w,
    focus_pos
  );
  
  -- JK: if character looks to the right, slide from the left
  if ( dialog_settings.ch_scale == -1 ) then
    
    dialog_settings.start_x = -30 * percent_w;
    
  end;
  
  return dialog_settings;
  
end;
--------------------------------------------------------------------------------
function private.Dialog_Settings_TrySetPrefs (
    dialog_settings,
    pref_vertical,
    pref_horizontal,
    percent_h,
    percent_w
  )
  
  if ( pref_vertical ) then
  
    dialog_settings.pos_y = pref_vertical * percent_h;
      
  end;

  -- JK: horizontal pref works in landscape only
  if ( private.landscape ) and ( pref_horizontal ) then
    
    dialog_settings.pos_x = pref_horizontal * percent_w;
    
    if ( dialog_settings.pos_x > 50 * percent_w ) then
    
      dialog_settings.ch_scale = 1;
      
    end;
      
  end;
  
  return dialog_settings;
  
end;
--------------------------------------------------------------------------------
function private.Dialog_Settings_SetCharacter (
    dialog_settings,
    percent_h,
    percent_w,
    focus_pos
  )

  dialog_settings.ch_scale = -1;
  dialog_settings.ch_pos_y = -96;
  
  if ( dialog_settings.pos_x > 50 * percent_w ) then
    
    dialog_settings.ch_scale = 1;
      
  end;
  
  if ( dialog_settings.pos_x == 50 * percent_w ) then
    
    if ( focus_pos[ 1 ] <= 50 * percent_w ) then
      
      dialog_settings.ch_scale = 1;
      
    end;
      
  end;
  
  --JK: if there's no space on top for character, place it below
  if ( dialog_settings.pos_y <= 20 * percent_h ) then
    
    dialog_settings.ch_pos_y = 160;
    
  end;
  
  return dialog_settings;
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.SetTimer ( time, func_end )

  local timer_name = "tmr_int_dialog_tutorial_delay"

  if ( not ObjGet( timer_name ) ) then

    ObjCreate( timer_name, "timer" );
    ObjAttach( timer_name, InterfaceName );

  end;

  local func_end_timer = function ()

    ObjDelete( "tmr_int_dialog_tutorial_delay" );

    func_end();

  end;

  ObjSet( timer_name, { playing = 1, time = time, endtrig = func_end_timer } );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Entity_Add ( tutorial_name, entity_name, entity_type )

  if ( "booster" == entity_type ) then

    if not ( private.Entity_IsAdded( tutorial_name, entity_name ) ) then

      m_boosters.TryChangeCount( entity_name, 1, "tutorial" );

      m_tutorial.Complete( tutorial_name.."_"..entity_name );

    end;
    
  elseif ( "stickerpack" == entity_type ) then

    if not ( private.Entity_IsAdded( tutorial_name, entity_name ) ) then

      m_fireflies.Stickerpack_TryObtain( 1 );

      m_tutorial.Complete( tutorial_name.."_"..entity_name );

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.Entity_IsAdded ( tutorial_name, entity_name )

  local query = 
  {
    query      = "find",
    group      = "player",
    collection = "tutorial",
    indice     = "name",
    criteria   = { like = tutorial_name.."_"..entity_name }
  };

  return m_storage.Execute( query ).result ~= nil;

end;
--------------------------------------------------------------------------------
function private.Entity_Free_Show ( tutorial_name, entity_name, object )

  if ( private.Entity_IsAdded( tutorial_name, entity_name ) ) then

    local obj_name = cmn.GetObjectName( object );

    local params = ObjGet( object );

    ObjCreate( "txt_"..obj_name.."_free", "text" );
    ObjAttach( "txt_"..obj_name.."_free", object );
    ObjSet( "txt_"..obj_name.."_free", 
    {
      res = "assets/fonts/sml_title",
      text = "str_tutorial_free",
      pos_x = 0.5 * math.abs( params.inputrect_x ) or 25,
      pos_y = math.abs( params.inputrect_y ) - 10 or 40, 
      pos_z = 10,
      scale_x = 0,
      scale_y = 0,
      ang = 0.3,
      align = 1,
      fontsize = 25,
      fontcolor_r = 1,
      fontcolor_g = 0,
      fontcolor_b = 0,
      display_outline = true,
      outline_size = 3,
      outline_color_r = 1, 
      outline_color_g = 1, 
      outline_color_b = 1 
    } );

    private.backup_entity_count = ObjGet( "anm_"..obj_name.."_icon" ).count;
    ObjSet( "anm_"..obj_name.."_icon", { count = "" } );

    ObjAnimate( "txt_"..obj_name.."_free", "scale_xy", 0, 0, function ()

      private.Entity_Free_Animate( "txt_"..obj_name.."_free", true );

    end, 
    { 
      0.0, 0, 0, 0, 
      0.3, 0, 1, 1 
    } );


  end;

end;
--------------------------------------------------------------------------------
function private.Entity_Free_Animate ( object, animate )

  if ( animate ) then

    ObjAnimate( object, "ang", 1, 0, "", 
    { 
      0.0, 3, 0.3, 
      0.6, 3, 0.0,
      1.2, 3, 0.3 
    } );

    return;

  end;

  ObjStopAnimate( object, "ang" );

end;
--------------------------------------------------------------------------------
function private.Entity_Free_Hide ( object )

  local obj_name = cmn.GetObjectName( object );

  local func_end_anim = function ()

    ObjDelete( "txt_"..obj_name.."_free" );

    ObjSet( "anm_"..obj_name.."_icon",
            { count = private.backup_entity_count } );

  end;

  private.Entity_Free_Animate( "txt_"..obj_name.."_free", false );

  ObjAnimate( "txt_"..obj_name.."_free", "scale_xy", 0, 0, func_end_anim, 
  { 
    0.0, 0, 1, 1, 
    0.3, 0, 0, 0 
  } );

end;
--------------------------------------------------------------------------------
function private.Entity_Index ( entities_list, pattern, point )

  for i = #entities_list, 1, - 1 do

    local query = 
    {
      query      = "find",
      group      = "static",
      collection = "boosters",
      indice     = "name",
      criteria   = { like = entities_list[ i ] }
    }

    local entity_type = m_storage.Execute( query ).result.type;

    if not ( entity_type == point ) then

      table.remove( entities_list, i );

    end;

  end;  

  local index = 1;

  for i = 1, #entities_list do

    if ( entities_list[ i ] == pattern ) then

      index = i;

      break;

    end;

  end;

  return index;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.Boosters_Backup ( tutorial_name, exclude_index, other, custom_name )

  local func_check = function ( index )

    if ( exclude_index ) then

      return not ( exclude_index == index );

    end;

    return true;  

  end;
  
  local parent_name = "obj_int_panel_stage_booster";
  
  if ( custom_name ) then
    
    parent_name = custom_name;
    
  end;

  for i = 1, 3 do

    if func_check( i ) then

      local object_name = parent_name.."_"..i;

      local backup_name = "otherbooster_tap_"..i;

      if ( other ) then

        object_name = parent_name.."_"..i.."_count";

        backup_name = "otherboosterbuy_tap_"..i;

      end;

      local tap_params = common.TapGet( object_name );

      if ( tap_params ) and ( tap_params.func_true ) then

        private.Backup( tutorial_name, backup_name, tap_params.func_true );

        common.TapSet( object_name, { func_true = function () end } );

      end;

    end;

  end;

end;
--------------------------------------------------------------------------------
function private.Boosters_Restore ( tutorial_name, exclude_index, other, custom_name )

  local func_check = function ( index )

    if ( exclude_index ) then

      return not ( exclude_index == index );

    end;

    return true;  

  end;
  
  local parent_name = "obj_int_panel_stage_booster";
  
  if ( custom_name ) then
    
    parent_name = custom_name;
    
  end;  

  for i = 1, 3 do

    local object_name = parent_name.."_"..i;

    local backup_name = "otherbooster_tap_"..i;

    if ( other ) then

      object_name = parent_name.."_"..i.."_count";

      backup_name = "otherboosterbuy_tap_"..i;

    end;

    if func_check( i ) then

      local func_restored = private.Restore( tutorial_name, backup_name );

      if ( func_restored ) then

        common.TapSet( object_name, { func_true = func_restored } );

      end;

    end;

  end;

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.intro ()

  private.Subscribe( "intro", "View_Tutorial_StartIntro", private.intro_first );

end;

function private.intro_first ( func_after )

  private.Unsubscribe( "intro", "View_Tutorial_StartIntro", private.intro_first );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 1,
    level = 0,
    name  = "tut_intro"
  } );

  local func_end = function ()

    private.intro_last1();
    
    if ( func_after ) then func_after(); end;

  end;

  v_map.Intro_Prepare( func_end );

  private.SetTimer( 0.5, function ()

    private.intro_next1( func_after );

  end );

end;

function private.intro_next1 ( func_after )

  local func_end = function ()

    private.intro_last1();
    
    if ( func_after ) then func_after(); end;

  end;

  v_map.Intro_Animate_Dragon( func_end );

end;

function private.intro_last1 ()

  private.Complete( "intro" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_1_tap ()

  if ( not m_tutorial.IsCompleted( "stage_1_tap" ) ) then
  
    private.Subscribe(
      "stage_1_tap",
      "View_Map_Update_Finished",
      private.stage_1_tap_next
    );
  
  end;

end;

function private.stage_1_tap_next ()

  private.Unsubscribe(
    "stage_1_tap",
    "View_Map_Update_Finished",
    private.stage_1_tap_next
  );
  
  -- Fix for cheater section switch.
  if not ( v_map.Section_Current() == "section_1" ) then
    private.Complete( "stage_1_tap" );
    return;
  end;
  
  private.Kontagent_LogEvent( "tutorial",
  {
    value = 2,
    level = 0,
    name  = "tut_level_1"
  } );
  
  local events = int.Control_EventsGet( "btn_map_point_stage_1" );
  local func_on_click = events.func_on_click;
  
  local func_close = function ()

    events.func_on_click = func_on_click;
    
    private.Dialog_Hide( private.stage_1_tap_last );
    func_on_click();

  end;

  events.func_on_click = func_close;
  
  local dialog_settings = private.Dialog_Settings( "obj_map_point_stage_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type   = "flashlight",

    res_id = 3,
    focus  = "obj_map_point_stage_1",
    scale  = 1,
  
    lock   = true,
    black  = true,
    hand   = {
      angle = 0.5 * math.pi,
      type  = "click"
    }
  };

  private.Dialog_ShowInstantly(
    "stage_1_tap_1", 
    positions,
    hole,
    func_close,
    nil,
    {
      active = true,
      input  = true,
      notify = false
    }
  );
  
  private.Complete( "stage_1_tap" );

end;

function private.stage_1_tap_last ()

  private.Kontagent_LogEvent( "tutorial",
  {
    value = 3,
    level = 0,
    name  = "tut_level_1_tap"
  } );

end;
--------------------------------------------------------------------------------
function private.stage_1_play ()

  private.Subscribe( "stage_1_play", "View_Stage_DialogStartDeactivated", private.stage_1_play_last );

end;

function private.stage_1_play_last ( stage_data )

  if ( stage_data.name == "stage_1" and stage_data.start and not m_tutorial.IsCompleted( "stage_1_play" ) ) then

    private.Unsubscribe( "stage_1_play", "View_Stage_DialogStartDeactivated", private.stage_1_play_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 4,
      level = 0,
      name  = "tut_level_1_play"
    } );  

    private.Complete( "stage_1_play" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_1 ()

  private.Subscribe(
    "stage_1",
    "View_Tutorial_StageOpened",
    private.stage_1_first
  );

end;

function private.stage_1_first ( stage_name )

  if ( stage_name == "stage_1"                 ) and
     ( not m_tutorial.IsCompleted( "stage_1" ) ) then

    private.Unsubscribe(
      "stage_1",
      "View_Tutorial_StageOpened",
      private.stage_1_first
    ); 

    private.Subscribe(
      "stage_1",
      "View_Stage_DialogTargetsHided",
      private.stage_1_next1
    );

  end;

end;

function private.stage_1_next1 ()
    
  private.Unsubscribe( "stage_1", "View_Stage_DialogTargetsHided", private.stage_1_next1 );
 
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 5,
    level = 0,
    name  = "tut_level_1_score"
  } );

  local focus_obj = "anm_int_panel_stage_top_goals_goal1";
  
  local dialog_settings =
    private.Dialog_Settings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = focus_obj,
    offset_x    = 0,
    offset_y    = 0,
    scale       = 1,
    angle       = 1.25 * math.pi,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_1_next2 );
    
  end;

  local text_param = m_stage.GetCurrentStageData().targets[ 1 ].count;

  private.Dialog_ShowInstantly( "stage_1_2", positions, hole, func_close, text_param );

end;

function private.stage_1_next2 ()

  private.Subscribe( "stage_1", "Model_Match3_FieldActivated", private.stage_1_last );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 6,
    level = 0,
    name  = "tut_level_1_swipe"
  } );

  local match3_pos = int.Position( "match" );
  
  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 3.1415,
    scale          = private.cell_scale,
    
    hand = {
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = - 1,
         type      = "move"
    },

    lock           = true
  };

  local func_close = function ()

    --

  end;

  private.Dialog_ShowInstantly( "stage_1_1", positions, hole, func_close );

end;

function private.stage_1_last ()

  private.Unsubscribe( "stage_1", "Model_Match3_FieldActivated", private.stage_1_last );

  private.Dialog_Hide();
  
  private.Complete( "stage_1" );

end;
--------------------------------------------------------------------------------
function private.stage_1_win ()

  private.Subscribe( "stage_1_win", "Model_Stage_StageWon", private.stage_1_win_last );

end;

function private.stage_1_win_last ( stage_data )

  if ( stage_data.name == "stage_1" and not m_tutorial.IsCompleted( "stage_1_win" ) ) then

    private.Unsubscribe( "stage_1_win", "Model_Stage_StageWon", private.stage_1_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 7,
      level = 0,
      name  = "tut_level_1_win"
    } );  

    private.Complete( "stage_1_win" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_1_reward ()

  private.Subscribe( "stage_1_reward", "View_Map_Update_StageRewardCollected", private.stage_1_reward_last );

end;

function private.stage_1_reward_last ( stage_name )

  if ( stage_name == "stage_1" and not m_tutorial.IsCompleted( "stage_1_reward" ) ) then

    private.Unsubscribe( "stage_1_reward", "View_Map_Update_StageRewardCollected", private.stage_1_reward_last );

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 8,
      level = 0,
      name  = "tut_level_1_reward"
    } );  

    private.Complete( "stage_1_reward" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.swordstone ()

  private.Subscribe( "swordstone", "View_Tutorial_MapOpened", private.swordstone_first );

end;

function private.swordstone_first ()

  if ( not m_tutorial.IsCompleted( "swordstone" ) ) then
    
    if ( (m_stage.GetSavedData( "stage_1" ) or {}).completed ) then

      private.Unsubscribe( "swordstone", "View_Tutorial_MapOpened", private.swordstone_first );
      private.Subscribe( "swordstone", "View_Map_Update_Build_Animated", private.swordstone_next1 );

    end;

  end;

end;

function private.swordstone_next1 ()
  
  private.Unsubscribe( 
    "swordstone",
    "View_Map_Update_Build_Animated",
    private.swordstone_next1
  );
  
  private.PendingBegin( "swordstone", "map" );
  private.Complete( "swordstone" );
  
  local pref_vertical = 75;
  
  if ( private.landscape ) then
    
    pref_vertical = 60;
    
  end;
  
  local dialog_settings =
    private.Dialog_Settings( "obj_map_builds_puzzle_1", pref_vertical );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "arrow",

    focus       = "obj_map_builds_puzzle_1",
    offset_x    = -40,
    offset_y    = -70,
    angle       = 1.5 * math.pi,
    scale       = -1,

    lock        = true
  };

  private.Dialog_ShowInstantly( "swordstone", positions, hole, private.swordstone_last1, nil, { active = true }, true );

end;

function private.swordstone_last1 ()

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 9,
    level = 0,
    name  = "tut_swordstone"
  } );

  private.Dialog_Hide( function ()
  
    private.PendingEnd( "swordstone", "map" );
  
  end );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_2_tap ()

  private.Subscribe( "stage_2_tap", "View_Stage_DialogStartActivated", private.stage_2_tap_last );

end;

function private.stage_2_tap_last ( stage_data )

  if ( stage_data.name == "stage_2" and not m_tutorial.IsCompleted( "stage_2_tap" ) ) then

    private.Unsubscribe( "stage_2_tap", "View_Stage_DialogStartActivated", private.stage_2_tap_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 10,
      level = 0,
      name  = "tut_level_2"
    } );  

    private.Complete( "stage_2_tap" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_2_play ()

  private.Subscribe( "stage_2_play", "View_Stage_DialogStartDeactivated", private.stage_2_play_last );

end;

function private.stage_2_play_last ( stage_data )

  if ( stage_data.name == "stage_2" and stage_data.start and not m_tutorial.IsCompleted( "stage_2_play" ) ) then

    private.Unsubscribe( "stage_2_play", "View_Stage_DialogStartDeactivated", private.stage_2_play_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 11,
      level = 0,
      name  = "tut_level_2_play"
    } );  

    private.Complete( "stage_2_play" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_2 ()

  private.Subscribe(
    "stage_2",
    "View_Tutorial_StageOpened",
    private.stage_2_first
  );

end;

function private.stage_2_first ( stage_name )

  if ( stage_name == "stage_2"                 ) and
     ( not m_tutorial.IsCompleted( "stage_2" ) ) then

    private.Unsubscribe(
      "stage_2",
      "View_Tutorial_StageOpened",
      private.stage_2_first
    ); 
  
    private.Subscribe(
      "stage_2",
      "View_Stage_DialogTargetsHided",
      private.stage_2_next1
    );

  end;

end;

function private.stage_2_next1 ()

  private.Unsubscribe(
    "stage_2",
    "View_Stage_DialogTargetsHided",
    private.stage_2_next1
  );

  private.Subscribe(
    "stage_2",
    "Model_Match3_FieldActivated",
    private.stage_2_hide1
  );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 12,
    level = 0,
    name  = "tut_level_2_match4"
  } );

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h / 2 - 100
  };

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 2,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = - 0.5 * math.pi,
         offset_x  = private.cell_size,
         offset_y  = 0,
         type      = "move"
    }
  };

  local func_close = function ()

    --

  end;

  private.Dialog_ShowInstantly( "stage_2_1", positions, hole, func_close );

  private.stage_2_last1();

end;

function private.stage_2_hide1 ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 13,
    level = 0,
    name  = "tut_level_2_match4done"
  } );  

  private.Unsubscribe(
    "stage_2",
    "Model_Match3_FieldActivated",
    private.stage_2_hide1
  );

  private.Dialog_Hide();

end;

function private.stage_2_last1 ()

  private.Complete( "stage_2" );

end;
--------------------------------------------------------------------------------
function private.stage_2_win ()

  private.Subscribe( "stage_2_win", "Model_Stage_StageWon", private.stage_2_win_last );

end;

function private.stage_2_win_last ( stage_data )

  if ( stage_data.name == "stage_2" and not m_tutorial.IsCompleted( "stage_2_win" ) ) then

    private.Unsubscribe( "stage_2_win", "Model_Stage_StageWon", private.stage_2_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 14,
      level = 0,
      name  = "tut_level_2_win"
    } );  

    private.Complete( "stage_2_win" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_2_reward ()

  private.Subscribe( "stage_2_reward", "View_Map_Update_StageRewardCollected", private.stage_2_reward_last );

end;

function private.stage_2_reward_last ( stage_name )

  if ( stage_name == "stage_2" and not m_tutorial.IsCompleted( "stage_2_reward" ) ) then

    private.Unsubscribe( "stage_2_reward", "View_Map_Update_StageRewardCollected", private.stage_2_reward_last );

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 15,
      level = 0,
      name  = "tut_level_2_reward"
    } );  

    private.Complete( "stage_2_reward" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.quest ()

  private.Subscribe( "quest", "View_Tutorial_MapOpened",
    private.quest_first
  );
  
end;

function private.quest_first ()

  if ( not m_tutorial.IsCompleted( "quest" ) ) then

    if ( ( m_stage.GetSavedData( "stage_2" ) or {} ).completed ) then

      private.Unsubscribe( "quest", "View_Tutorial_MapOpened",
                           private.quest_first );

      private.Subscribe( "quest", "View_Map_Update_Character_PopupDisplayed",
                         private.quest_next1 );

    end;

  end;

end; 

function private.quest_next1 ( character_name )

  if not ( character_name == "wizard" ) then
    return;
  end;
  
  private.Unsubscribe( 
    "quest",
    "View_Map_Update_Character_PopupDisplayed",
    private.quest_next1
  );
  
  private.PendingBegin( "quest", "map" );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 16,
    level = 0,
    name  = "tut_cage"
  } );

  local func_close = function ()

    local func_OnTutorialHide = function ()

      private.quest_last1();

      mediator.Notify( "View_Tutorial_TutorialQuestCompleted" );

    end;

    private.Dialog_Hide( func_OnTutorialHide );

  end;
  
  local pref_vertical = 25;
  
  if ( private.landscape ) then
    
    pref_vertical = nil;
    
  end;
  
  local dialog_settings =
    private.Dialog_Settings( "obj_map_characters_wizard", pref_vertical );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "obj_map_characters_wizard",
    offset_x    = 0,
    offset_y    = - 90,
    angle       = 0,
    scale       = 1.0,

    lock        = true
  };

  private.Dialog_ShowInstantly( "quest", positions, hole, func_close, 
                                nil, { active = true } );

end;

function private.quest_last1 ()

  private.Complete( "quest" );
  private.PendingEnd( "quest", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_3_tap ()

  private.Subscribe( "stage_3_tap", "View_Stage_DialogStartActivated", private.stage_3_tap_last );

end;

function private.stage_3_tap_last ( stage_data )

  if ( stage_data.name == "stage_3" and not m_tutorial.IsCompleted( "stage_3_tap" ) ) then

    private.Unsubscribe( "stage_3_tap", "View_Stage_DialogStartActivated", private.stage_3_tap_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 17,
      level = 0,
      name  = "tut_level_3"
    } );  

    private.Complete( "stage_3_tap" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_3_play ()

  private.Subscribe( "stage_3_play", "View_Stage_DialogStartDeactivated", private.stage_3_play_last );

end;

function private.stage_3_play_last ( stage_data )

  if ( stage_data.name == "stage_3" and stage_data.start and not m_tutorial.IsCompleted( "stage_3_play" ) ) then

    private.Unsubscribe( "stage_3_play", "View_Stage_DialogStartDeactivated", private.stage_3_play_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 18,
      level = 0,
      name  = "tut_level_3_play"
    } );  

    private.Complete( "stage_3_play" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_3 ()

  private.Subscribe(
    "stage_3",
    "View_Tutorial_StageOpened",
    private.stage_3_first
  );

end;

function private.stage_3_first ( stage_name )

  if ( stage_name == "stage_3"                 ) and
     ( not m_tutorial.IsCompleted( "stage_3" ) ) then

    private.Unsubscribe(
      "stage_3",
      "View_Tutorial_StageOpened",
      private.stage_3_first
    ); 
  
    private.Subscribe(
      "stage_3",
      "View_Stage_DialogTargetsHided",
      private.stage_3_next1
    );

  end;

end;

function private.stage_3_next1 ()

  private.Unsubscribe(
    "stage_3",
    "View_Stage_DialogTargetsHided",
    private.stage_3_next1
  );

  private.Subscribe(
    "stage_3",
    "Model_Match3_FieldActivated",
    private.stage_3_hide1
  );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 19,
    level = 0,
    name  = "tut_level_3_matchl"
  } );  

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 13,
    pos_x          = pos_x - private.cell_size,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = -2 * private.cell_size,
         offset_y  = -2 * private.cell_size,
         type      = "move"
    }
  };

  local func_close = function ()

    --

  end;

  private.Dialog_ShowInstantly( "stage_3_1", positions, hole, func_close );

  private.stage_3_last1();

end;

function private.stage_3_hide1 ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 20,
    level = 0,
    name  = "tut_level_3_matchldone"
  } );   

  private.Unsubscribe(
    "stage_3",
    "Model_Match3_FieldActivated",
    private.stage_3_hide1
  );

  private.Dialog_Hide();
  
end;

function private.stage_3_last1 ()

  private.Complete( "stage_3" );

end;
--------------------------------------------------------------------------------
function private.stage_3_win ()

  private.Subscribe( "stage_3_win", "Model_Stage_StageWon", private.stage_3_win_last );

end;

function private.stage_3_win_last ( stage_data )

  if ( stage_data.name == "stage_3" and 
       not m_tutorial.IsCompleted( "stage_3_win" ) ) then

    private.Unsubscribe( "stage_3_win",
                     "Model_Stage_StageWon",
                     private.stage_3_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 21,
      level = 0,
      name  = "tut_level_3_win"
    } );  

    private.Complete( "stage_3_win" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_4_tap ()

  private.Subscribe( "stage_4_tap", "View_Stage_DialogStartActivated", private.stage_4_tap_last );

end;

function private.stage_4_tap_last ( stage_data )

  if ( stage_data.name == "stage_4" and not m_tutorial.IsCompleted( "stage_4_tap" ) ) then

    private.Unsubscribe( "stage_4_tap", "View_Stage_DialogStartActivated", private.stage_4_tap_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 22,
      level = 0,
      name  = "tut_level_4"
    } );  

    private.Complete( "stage_4_tap" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_4_play ()

  private.Subscribe( "stage_4_play", "View_Stage_DialogStartDeactivated", private.stage_4_play_last );

end;

function private.stage_4_play_last ( stage_data )

  if ( stage_data.name == "stage_4" and stage_data.start and not m_tutorial.IsCompleted( "stage_4_play" ) ) then

    private.Unsubscribe( "stage_4_play", "View_Stage_DialogStartDeactivated", private.stage_4_play_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 23,
      level = 0,
      name  = "tut_level_4_play"
    } );  

    private.Complete( "stage_4_play" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_4 ()

  private.Subscribe(
    "stage_4",
    "View_Tutorial_StageOpened",
    private.stage_4_first
  );

end;

function private.stage_4_first ( stage_name )

  if ( stage_name == "stage_4"                 ) and
     ( not m_tutorial.IsCompleted( "stage_4" ) ) then

    private.Unsubscribe(
      "stage_4",
      "View_Tutorial_StageOpened",
      private.stage_4_first
    ); 

    private.Subscribe(
      "stage_4",
      "View_Stage_DialogTargetsHided",
      private.stage_4_next1
    );

  end;

end;

function private.stage_4_next1 ()

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 24,
    level = 0,
    name  = "tut_level_4_fireflies"
  } );

  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "hammer", "stage" ); 

  private.Unsubscribe( "stage_4", "View_Stage_DialogTargetsHided", private.stage_4_next1 );

  private.Backup( "stage_4", "booster_tap", common.TapGet( "obj_int_panel_stage_booster_"..index ).func_true );

  common.TapClear( "obj_int_panel_stage_booster_"..index );

  local focus_obj = "anm_int_panel_stage_top_goals_goal2";
  
  local dialog_settings =
    private.Dialog_Settings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = focus_obj,
    offset_x    = 0,
    offset_y    = 0,
    scale       = 1,
    angle       = math.pi,

    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( function () private.stage_4_next2( index ); end );
    
  end;

  private.Dialog_ShowInstantly( "stage_4_1", positions, hole, func_close );

end;

function private.stage_4_next2 ( index )

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 25,
    level = 0,
    name  = "tut_level_4_hammer"
  } );

  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = int.Position( "obj_int_panel_stage_booster_"..index )[ 2 ] - 200,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( function () 

      private.stage_4_next3( index ); 

    end );

  end;

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Dialog_ShowInstantly( "stage_4_2", positions, hole );
  
  private.Entity_Add( "stage_4", "hammer", "booster" );

  private.Entity_Free_Show( "stage_4", "hammer", "obj_int_panel_stage_booster_"..index );

end;

function private.stage_4_next3 ( index )

  private.Subscribe( "stage_4", "View_Boosters_BoosterUsed", private.stage_4_last1 );
  private.Subscribe(
    "stage_4",
    "View_Boosters_BoosterUsageFailed",
    private.stage_4_booster_reset
  );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 26,
    level = 0,
    name  = "tut_level_4_hammerdone"
  } );

  local func_booster_tap = private.Restore( "stage_4", "booster_tap" );

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_booster_tap } );

  if ( func_booster_tap ) then

    func_booster_tap();

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5 + private.cell_size;
  
  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );
  
  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type           = "flashlight",

    res_id         = 3,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = 0.7,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "stage_4_3", positions, hole );  

end;

function private.stage_4_booster_reset ()

  local boosters = m_stage.GetCurrentStageData().boosters;
  local index = private.Entity_Index( boosters, "hammer", "stage" );
  common.TapGet( "obj_int_panel_stage_booster_"..index ).func_true();

end;

function private.stage_4_last1 ()

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 27,
    level = 0,
    name  = "tut_level_4_hammeruse"
  } );

  private.Unsubscribe( "stage_4", "View_Boosters_BoosterUsed", private.stage_4_last1 );
  
  private.Unsubscribe(
    "stage_4",
    "View_Boosters_BoosterUsageFailed",
    private.stage_4_booster_reset
  );
  
  private.Dialog_Hide();
  private.Complete( "stage_4" );

end;
--------------------------------------------------------------------------------
function private.stage_4_win ()

  private.Subscribe( "stage_4_win", "Model_Stage_StageWon", private.stage_4_win_last );

end;

function private.stage_4_win_last ( stage_data )

  if ( stage_data.name == "stage_4" and 
    not m_tutorial.IsCompleted( "stage_4_win" ) ) then

    private.Unsubscribe( "stage_4_win",
                     "Model_Stage_StageWon",
                     private.stage_4_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 28,
      level = 0,
      name  = "tut_level_4_win"
    } );  

    private.Complete( "stage_4_win" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.fireflies_album ()

  if ( ( m_stage.GetSavedData( "stage_5" ) or {} ).completed ) and
     ( not m_tutorial.IsCompleted( "fireflies_album" )       ) then

    -- Add a stickerpack and force complete.
    private.Entity_Add( "fireflies_album", "stickerpack", "stickerpack" );

    private.Kontagent_LogEvent( "tutorial",
    {
      value = 0,
      level = 7,
      name  = "tut_album"
    } );

    private.Complete( "fireflies_album" );
    private.fireflies_album_last();

  else

    private.Subscribe(
      "fireflies_album",
      "Model_Fireflies_BoosterCountChanged",
      private.fireflies_album_first
    );

  end;

end;

function private.fireflies_album_first ( params )

  if ( params.change > 0 ) then
  
    private.Unsubscribe(
      "fireflies_album",
      "Model_Fireflies_BoosterCountChanged",
      private.fireflies_album_first
    );

    if ( not m_tutorial.IsCompleted( "fireflies_album" ) ) then
    
      private.Subscribe(
        "fireflies_album",
        "View_Map_Update_StageRewardDisplayed",
        private.fireflies_album_first2
      );

    end;
    
  end;

end;

function private.fireflies_album_first2 ()
  
  private.Unsubscribe(
    "fireflies_album",
    "View_Map_Update_StageRewardDisplayed",
    private.fireflies_album_first2
  );
  
  private.PendingBegin( "fireflies_album", "map" );
  
  private.fireflies_album_next();

end;

function private.fireflies_album_next ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 7,
    name  = "tut_album"
  } );  
  
  local dialog_settings =
    private.Dialog_Settings( "btn_int_panel_map_fireflies" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type  = "flashlight",
    focus = "btn_int_panel_map_fireflies",
    
    res_id   = 3,
    offset_x = 0,
    offset_y = -70,
    angle    = 0,
    scale    = 1.25,

    lock     = true,
    black    = true,
    wait     = true,
    hand = {  
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = - 1,
         angle     = - 0.5 * math.pi, 
         type      = "click"
    }    
  };
  
  local func_close = function ()
    
    local func_album_tap = private.Restore( "fireflies_album", "fireflies_album_tap" );

    common.TapSet( "btn_int_panel_map_fireflies", { func_true = func_album_tap } );
    
    private.Dialog_Hide( function()
      
      if ( func_album_tap ) then func_album_tap(); end;
      
      private.fireflies_album_last();
    
    end );
      
  end;
  
  private.Backup(
    "fireflies_album",
    "fireflies_album_tap",
    common.TapGet( "btn_int_panel_map_fireflies" ).func_true
  );

  common.TapSet( "btn_int_panel_map_fireflies", { func_true = func_close } );

  private.Dialog_ShowInstantly( "fireflies_album_1", positions, hole,
                                nil, nil, { active = true, notify = false } );
  
  private.Complete( "fireflies_album" );

end;

function private.fireflies_album_last ()
  
  private.Kontagent_LogEvent( "tutorial",
  {
    value = 0,
    level = 8,
    name  = "tut_albumdone"
  } );
  
  private.PendingEnd( "fireflies_album", "map" );
    
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stickerpack ()

  private.Subscribe(
    "stickerpack",
    "Interface_DialogFireflies_Opened",
    private.stickerpack_next
  );

end;

function private.stickerpack_next ()
    
  private.Unsubscribe(
    "stickerpack",
    "Interface_DialogFireflies_Opened",
    private.stickerpack_next
  );

  if ( m_tutorial.IsCompleted( "stickerpack" ) ) then
    
    return;
    
  end;

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 9,
    name  = "tut_stickerpack"
  } );

  local focus_obj = "btn_int_dialog_fireflies_stickerpack_get"; 
  
  local dialog_settings = private.Dialog_Settings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "flashlight",
    focus    = focus_obj,
    
    res_id   = 3,
    offset_x = 0,
    offset_y = 0,
    angle    = 0,
    scale_x  = 2.1,
    scale_y  = 1.0,
    
    lock     = true,
    black    = true,
    wait     = true,
    hand = {  
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = - 1,
         angle     = - 1.57, 
         type      = "click"
    }
  };    
  
  local func_close = function ()

    private.Dialog_Hide( function()
      
      -- JK: lock here, unlock in next tutorial ( private.stickerpool )
      int.Lock( true );
    
      private.stickerpack_last();
     
      local func_stickerpack_tap =
        private.Restore( "stickerpack", "stickerpack_tap" );

      int.Button_EventSet(
        "btn_int_dialog_fireflies_stickerpack_get",
        func_stickerpack_tap
      );

      if ( func_stickerpack_tap ) then

        func_stickerpack_tap();

      end;
     
    end );
    
  end;

  private.Backup(
    "stickerpack",
    "stickerpack_tap",
    int.Button_EventGet( "btn_int_dialog_fireflies_stickerpack_get" )
  );

  int.Button_EventSet(
    "btn_int_dialog_fireflies_stickerpack_get",
    func_close
  );
  
  private.Dialog_ShowInstantly( "stickerpack_1", positions, hole, func_close );
  
end;

function private.stickerpack_last ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 10,
    name  = "tut_stickerpackdone"
  } );  

  private.Complete( "stickerpack" );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stickerpool ()

  private.Subscribe(
    "stickerpool",
    "Interface_DialogFireflies_HasStickable",
    private.stickerpool_first
  );

end;

function private.stickerpool_first ( stickable_stickers )

  local sticker = stickable_stickers[ 1 ];
  
  private.Unsubscribe(
    "stickerpool",
    "Interface_DialogFireflies_HasStickable",
    private.stickerpool_first
  );
    
  if ( not m_tutorial.IsCompleted( "stickerpool" ) ) then

    int_dialog_fireflies.Tutorial_GoToSticker( sticker );
  
    private.SetTimer( 0.5, function ()
      private.stickerpool_next1( sticker );
    end );

  end;

end;

function private.stickerpool_next1 ( sticker )

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 11,
    name  = "tut_sticker_move"
  } );
  
  local focus_obj = "obj_int_dialog_fireflies_stickerpool";
  
  local dialog_settings = private.Dialog_Settings( focus_obj, 75 );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local start_pos  =
    int_dialog_fireflies.Tutorial_GetStickerPoolPos( sticker.name );
  local finish_pos =
    int_dialog_fireflies.Tutorial_StickerPosition( sticker.index );
  
  int_dialog_fireflies.Tutorial_SetButtonsInput( false );
  int_window.OuterTap_Disable();
    
  local hole = 
  {
    type   = "sticker",
    start  = start_pos,
    finish = finish_pos,
    lock   = false,
    black  = false,
  };
  
  private.Subscribe(
    "stickerpool",
    "Interface_DialogFireflies_StickerSticked",
    private.stickerpool_last1
  );

  private.Dialog_ShowInstantly( "stickerpool_1", positions, hole );

  -- JK: unlock here, locked in previous tutorial ( private.stickerpack )
  int.Lock( false );
  
end;

function private.stickerpool_last1 ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 12,
    name  = "tut_sticker_movedone"
  } );    
  
  int_dialog_fireflies.Tutorial_SetButtonsInput( true );
  int_window.OuterTap_Enable();
  
  private.Complete( "stickerpool" );

  private.Unsubscribe(
    "stickerpool",
    "Interface_DialogFireflies_StickerSticked",
    private.stickerpool_last1
  );

  private.Dialog_Hide();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stickerpack_buy ()

  private.Subscribe(
    "stickerpack_buy",
    "Interface_DialogFireflies_BuyMode",
    private.stickerpack_buy_first
  );

end;

function private.stickerpack_buy_first ()

  if ( not m_tutorial.IsCompleted( "stickerpool" ) ) then

    return;

  end;

  private.Unsubscribe(
    "stickerpack_buy",
    "Interface_DialogFireflies_BuyMode",
    private.stickerpack_buy_first
  );
  
  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_fireflies_stickerpack_buy" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
 
  local hole = 
  {
    type  = "arrow",
    focus = "btn_int_dialog_fireflies_stickerpack_buy",
    
    offset_x = 0,
    offset_y = 0,
    angle    = 0,
    scale    = 1.0, 

    lock     = true
  };
  
  private.Dialog_ShowInstantly( "stickerpack_buy_1", positions, hole, function()
 
    private.Dialog_Hide( private.stickerpack_buy_last );
 
  end );
  
end;

function private.stickerpack_buy_last ()
  
  private.Complete( "stickerpack_buy" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_5_win ()

  private.Subscribe( "stage_5_win", "Model_Stage_StageWon", private.stage_5_win_last );

end;

function private.stage_5_win_last ( stage_data )

  if ( stage_data.name == "stage_5" and 
    not m_tutorial.IsCompleted( "stage_5_win" ) ) then

    private.Unsubscribe( "stage_5_win",
                     "Model_Stage_StageWon",
                     private.stage_5_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 29,
      level = 0,
      name  = "tut_level_5_win"
    } );  

    private.Complete( "stage_5_win" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_6_tap ()

  private.Subscribe( "stage_6_tap", "View_Stage_DialogStartActivated", private.stage_6_tap_last );

end;

function private.stage_6_tap_last ( stage_data )

  if ( stage_data.name == "stage_6" and not m_tutorial.IsCompleted( "stage_6_tap" ) ) then

    private.Unsubscribe( "stage_6_tap", "View_Stage_DialogStartActivated", private.stage_6_tap_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 30,
      level = 0,
      name  = "tut_level_6"
    } );  

    private.Complete( "stage_6_tap" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_6_play ()

  private.Subscribe( "stage_6_play", "View_Stage_DialogStartDeactivated", private.stage_6_play_last );

end;

function private.stage_6_play_last ( stage_data )

  if ( stage_data.name == "stage_6" and stage_data.start and not m_tutorial.IsCompleted( "stage_6_play" ) ) then

    private.Unsubscribe( "stage_6_play", "View_Stage_DialogStartDeactivated", private.stage_6_play_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 31,
      level = 0,
      name  = "tut_level_6_play"
    } );  

    private.Complete( "stage_6_play" );

  end;    

end;
--------------------------------------------------------------------------------
function private.stage_6 ()

  private.Subscribe(
    "stage_6",
    "View_Tutorial_StageOpened",
    private.stage_6_first
  );

end;

function private.stage_6_first ( stage_name )

  if ( stage_name == "stage_6"                 ) and
     ( not m_tutorial.IsCompleted( "stage_6" ) ) then

    private.Unsubscribe(
      "stage_6",
      "View_Tutorial_StageOpened",
      private.stage_6_first
    );

    private.Subscribe(
      "stage_6",
      "View_Stage_DialogTargetsHided",
      private.stage_6_next1
    );

  end;

end;

function private.stage_6_next1 ()

  private.Unsubscribe(
    "stage_6",
    "View_Stage_DialogTargetsHided",
    private.stage_6_next1
  );

  private.Subscribe(
    "stage_6",
    "Model_Match3_FieldActivated",
    private.stage_6_hide1
  );

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 32,
    level = 0,
    name  = "tut_level_6_match5"
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3;
  
  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type           = "flashlight",

    res_id         = 5,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local func_close = function ()

    --
    
  end;

  private.Dialog_ShowInstantly( "stage_6_1", positions, hole, func_close );

  private.stage_6_last();

end;

function private.stage_6_hide1 ()

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 33,
    level = 0,
    name  = "tut_level_6_match5done"
  } );

  private.Unsubscribe(
    "stage_6",
    "Model_Match3_FieldActivated",
    private.stage_6_hide1
  );

  private.Dialog_Hide();

end;

function private.stage_6_last ()

  private.Complete( "stage_6" );

end;
--------------------------------------------------------------------------------
function private.stage_6_win ()

  private.Subscribe( "stage_6_win", "Model_Stage_StageWon", private.stage_6_win_last );

end;

function private.stage_6_win_last ( stage_data )

  if ( stage_data.name == "stage_6" and 
    not m_tutorial.IsCompleted( "stage_6_win" ) ) then

    private.Unsubscribe( "stage_6_win",
                     "Model_Stage_StageWon",
                     private.stage_6_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 34,
      level = 0,
      name  = "tut_level_6_win"
    } );  

    private.Complete( "stage_6_win" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.dailyquest_countdown ()

  private.Subscribe(
    "dailyquest_countdown",
    "Model_DailyQuest_CountdownStarted",
    private.dailyquest_countdown_first
  );

end;

function private.dailyquest_countdown_first ()

  private.Unsubscribe(
    "dailyquest_countdown",
    "Model_DailyQuest_CountdownStarted",
    private.dailyquest_countdown_first
  );

  if not ( m_tutorial.IsCompleted( "dailyquest_countdown" ) ) then

    private.dailyquest_countdown_next1();

  end;

end;

function private.dailyquest_countdown_next1 ()

  private.Subscribe(
    "dailyquest_countdown",
    "View_Map_Update_Finished",
    private.dailyquest_countdown_next2
  );

end;

function private.dailyquest_countdown_next2 ()

  private.Unsubscribe(
    "dailyquest_countdown",
    "View_Map_Update_Finished",
    private.dailyquest_countdown_next2
  );
  
  private.PendingBegin( "dailyquest_countdown", "map" );

  local dialog_settings = private.Dialog_Settings(
    "btn_int_panel_map_dailyquest",
    55
  );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "arrow",
    focus    = "btn_int_panel_map_dailyquest",
    
    offset_x = 50,
    offset_y = 0,
    angle    = -1.57,
    scale    = 1.0,

    lock     = false,
    black    = false
  };

  local func_close = function ()

    private.Dialog_Hide( private.dailyquest_countdown_last1, true );

  end;

  private.Dialog_ShowInstantly(
    "dailyquest_countdown_1",
    positions,
    hole,
    func_close,
    nil,
    { active = true, input = false, notify = false }
  );

end;

function private.dailyquest_countdown_last1 ()

  private.Complete( "dailyquest_countdown" );
  private.PendingEnd( "dailyquest_countdown", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_7 ()

  private.Subscribe(
    "stage_7",
    "View_Tutorial_StageOpened",
    private.stage_7_first
  );

end;

function private.stage_7_first ( stage_name )

  if ( stage_name == "stage_7"                 ) and
     ( not m_tutorial.IsCompleted( "stage_7" ) ) then
    
    private.Unsubscribe(
      "stage_7",
      "View_Tutorial_StageOpened",
      private.stage_7_first
    );
    
    private.Subscribe(
      "stage_7",
      "View_Stage_DialogTargetsHided",
      private.stage_7_next1
    );

  end;

end;

function private.stage_7_next1 ()

  private.Unsubscribe(
    "stage_7",
    "View_Stage_DialogTargetsHided",
    private.stage_7_next1
  );
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;
  
  local v_pref = 25;
  
  if ( int.Landscape() ) then
    
    v_pref = nil;
    
  end;
  
  local dialog_settings = private.Dialog_Settings(
    { pos_x, pos_y },
    v_pref
  );
    
  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 10,
    pos_x          = pos_x + private.cell_size,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = false,
    black          = true,
    input          = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_7_last1 );

  end;

  private.Dialog_ShowInstantly( "stage_7_1", positions, hole, func_close );

end;

function private.stage_7_last1 ()

  private.Complete( "stage_7" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.achievements ()

  private.Subscribe(
    "achievements",
    "Model_Achievements_Completed",
    private.achievements_first
  );  

end;

function private.achievements_first ( achievement_data )

  if ( not m_tutorial.IsCompleted( "achievements" ) ) and
     ( achievement_data.name == "only_forward"      ) then

    private.Unsubscribe(
      "achievements",
      "Model_Achievements_Completed",
      private.achievements_first
    );
    
    private.Subscribe(
      "achievements",
      "View_Map_Update_Finished",
      private.achievements_next1
    );

  end;

end;

function private.achievements_next1 ()

  private.Unsubscribe(
    "achievements",
    "View_Map_Update_Finished",
    private.achievements_next1
  );
  
  private.PendingBegin( "achievements", "map" );
  
  local dialog_settings =
    private.Dialog_Settings( "btn_int_panel_map_hero" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type     = "flashlight",
    focus    = "btn_int_panel_map_hero", 
    
    res_id   = 3,
    offset_x = 0,
    offset_y = -70,
    angle    = 0,
    scale    = 1.0, 

    lock     = true,
    black    = false,
    wait     = true,
    hand = {  
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = - 1,
         angle     = - 0.785, 
         type      = "click"
    }
  };

  local func_close = function ()
    
    local func_achievements_tap = private.Restore(
      "achievements",
      "achievements_tap"
    );

    common.TapSet( "btn_int_panel_map_hero", 
    {
      func_true = func_achievements_tap
    } );
    
    private.Subscribe(
      "achievements",
      "Interface_Hero_AchievementUpdated",
      private.achievements_next2
    );
    
    private.Dialog_Hide( function ()
    
      if ( func_achievements_tap ) then

        func_achievements_tap( nil, "achievements" );

      end;
    
    end );

  end;

  private.Backup(
    "achievements",
    "achievements_tap",
    common.TapGet( "btn_int_panel_map_hero" ).func_true
  );

  common.TapSet( "btn_int_panel_map_hero", { func_true = func_close } );

  private.Dialog_ShowInstantly( "achievements_1", positions, hole, func_close,
                                nil, { active = true, notify = false } );
  
  private.achievements_last1();
 
end;

function private.achievements_next2 ( achievement_name )
  
  if not ( achievement_name == "only_forward" ) then
    
    return;
    
  end;
  
  private.Unsubscribe(
    "achievements",
    "Interface_Hero_AchievementUpdated",
    private.achievements_next2
  );
  
  int_dialog_hero.AchievementsTab_DisableScrolling();
  
  local focus_obj = "anm_int_dialog_hero_achievements_slot_only_forward";
  
  local dialog_settings = private.Dialog_Settings( focus_obj );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local scale_x,  scale_y  = 1, 1;
  local offset_x, offset_y = 0, 16;
  
  if ( private.landscape ) then
    
    scale_x,  scale_y  = 0.75, 0.75;
    offset_x, offset_y = 0, 15;
    
  end;
  
  local hole = 
  {
    type     = "flashlight",
    focus    = focus_obj, 
    
    res_id   = 8,
    angle    = 0,
    scale_x  = scale_x,
    scale_y  = scale_y,
    offset_x = offset_x,
    offset_y = offset_y, 

    lock     = true,
    black    = true,
    wait     = true,
    hand = {  
      offset_x = -10,
      offset_y = 40,
      angle    = 0, 
      type     = "click"
    }
  };

  local func_close = function ()

    local func_achievements_reward =
      private.Restore(
        "achievements",
        "achievements_reward"
      );

    int.Button_EventSet(
      "btn_int_dialog_hero_achievements_slot_button_only_forward",
      func_achievements_reward
    );
  
    private.Dialog_Hide( function ()
    
      if ( func_achievements_reward ) then

        func_achievements_reward();

      end;
      
      int_dialog_hero.AchievementsTab_EnableScrolling();
   
    end );
    
  end;

  private.Backup(
    "achievements",
    "achievements_reward",
    int.Button_EventGet(
      "btn_int_dialog_hero_achievements_slot_button_only_forward"
    )
  );

  int.Button_EventSet(
    "btn_int_dialog_hero_achievements_slot_button_only_forward",
    func_close
  );

  private.Dialog_ShowInstantly( "achievements_2", positions, hole );

end;

function private.achievements_last1 ()

  private.Complete( "achievements" );
  private.PendingEnd( "achievements", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.questlist ()

  private.Subscribe( "questlist", "View_Map_Update_Finished", private.questlist_first );

end;

function private.questlist_first ()

  if ( not m_tutorial.IsCompleted( "questlist" ) ) then

    if ( ( m_stage.GetSavedData( "stage_8" ) or {} ).completed ) then

      private.Unsubscribe(
        "questlist",
        "View_Map_Update_Finished",
        private.questlist_first
      );
      
      private.PendingBegin( "questlist", "map" );
     
      private.questlist_next1();
      
    end;

  end;

end;

function private.questlist_next1 ()

  local func_close = function ( execute_tap )

    local func_questlist_tap = private.Restore( "questlist", "questlist_tap" );

    common.TapSet( "btn_int_panel_questlist", { func_true = func_questlist_tap } );

    private.Dialog_Hide( private.questlist_last1 );

    if ( execute_tap ) then

      func_questlist_tap();

    end;

  end;

  private.Backup( "questlist", "questlist_tap", common.TapGet( "btn_int_panel_questlist" ).func_true );

  common.TapSet( "btn_int_panel_questlist", { func_true = function () func_close( true ); end } );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_panel_questlist" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "btn_int_panel_questlist",
    offset_x    = - 50,
    offset_y    = 100,
    angle       = 1.575707,
    scale       = 1.0,

    lock        = false
  };

  private.Dialog_ShowInstantly(
    "questlist", 
    positions,
    hole,
    func_close,
    nil,
    { active = true, input = false, notify = false }
  );

end;

function private.questlist_last1 ()

  private.Complete( "questlist" );
  private.PendingEnd( "questlist", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.questlist_quest ()

  private.Subscribe( "questlist_quest", "View_Questlist_Opened", private.questlist_quest_first );

end;

function private.questlist_quest_first ( quests_list )

  if ( not m_tutorial.IsCompleted( "questlist_quest" ) and
       #quests_list > 0 ) then

    private.Unsubscribe( "questlist_quest", "View_Questlist_Opened", private.questlist_quest_first );
     
    local quest_name = quests_list[ 1 ].name;
    if ( quests_list[ 2 ] ) then
      quest_name = quests_list[ 2 ].name;
    end;
    
    private.questlist_quest_next1( quest_name );

  end;

end;

function private.questlist_quest_next1 ( quest_name )
  
  local func_close = function ( execute_tap )

    local func_questlist_quest_tap = private.Restore( "questlist_quest", "questlist_quest_tap" );

    common.TapSet( "anm_int_panel_questlist_cell_"..quest_name, { func_true = func_questlist_quest_tap } );

    private.Dialog_Hide( private.questlist_quest_last1 );

    if ( execute_tap ) then

      func_questlist_quest_tap();

    end;

  end;

  private.Backup( "questlist_quest", "questlist_quest_tap", common.TapGet( "anm_int_panel_questlist_cell_"..quest_name ).func_true );

  common.TapSet( "anm_int_panel_questlist_cell_"..quest_name, { func_true = function () func_close( true ); end } );

  local dialog_settings = 
    private.Dialog_Settings( "anm_int_panel_questlist_cell_"..quest_name );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type  = "flashlight",
    focus = "anm_int_panel_questlist_cell_"..quest_name,
    
    res_id   = 14,
    offset_x = -155,
    offset_y = -2,
    angle    = 0,
    scale_x    = 1,
    scale_y    = 1,

    lock     = true,
    black    = true,
    wait     = true,
    hand = {  
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = -1,
         angle     = 0, 
         type      = "click"
    }    
  };

  private.Dialog_ShowInstantly( "questlist_quest_1", positions, hole, func_close );

end;

function private.questlist_quest_last1 ()

  private.Complete( "questlist_quest" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_9 ()

  private.Subscribe(
    "stage_9",
    "View_Tutorial_StageOpened",
    private.stage_9_first
  );

end;

function private.stage_9_first ( stage_name )

  if ( stage_name == "stage_9"                 ) and
     ( not m_tutorial.IsCompleted( "stage_9" ) ) then

    private.Unsubscribe(
      "stage_9",
      "View_Tutorial_StageOpened",
      private.stage_9_first
    ); 
  
    private.Subscribe(
      "stage_9",
      "View_Stage_DialogTargetsHided",
      private.stage_9_next1
    );

  end;

end;

function private.stage_9_next1 ()

  private.Unsubscribe( "stage_9", "View_Stage_DialogTargetsHided", private.stage_9_next1 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 11,
    pos_x          = pos_x,
    pos_y          = pos_y + private.cell_size,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = false,
    black          = true,
    input          = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_9_next2 );

  end;

  private.Dialog_ShowInstantly( "stage_9_1", positions, hole, func_close );

end;

function private.stage_9_next2 ()

  private.Subscribe( "stage_9", "Model_Match3_FieldActivated", private.stage_9_hide2 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0.5 * math.pi,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local func_close = function ()

    --
    
  end;

  private.Dialog_ShowInstantly( "stage_9_2", positions, hole, func_close );

  private.stage_9_last1();

end;

function private.stage_9_hide2 ()

  private.Unsubscribe( "stage_9", "Model_Match3_FieldActivated", private.stage_9_hide2 );

  private.Dialog_Hide();

end;

function private.stage_9_last1 ()

  private.Complete( "stage_9" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.magicgift ()

  private.Subscribe( "magicgift", "View_Stage_DialogStartActivated", private.magicgift_first );

end;

function private.magicgift_first ( stage_data )

  local stage_name = stage_data.name;

  if ( not m_tutorial.IsCompleted( "magicgift" ) ) then

    if ( stage_name == "stage_10" ) then

      local index = private.Entity_Index( stage_data.boosters, "magicgift", "start" );

      private.Unsubscribe( "magicgift", "View_Stage_DialogStartActivated", private.magicgift_first );
      
      private.Entity_Add( "magicgift", "magicgift", "booster" );
      private.Entity_Free_Show( "magicgift", "magicgift", "btn_int_dialog_stage_start_boosters_"..index );

      private.magicgift_next1( stage_data.boosters );
      
      --private.SetTimer( 0.1, function () private.magicgift_next1( stage_data.boosters ) end );

    end;

  end;

end;

function private.magicgift_next1 ( boosters )

  local index = private.Entity_Index( boosters, "magicgift", "start" );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_stage_start_boosters_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "btn_int_dialog_stage_start_boosters_"..index,
    offset_x    = 0,
    offset_y    = - 50,
    angle       = 0,
    scale       = 1,

    lock        = false
  };

  local func_close = function ()

    private.Dialog_Hide();

    private.Entity_Free_Hide( "btn_int_dialog_stage_start_boosters_"..index );

  end;

  private.Dialog_ShowInstantly( "magicgift", positions, hole, func_close );

  private.magicgift_last1();

end;

function private.magicgift_last1 ()

  private.Complete( "magicgift" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.skin ()

  private.Subscribe(
    "skin",
    "Model_Skins_SkinCollected",
    private.skin_first
  );
  
end;

function private.skin_first ( skin_name )

  private.Unsubscribe(
    "skin",
    "Model_Skins_SkinCollected",
    private.skin_first
  );

  if ( not m_tutorial.IsCompleted( "skin" ) ) then
    
    private.Subscribe(
      "skin",
      "View_Map_Update_Quest_RewardDisplayed",
      private.skin_next1
    );

    private.Subscribe(
      "skin",
      "Interface_DialogHero_Opened",
      private.skin_next2
    );

    m_storage.Session_Set( "tutorial_skin", skin_name );

  end;

end;

function private.skin_next1 ()
  
  private.Unsubscribe(
    "skin",
    "View_Map_Update_Quest_RewardDisplayed",
    private.skin_next1
  );
  
  private.PendingBegin( "skin", "map" );

  local dialog_settings = private.Dialog_Settings( "btn_int_panel_map_hero" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "btn_int_panel_map_hero",
    scale       = 1.25,

    offset_x    = 0,
    offset_y    = -70,
  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_hero_tap = common.TapGet( "btn_int_panel_map_hero" ).func_true;

  local func_close = function ()

    private.Dialog_Hide();
    common.TapSet( "btn_int_panel_map_hero", { func_true = func_hero_tap } );
    func_hero_tap();

  end;

  common.TapSet( "btn_int_panel_map_hero", { func_true = func_close } );  

  private.Dialog_ShowInstantly( "skin_1", positions, hole, nil, nil,
                                { active = true, notify = false } );

end;

function private.skin_next2 ()

  private.Unsubscribe(
    "skin",
    "View_Map_Update_Quest_RewardDisplayed",
    private.skin_next1
  );

  private.Unsubscribe(
    "skin",
    "Interface_DialogHero_Opened",
    private.skin_next2
  );

  private.PendingBegin( "skin", "map" );

  local skin_name = m_storage.Session_Get( "tutorial_skin" );
  local skin_data = m_skins.GetSkinInfo( skin_name );

  -- JK: if somehow the skin is already weared, force complete the tutorial
  if ( skin_data.weared ) then

    private.skin_last1();
    return;

  end;

  if ( not skin_data.parts ) or
     ( skin_data.parts < 1 ) then
     
    int.Lock( true );
    
    v_hero.Hero_FocusSkin( skin_name, function ()
      
      int.Lock( false );
      private.skin_next3();
    
    end );
 
    return;

  end;

  local dialog_settings =
    private.Dialog_Settings( "anm_int_dialog_hero_skin_info_progress" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "arrow",

    focus    = "anm_int_dialog_hero_skin_info_progress",
    angle    = 0,
    scale    = 1.0,

    offset_x  = 0,
    offset_y  = 0,

    lock     = true
  };

  local func_close = function ()
    
    mediator.Notify( "View_Tutorial_SkinProgressComplete" );

    private.Dialog_Hide( private.skin_next3 );

  end;

  int.Lock( true );
  
  v_hero.Hero_FocusSkin( skin_name, function ()
  
    private.Dialog_ShowInstantly( "skin_2", positions, hole, func_close );
    
    int.Lock( false );
  
  end );

end;

function private.skin_next3 ()
  
  local focus_obj = "obj_int_dialog_hero_skin_hero";
  local v_pref    = 65;
  
  if ( int.Landscape() ) then
    
    v_pref = nil;
    
  end;
  
  local dialog_settings = private.Dialog_Settings( focus_obj, v_pref );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "arrow",

    focus    = focus_obj,
    angle    = math.rad( 315 ),
    scale    = 1.0,

    offset_x =  50,
    offset_y = -150,

    lock     = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.skin_next4 );

  end;
  
  private.Dialog_ShowInstantly( "skin_3", positions, hole, func_close );

end;

function private.skin_next4 ()

  -- JK: if somehow the skin tab has no select button, force complete the tutorial
  if ( not int_dialog_hero.HasSelectButton() ) then

    private.skin_last1();
    return;

  end;

  local focus_obj = "btn_int_dialog_hero_skin_select";
  local v_pref    = 90;
  
  local dialog_settings = private.Dialog_Settings( focus_obj, v_pref );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = focus_obj,
    scale_x     = 1.4,
    scale_y     = 0.7,
    
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    local func_btn_wear_tap = private.Restore( "skin", "btn_wear_tap" );

    int.Button_EventSet( "btn_int_dialog_hero_skin_select", func_btn_wear_tap );

    func_btn_wear_tap();

    private.Dialog_Hide( private.skin_last1 );

  end;

  private.Backup(
    "skin",
    "btn_wear_tap",
    int.Button_EventGet( "btn_int_dialog_hero_skin_select" )
  );

  int.Button_EventSet( "btn_int_dialog_hero_skin_select", func_close );

  private.Dialog_ShowInstantly( "skin_4", positions, hole );

end;

function private.skin_last1 ()

  m_storage.Session_Clear( "tutorial_skin" );
  private.Complete( "skin" );
  private.PendingEnd( "skin", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.build ()

  private.Subscribe(
    "build",
    "View_Tutorial_MapOpened",
    private.build_first
  );

end;

function private.build_first ()

  if ( not m_tutorial.IsCompleted( "build" ) ) then

    if ( ( m_stage.GetSavedData( "stage_11" ) or {} ).completed ) then

      private.Unsubscribe(
        "build",
        "View_Tutorial_MapOpened",
        private.build_first
      );
      
      private.Subscribe(
        "build",
        "View_Map_Update_Finished",
        private.build_next1
      );

    end;

  end;

end;

function private.build_next1 ()

  private.Unsubscribe(
    "build",
    "View_Map_Update_Finished",
    private.build_next1
  );
  
  private.PendingBegin( "build", "map" );

  local func_close = function ()

    private.Dialog_Hide( private.build_last1 );

  end;

  local dialog_settings =
    private.Dialog_Settings( "spr_map_build_indicator_build_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "spr_map_build_indicator_build_1",
    scale       = 1.25,
  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };
  
  local events        = int.Control_EventsGet( "obj_map_builds_build_1" );
  local func_on_click = events.func_on_click;
  
  events.func_on_click = function ()
  
    func_close();
    func_on_click();
    events.func_on_click = func_on_click;
  
  end;

  local map_params =
  {
    notify = false,
    input  = true,
    active = true
  }; 

  v_map.Focus( "obj_map_builds_build_1",
    { 
      scale      = 1.0,
      -- time       = 0.6,
      func_after = function ()
      
        private.Dialog_ShowInstantly(
          "build",
          positions,
          hole,
          func_close,
          nil,
          map_params
        );
      
      end;
    }
  );

end;

function private.build_last1 ()

  private.Complete( "build" );
  private.PendingEnd( "build", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.mine ()

  private.Subscribe( "mine", "View_Tutorial_MapOpened", private.mine_first );

end;

function private.mine_first ()

  if ( not m_tutorial.IsCompleted( "mine" ) ) then

    if ( ( m_stage.GetSavedData( "stage_12" ) or {} ).completed ) then

      private.Unsubscribe( "mine", "View_Tutorial_MapOpened", private.mine_first ); 

      private.Subscribe( "mine", "View_Map_Update_Mine_Animated", private.mine_next1 );

    end;

  end;

end;

function private.mine_next1 ()

  private.Unsubscribe( "mine", "View_Map_Update_Mine_Animated", private.mine_next1 );
  
  private.PendingBegin( "mine", "map" );
  
  local events = int.Control_EventsGet( "btn_map_mines_mine_1" );
  local func_on_click = events.func_on_click; -- backup

  local func_close = function ( click )
  
    events.func_on_click = func_on_click; -- restore
  
    private.Dialog_Hide( private.mine_last1 );
    if ( click ) then func_on_click(); end;
    
  end;
  
  events.func_on_click = function () func_close( true ); end;
  
  local dialog_settings = private.Dialog_Settings( "obj_map_mines_mine_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "obj_map_mines_mine_1",
    offset_x    = 0,
    offset_y    = - 40,
    angle       = 0,
    scale       = 1.0,

    lock        = true
  };

  private.Dialog_ShowInstantly( 
    "mine", positions, hole, func_close, nil, { active = true }
  );

end;

function private.mine_last1 ()

  private.Complete( "mine" );
  private.PendingEnd( "mine", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_14 ()

  private.Subscribe(
    "stage_14",
    "View_Tutorial_StageOpened",
    private.stage_14_first
  );

end;

function private.stage_14_first ( stage_name )

  if ( stage_name == "stage_14"                 ) and
     ( not m_tutorial.IsCompleted( "stage_14" ) ) then
    
    private.Unsubscribe(
      "stage_14",
      "View_Tutorial_StageOpened",
      private.stage_14_first
    ); 
    
    private.Subscribe(
      "stage_14",
      "View_Stage_DialogTargetsHided",
      private.stage_14_next1
    );

  end;

end;

function private.stage_14_next1 ()
  
  private.Unsubscribe( "stage_14", "View_Stage_DialogTargetsHided", private.stage_14_next1 );

  local items_data = m_stage.GetCurrentStageData().items; 

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * items_data[ 1 ].col - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * items_data[ 1 ].row + private.cell_size;

  local pref_vertical = 12.5;
  
  if ( private.landscape ) then 
    
    pref_vertical = nil;
    
  end;
  
  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y }, pref_vertical );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale,
    character_pos_y = dialog_settings.ch_pos_y
  };
  
  local hole = 
  {
    type        = "arrow",

    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 1,
    angle       = 0,
    length      = 460,

    lock        = false
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_14_last1 );
    
  end;

  private.Dialog_ShowInstantly( "stage_14_1", positions, hole, func_close );

end;

function private.stage_14_last1 ()

  private.Complete( "stage_14" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.booster_shop ()
  
  private.Subscribe(
    "booster_shop",
    "View_Tutorial_MapOpened",
    private.booster_shop_first
  );
  
end;

function private.booster_shop_first ()
  if ( ( m_stage.GetSavedData( "stage_14" ) or {} ).completed ) and
    ( not m_tutorial.IsCompleted( "booster_shop" )) then
           private.Unsubscribe( "booster_shop", "View_Tutorial_MapOpened",
                           private.booster_shop_first );

      private.Subscribe( "booster_shop", "View_Map_Update_Finished",
                         private.booster_shop_next1 );
   end;
end;
                     
function private.booster_shop_next1 ()

  private.Unsubscribe( "booster_shop", "View_Map_Update_Finished",
                         private.booster_shop_next1 );
                         
  private.PendingBegin( "booster_shop", "map" );
  
  local dialog_settings =
  private.Dialog_Settings( "btn_int_panel_map_shop" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type  = "flashlight",
    focus = "btn_int_panel_map_shop",
    
    res_id   = 3,
    offset_x = 0,
    offset_y = -70,
    angle    = 0,
    scale    = 1.25,

    lock     = true,
    black    = true,
    wait     = true,
    hand = {  
         offset_x  = 0,
         offset_y  = 0,
         scale_x   = - 1,
         angle     = - 0.5 * math.pi, 
         type      = "click"
    }    
  };
  
  local func_close = function ()
    
    local func_shop_tap = private.Restore( "booster_shop", "booster_shop_tap" );
    common.TapSet( "btn_int_panel_map_shop", { func_true = func_shop_tap; } );
    
    private.Dialog_Hide( function()
      
      private.Complete( "booster_shop" );
      private.PendingEnd( "booster_shop", "map" );
      
      if ( func_shop_tap ) then
      
        func_shop_tap( nil, "boosters" );

      end;
    
    end );
      
  end;
  
  private.Backup(
    "booster_shop",
    "booster_shop_tap",
    common.TapGet( "btn_int_panel_map_shop" ).func_true
  );

  common.TapSet( "btn_int_panel_map_shop", { func_true = func_close } );

  private.Dialog_ShowInstantly( "booster_shop_1", positions, hole, nil, nil,
                                { active = true, notify = false } );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.booster_buy () 
  
  v_shop.Notify( true );
  
  private.Subscribe(
    "booster_buy",
    "View_Shop_TabOpened",
    private.booster_buy_first
  ); 
  
end;


function private.booster_buy_first ( name )
    
  if ( name ~= "boosters"                           ) or
     ( m_tutorial.IsCompleted( "booster_buy" )      ) or 
     ( not m_tutorial.IsCompleted( "booster_shop" ) ) then
    
    return;
    
  end;

  private.Unsubscribe(
    "booster_buy",
    "View_Shop_TabOpened",
    private.booster_buy_first
  );

  private.booster_buy_next();

end;

function private.booster_buy_next ()

  -- JK: Workaround, as normal focusing doesn't work
  local focus_obj = "btn_int_dialog_shop_close";
  
  local v_pref = 50;
  
  local shift_x, shift_y = -285, 89;
  local scale_x, scale_y = 0.98, 0.65;
  
  if ( private.landscape ) then
    
    shift_x, shift_y = -220, 70;
    scale_x, scale_y = 0.76, 0.5;
    
    v_pref = 70;
 
  end;
  
  local dialog_settings = private.Dialog_Settings( focus_obj, v_pref );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type     = "flashlight",
    focus    = focus_obj,
    res_id   = 8,
    offset_x = shift_x,
    offset_y = shift_y,
    angle    = 0,
    scale_x  = scale_x,
    scale_y  = scale_y,
    lock     = true,
    black    = true,
    input    = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.booster_buy_last );

  end;
  
  private.Dialog_ShowInstantly( "booster_buy_1", positions, hole, func_close );
  
end;

function private.booster_buy_last ()
  
  if ( not m_tutorial.IsCompleted( "booster_shop" ) ) then
    
    private.Complete( "booster_shop" );
    
  end;
  
  private.Complete( "booster_buy" );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_16_tap ()

  private.Subscribe( "stage_16_tap", "View_Stage_DialogStartActivated", private.stage_16_tap_last );

end;

function private.stage_16_tap_last ( stage_data )

  if ( stage_data.name == "stage_16" and not m_tutorial.IsCompleted( "stage_16_tap" ) ) then

    private.Unsubscribe( "stage_16_tap", "View_Stage_DialogStartActivated", private.stage_16_tap_last ); 

    private.Boosters_Backup( "stage_16_tap", "", false, "btn_int_dialog_stage_start_boosters" );
    
  end;    

end;
--------------------------------------------------------------------------------
function private.stage_16 ()

  private.Subscribe(
    "stage_16",
    "View_Tutorial_StageOpened",
    private.stage_16_first
  );

end;

function private.stage_16_first ( stage_name )

  if ( stage_name == "stage_16"                 ) and 
     ( not m_tutorial.IsCompleted( "stage_16" ) ) then

    private.Unsubscribe(
      "stage_16",
      "View_Tutorial_StageOpened",
      private.stage_16_first
    );

    private.Subscribe(
      "stage_16",
      "View_Stage_DialogTargetsHided",
      private.stage_16_next1
    );

    local sorcery_index = private.Entity_Index( 
      m_stage.GetCurrentStageData().boosters, "sorcery", "stage" );

    private.Backup( "stage_16", "sorcery_tap", common.TapGet( "obj_int_panel_stage_booster_"..sorcery_index ).func_true );

    common.TapSet( "obj_int_panel_stage_booster_"..sorcery_index, 
    { 
      func_true = function () end
    } );

    private.Boosters_Backup( "stage_16", sorcery_index );

    private.Backup( "stage_16", "settings_tap", 
      int.Control_EventsGet( "btn_int_panel_stage_settings_panel" ).func_on_click );

    int.Control_EventsSet( "btn_int_panel_stage_settings_panel", { 
      func_on_click = function () end } );

  end;

end;

function private.stage_16_next1 ()
  
  private.Unsubscribe( "stage_16", "View_Stage_DialogTargetsHided", private.stage_16_next1 );

  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "sorcery", "stage" );
  
  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( function () private.stage_16_next2( index ); end );

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Boosters_Backup( "stage_16", false, true );

  private.Dialog_ShowInstantly( "stage_16_1", positions, hole );
  
  private.Entity_Add( "stage_16", "sorcery", "booster" );
  private.Entity_Free_Show( "stage_16", "sorcery", "obj_int_panel_stage_booster_"..index );

end;

function private.stage_16_next2 ( index )
  
  private.Subscribe( "stage_16", "View_Boosters_BoosterUsed", 
    function ( params ) 
      private.stage_16_hide2( index, params.name ) 
    end );
  private.Subscribe( "stage_16", "View_Boosters_BoosterUsageFailed", 
    private.stage_16_reset );

  local items_data = m_stage.GetCurrentStageData().items;

  -- Fake tap.
  v_boosters.Tap( "stage", "sorcery", "stage_16", 
  { 
    row = items_data[ 1 ].row * 5, 
    col = items_data[ 1 ].col,
    vertical = true
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * items_data[ 1 ].col - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * items_data[ 1 ].row * 4 + private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.8,
    angle       = 1.575707,  

    lock        = true,
    wait        = true,
    black       = true,
    hand = {
         offset_x  = 0,
         offset_y  = 0,
         angle     = 0, 
         type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide();

  end;

  private.Dialog_ShowInstantly( "stage_16_2", positions, hole, func_close );

end;

function private.stage_16_hide2 ( index, booster_name )

  if ( booster_name == "sorcery" ) then

    local func_hide = function ()
      
      local dialog_settings =
        private.Dialog_Settings( "obj_int_panel_booster_sorcery_vertical" );

      local positions = 
      {
        dlg_start       = dialog_settings.start_x,
        dlg_end         = dialog_settings.pos_x,
        dlg_pos_y       = dialog_settings.pos_y,
        character_scale = dialog_settings.ch_scale
      };

      local hole = 
      {
        type        = "flashlight",  

        res_id      = 3,
        focus       = "obj_int_panel_booster_sorcery_vertical",
        scale       = 0.8,
        angle       = 1.575707,  

        lock        = true,
        wait        = true,
        black       = true,
        hand = {
             offset_x  = 0,
             offset_y  = 0,
             angle     = 0, 
             type      = "click"
        }
      };

      local func_close = function ()

        --

      end;

      private.Dialog_ShowInstantly( "stage_16_3", positions, hole, func_close );

      private.Backup( "stage_16", "lock_tap", common.TapGet( "obj_int_panel_booster_sorcery_lock" ).func_true );

      common.TapSet( "obj_int_panel_booster_sorcery_lock", 
      { 
        func_true = common.TapGet( "obj_int_panel_booster_sorcery_vertical" ).func_true 
      } );

    end;

    private.Dialog_Hide( func_hide );
    
    return;

  end;

  if ( booster_name == "sorcery_last" ) then

    private.Unsubscribe( "stage_16", "View_Boosters_BoosterUsed", function () private.stage_16_hide2( index ) end );
    private.Unsubscribe( "stage_16", "View_Boosters_BoosterUsageFailed", private.stage_16_reset );

    local func_lock_tap = private.Restore( "stage_16", "lock_tap" );

    common.TapSet( "obj_int_panel_booster_sorcery_lock", { func_true = func_lock_tap } );

    local func_sorcery_tap = private.Restore( "stage_16", "sorcery_tap" );

    common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_sorcery_tap } );

    private.Boosters_Restore( "stage_16", index );
    private.Boosters_Restore( "stage_16", false, true );

    local func_settings_tap = private.Restore( "stage_16", "settings_tap" );

    int.Control_EventsSet( "btn_int_panel_stage_settings_panel", { 
      func_on_click = func_settings_tap } );
    
    private.Dialog_Hide( private.stage_16_next3 );

    return;

  end;

end;

function private.stage_16_next3 ()

  private.Subscribe( "stage_16", "Model_Match3_FieldActivated", private.stage_16_hide3 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3;

  local v_pref = 75;
  
  if ( int.Landscape() ) then
    
    v_pref = nil;
    
  end;
  
  local dialog_settings = private.Dialog_Settings(
    { pos_x, pos_y },
    v_pref
  );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",

    res_id      = 12,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = private.cell_scale,
    angle       = 1.575707,

    hand = {
         offset_x  = 0,
         offset_y  = 2 * private.cell_size,
         angle     = 1.575707,
         type      = "move"
    },

    black       = true,
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide();

  end;

  private.Dialog_ShowInstantly( "stage_16_4", positions, hole, func_close );
  
  private.Boosters_Restore( "stage_16_tap", "", false, "btn_int_dialog_stage_start_boosters" );

  private.Complete( "stage_16" );
  private.Complete( "stage_16_tap" );

end;

function private.stage_16_hide3 ()

  private.Unsubscribe( "stage_16", "Model_Match3_FieldActivated", private.stage_16_hide3 );

  private.Dialog_Hide();

end;

function private.stage_16_reset ()

  local items_data = m_stage.GetCurrentStageData().items;

  -- Fake tap.
  v_boosters.Tap( "stage", "sorcery", "stage_16", 
  { 
    row = items_data[ 1 ].row * 5,
    col = items_data[ 1 ].col,
    vertical = true
  } );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.spellbook ()

  private.Subscribe( "spellbook", "View_Spells_SpellbookAppear", private.spellbook_first );

end;

function private.spellbook_first ()

  if ( not m_tutorial.IsCompleted( "spellbook" ) ) then

    if ( (m_stage.GetSavedData( "stage_18" ) or {}).completed ) then

      private.Unsubscribe( "spellbook", "View_Spells_SpellbookAppear", private.spellbook_first );
      
      private.Subscribe( "spellbook", "View_Map_Update_Finished", private.spellbook_next1 );

    end;

  end;

end;

function private.spellbook_next1 ()

  private.Unsubscribe( "spellbook", "View_Map_Update_Finished", private.spellbook_next1 );
  
  private.PendingBegin( "spellbook", "map" );

  local func_close = function ( execute_tap )

    private.Dialog_Hide( private.spellbook_last1 );

  end;

  local dialog_settings =
    private.Dialog_Settings( "obj_map_spells_spell_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",  

    res_id      = 3,
    focus       = "obj_map_spells_spell_1",
    scale       = 1,
    offset_x    = 0,
    offset_y    = - 80,
  
    lock        = false
  };

  private.Dialog_ShowInstantly(
   "spellbook_1", positions, hole, func_close, nil,
   { active = true, input = true, notify = false }
  );

end;

function private.spellbook_last1 ()

  private.Complete( "spellbook" );
  private.PendingEnd( "spellbook", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.heavenhelp ()

  private.Subscribe( "heavenhelp", "View_Stage_DialogStartActivated", private.heavenhelp_first );

end;

function private.heavenhelp_first ( stage_data )

  local stage_name = stage_data.name;

  if ( not m_tutorial.IsCompleted( "heavenhelp" ) ) then

    if ( stage_name == "stage_20" ) then

      local index = private.Entity_Index( stage_data.boosters, "heavenhelp", "start" );

      private.Unsubscribe( "heavenhelp", "View_Stage_DialogStartActivated", private.heavenhelp_first );

      private.Entity_Add( "heavenhelp", "heavenhelp", "booster" );
      private.Entity_Free_Show( "heavenhelp", "heavenhelp", "btn_int_dialog_stage_start_boosters_"..index );

      private.heavenhelp_next1( stage_data.boosters );
      
      --private.SetTimer( 0.1, function () private.heavenhelp_next1( stage_data.boosters ) end );

    end;

  end;

end;

function private.heavenhelp_next1 ( boosters )

  local index = private.Entity_Index( boosters, "heavenhelp", "start" );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_stage_start_boosters_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "btn_int_dialog_stage_start_boosters_"..index,
    offset_x    = 0,
    offset_y    = - 50,
    angle       = 0,
    scale       = 1,

    lock        = false
  };

  local func_close = function ()

    private.Dialog_Hide();

    private.Entity_Free_Hide( "btn_int_dialog_stage_start_boosters_"..index );

  end;

  private.Dialog_ShowInstantly( "heavenhelp", positions, hole, func_close );

  private.heavenhelp_last1();

end;

function private.heavenhelp_last1 ()

  private.Complete( "heavenhelp" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.mine_construct ()
  
  local mine_data = m_mines.GetMineData( "mine_1" );

  if ( mine_data.state == "ready" ) then

    local function func_at_section_open ( section )

      if ( section == 1 ) then

        private.mine_construct_next1( "mine_1" );

        mediator.Unsubscribe( "View_Map_Section_Switched", 
                              func_at_section_open         );

      end;

    end;

    mediator.Subscribe( "View_Map_Section_Switched", func_at_section_open );

  else

    private.Subscribe( "mine_construct", "Model_Mines_MineStateChanged", private.mine_construct_first );

  end;

end;

function private.mine_construct_first ( args )

  if ( args.name ~= "mine_1" ) then

    return;

  end;

  private.Unsubscribe( "mine_construct", "Model_Mines_MineStateChanged", private.mine_construct_first );
  
  if ( not m_tutorial.IsCompleted( "mine_construct" ) ) then

    private.Subscribe( "mine_construct", "View_Map_Update_Mine_Animated", private.mine_construct_next1 );

  end;

end;

function private.mine_construct_next1 ()
  
  private.Unsubscribe( "mine_construct", "View_Map_Update_Mine_Animated", private.mine_construct_next1 );
  
  private.PendingBegin( "mine_construct", "map" );
  
  local events        = int.Control_EventsGet( "btn_map_mines_mine_1" );
  local func_on_click = events.func_on_click;

  local func_close = function ()

    events.func_on_click = func_on_click;

    private.Dialog_Hide( function ()
    
      func_on_click();
      private.mine_construct_next2();
     
    end );

  end;
  
  events.func_on_click = func_close;

  local dialog_settings = private.Dialog_Settings( "obj_map_mines_mine_1" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_map_mines_mine_1",
    scale       = 1,
    offset_x    = 0,
    offset_y    = -20,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local map_params = { notify = false, input = true, active = true };

  private.Dialog_ShowInstantly(
    "mine_construct_1", positions, hole, func_close, nil, map_params
  );

end;

function private.mine_construct_next2 ()

  private.SetTimer( 0.3, private.mine_construct_next3 );

end;

function private.mine_construct_next3 ()

  local func_close = function ( execute_tap )

    local func_mine_construct_tap = private.Restore( "mine_construct", "mine_construct_tap" );

    common.TapSet( "anm_int_dialog_map_mine_resource1", { func_true = func_mine_construct_tap } );

    private.Dialog_Hide( private.mine_construct_next4 );

    if ( execute_tap ) then

      func_mine_construct_tap();

    end;

  end;

  private.Backup( "mine_construct", "mine_construct_tap", common.TapGet( "anm_int_dialog_map_mine_resource1" ).func_true );

  common.TapSet( "anm_int_dialog_map_mine_resource1", { func_true = function () func_close( true ); end } );

  local dialog_settings =
    private.Dialog_Settings( "anm_int_dialog_map_mine_resource1", 80, 70 );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "anm_int_dialog_map_mine_resource1",
    scale       = 1,
    offset_x    = 0,
    offset_y    = 0,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.3 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "mine_construct_2", positions, hole, func_close );

end;

function private.mine_construct_next4 ()

  local func_close = function ()

    local func_mine_construct_tap = private.Restore( "mine_construct", "mine_construct_tap" );

    int.Button_EventSet(
      "btn_int_dialog_map_mine_select",
      func_mine_construct_tap
    );

    private.Dialog_Hide( private.mine_construct_last1 );

    func_mine_construct_tap();

  end;

  private.Backup(
    "mine_construct",
    "mine_construct_tap",
    int.Button_EventGet( "btn_int_dialog_map_mine_select" )
  );

  int.Button_EventSet( "btn_int_dialog_map_mine_select", func_close );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_map_mine_select" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "btn_int_dialog_map_mine_select",
    scale_x     = 2.5,
    scale_y     = 1.0,
    offset_x    = 0,
    offset_y    = 0,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "mine_construct_3", positions, hole, func_close );
  private.Complete( "mine_construct" );

end;

function private.mine_construct_last1 ()

  private.PendingEnd( "mine_construct", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_26 ()

  private.Subscribe(
    "stage_26",
    "View_Tutorial_StageOpened",
    private.stage_26_first
  );

end;

function private.stage_26_first ( stage_name )

  if ( private.stage_26_has_enter ) then
    
    private.Unsubscribe( "stage_26", "Model_Match3_FieldActivated", private.stage_26_next1 );
    private.stage_26_has_enter = false;
    
  end;
  
  if ( stage_name == "stage_26"                 ) and
     ( not m_tutorial.IsCompleted( "stage_26" ) ) then

    private.Subscribe( "stage_26", "Model_Match3_FieldActivated", private.stage_26_next1 );

    private.stage_26_has_enter = true;
    private.stage_26_data = 0;
        
  end;

end;

function private.stage_26_next1 ()
  
  local stage_data = m_stage.GetCurrentStageData();
 
  if not ( stage_data.name == "stage_26" ) then
    
    return;
    
  end;
  
  private.stage_26_data = ( private.stage_26_data or 0 ) + 1;

  if ( ( stage_data.moves - private.stage_26_data ) == stage_data.items[ 1 ].move ) then

    private.Unsubscribe(
      "stage_26",
      "View_Tutorial_StageOpened",
      private.stage_26_first
    );
    
    private.Unsubscribe( "stage_26", "Model_Match3_FieldActivated", private.stage_26_next1 );

    private.Subscribe( "stage_26", "View_Match3_FieldEstablished", private.stage_26_next1_1 ); 

  end;

end;

function private.stage_26_next1_1 ()
  
  private.Unsubscribe( "stage_26", "View_Match3_FieldEstablished", private.stage_26_next1_1 );

  local wind_index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "wind", "stage" );

  private.Backup( "stage_26", "wind_tap", common.TapGet( "obj_int_panel_stage_booster_"..wind_index ).func_true );

  common.TapSet( "obj_int_panel_stage_booster_"..wind_index, { func_true = function () end } );

  private.Boosters_Backup( "stage_26", wind_index );

  private.Backup( "stage_26", "settings_tap", 
    int.Control_EventsGet( "btn_int_panel_stage_settings_panel" ).func_on_click );

  int.Control_EventsSet( "btn_int_panel_stage_settings_panel", { 
    func_on_click = function () end } );
  
  private.stage_26_next1_2();

end;

function private.stage_26_next1_2 ()
  
  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "wind", "stage" );
  
  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( function () private.stage_26_next2( index ); end );

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Dialog_ShowInstantly( "stage_26_1", positions, hole );
  
  private.Entity_Add( "stage_26", "wind", "booster" );
  private.Entity_Free_Show( "stage_26", "wind", "obj_int_panel_stage_booster_"..index );

end;

function private.stage_26_next2 ( index )

  private.Subscribe( "stage_26", "View_Boosters_BoosterUsed", private.stage_26_last1 );
  private.Subscribe( "stage_26", "View_Boosters_BoosterUsageFailed", private.stage_26_reset );

  common.MessageSubscribe( "Event_Match3_WindBoosterFirstSelected",
    private.stage_26_hide2 );

  local func_settings_tap = private.Restore( "stage_26", "settings_tap" );

  int.Control_EventsSet( "btn_int_panel_stage_settings_panel", { 
    func_on_click = func_settings_tap } );

  local func_wind_tap = private.Restore( "stage_26", "wind_tap" );

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_wind_tap } );

  private.Boosters_Restore( "stage_26", index );

  if ( func_wind_tap ) then

    func_wind_tap();

  end;

  local items_data = m_stage.GetCurrentStageData().items; 

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * items_data[ 1 ].col - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * items_data[ 1 ].row - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.5,
  
    lock        = true,
    black       = false,
    hand       = {
      offset_x  = 0,
      offset_y  = 0,
      scale     = 1,
      angle     = 0,
      type      = "click"
    },
    input       = false
  };

  local func_close = function ()

    private.Dialog_Hide();
    
  end;

  private.Dialog_ShowInstantly( "stage_26_2", positions, hole, func_close );

end;

function private.stage_26_hide2 ()
  
  common.MessageUnsubscribe( "Event_Match3_WindBoosterFirstSelected", 
    private.stage_26_hide2 );
  private.Dialog_Hide( private.stage_26_next3 );

end;

function private.stage_26_next3 ()

  local stage_data = m_stage.GetCurrentStageData();
  local items_data = stage_data.items; 

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * items_data[ 1 ].col - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * stage_data.field[ 1 ] - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.5,
  
    lock        = true,
    black       = false,
    hand       = {
      offset_x  = 0,
      offset_y  = 0,
      scale     = 1,
      angle     = 0,
      type      = "click"
    },
    input       = false
  };


  local func_close = function ()

    private.Dialog_Hide();
    
  end;

  private.Dialog_ShowInstantly( "stage_26_3", positions, hole, func_close );

  private.Complete( "stage_26" );

end;

function private.stage_26_last1 ()

  private.Unsubscribe( "stage_26", "View_Boosters_BoosterUsageFailed", private.stage_26_reset );

  private.Unsubscribe( "stage_26", "View_Boosters_BoosterUsed", private.stage_26_last1 );

  private.Dialog_Hide();

end;

function private.stage_26_reset ()

  local func_fake_tap = function ()
    
    v_boosters.Tap( "stage", "wind", "stage_26", { wind = true } );

  end;

  func_fake_tap();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.nolimits ()

  private.Subscribe(
    "nolimits",
    "View_Stage_DialogStartActivated",
    private.nolimits_first
  );

end;

function private.nolimits_first ( stage_data )

  local stage_name = stage_data.name;
  local completed  = m_tutorial.IsCompleted( "nolimits" );

  if ( stage_name == "stage_37" and not completed ) then

    private.Unsubscribe(
      "nolimits",
      "View_Stage_DialogStartActivated",
      private.nolimits_first
    );

    private.nolimits_point_to( stage_data.boosters );

  end;

end;

function private.nolimits_point_to( boosters )

  local index = private.Entity_Index( boosters, "nolimits", "start" );
  
  private.Entity_Add( "nolimits", "nolimits", "booster" );
  private.Entity_Free_Show(
    "nolimits",
    "nolimits",
    "btn_int_dialog_stage_start_boosters_"..index
  );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_stage_start_boosters_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "btn_int_dialog_stage_start_boosters_"..index,
    offset_x    = 0,
    offset_y    = - 50,
    angle       = 0,
    scale       = 1,

    lock        = false
  };

  local func_close = function ()

    private.Dialog_Hide();
    private.Entity_Free_Hide( "btn_int_dialog_stage_start_boosters_"..index );

  end;

  private.Dialog_ShowInstantly( "nolimits", positions, hole, func_close );
  private.nolimits_complete();

end;

function private.nolimits_complete ()

  private.Complete( "nolimits" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_44 ()

  private.Subscribe(
    "stage_44",
    "View_Tutorial_StageOpened",
    private.stage_44_first
  );

end;

function private.stage_44_first ( stage_name )

  if ( stage_name == "stage_44"                 ) and
     ( not m_tutorial.IsCompleted( "stage_44" ) ) then

    private.Unsubscribe(
      "stage_44",
      "View_Tutorial_StageOpened",
      private.stage_44_first
    ); 

    private.Subscribe(
      "stage_44",
      "View_Stage_DialogTargetsHided",
      private.stage_44_next1
    );

  end;

end;

function private.stage_44_next1 ()

  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "cascade", "stage" ); 

  private.Unsubscribe( "stage_44", "View_Stage_DialogTargetsHided", private.stage_44_next1 );

  private.Backup( "stage_44", "booster_tap", common.TapGet( "obj_int_panel_stage_booster_"..index ).func_true );

  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( function () private.stage_44_next2( index ); end );

  end;

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Dialog_ShowInstantly( "stage_44_1", positions, hole );
  
  private.Entity_Add( "stage_44", "cascade", "booster" );

  private.Entity_Free_Show( "stage_44", "cascade", "obj_int_panel_stage_booster_"..index );

end;

function private.stage_44_next2 ( index )

  private.Subscribe( "stage_44", "View_Boosters_BoosterUsed", private.stage_44_last1 );

  local func_booster_tap = private.Restore( "stage_44", "booster_tap" );

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_booster_tap } );

  if ( func_booster_tap ) then

    func_booster_tap();

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 2 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3 + private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y - 200 } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.7,
  
    lock        = true,
    black       = true,
    hand       = {
      offset_x  = 0,
      offset_y  = 0,
      scale     = 1,
      angle     = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "stage_44_2", positions, hole );

  private.Complete( "stage_44" );

end;

function private.stage_44_last1 ()

  private.Unsubscribe( "stage_44", "View_Boosters_BoosterUsed", private.stage_44_last1 );

  private.Dialog_Hide();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_45 ()

  private.Subscribe(
    "stage_45",
    "View_Tutorial_StageOpened",
    private.stage_45_first
  );

end;

function private.stage_45_first ( stage_name )

  if ( stage_name == "stage_45"                 ) and
     ( not m_tutorial.IsCompleted( "stage_45" ) ) then

    private.Unsubscribe(
      "stage_45",
      "View_Tutorial_StageOpened",
      private.stage_45_first
    ); 

    private.Subscribe(
      "stage_45",
      "View_Stage_DialogTargetsHided",
      private.stage_45_next1
    );

  end;

end;

function private.stage_45_next1 ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 3,
    pos_x          = pos_x,
    pos_y          = pos_y + private.cell_size,
    angle          = 0,
    scale          = 1,

    lock           = false,
    black          = true,
    input          = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_45_next2 );
    
  end;

  local text_param = m_stage.GetCurrentStageData().targets[ 1 ].count;

  private.Dialog_ShowInstantly(
    "stage_45_1",
    positions,
    hole,
    func_close,
    text_param
  );

end;

function private.stage_45_next2 ()

  private.Unsubscribe( "stage_45", "View_Stage_DialogTargetsHided", private.stage_45_next1 ); 
  private.Subscribe( "stage_45", "Model_Match3_FieldActivated", private.stage_45_hide1 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4 - private.cell_size;

  local v_pref = 25;
  
  if ( int.Landscape() ) then
    
    v_pref = nil;
    
  end;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y }, v_pref );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 3.1415,
    scale          = private.cell_scale,
    
    hand = {
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    },

    lock           = true
  };

  local func_close = function ()

    --

  end;

  private.Dialog_ShowInstantly( "stage_45_2", positions, hole, func_close );

end;

function private.stage_45_hide1 ()

  private.Unsubscribe( "stage_45", "Model_Match3_FieldActivated", private.stage_45_hide1 );

  private.Dialog_Hide();

  private.Complete( "stage_45" );

end;

function private.stage_45_last1 ()

  --

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.market_construct ()

  local section  = v_map.Section_Current();
  local unlocked = m_market.IsUnlocked();
  local built    = m_market.IsBuilt();
  
  if ( section ~= "section_1" ) then
    
    private.market_construct_last1();
    
    return;
    
  end;
  
  if ( built ) then
    
    private.market_construct_last1();
    
    return;
    
  end;

  if ( unlocked ) then
    
    private.SetTimer( 1.0, private.market_construct_next1 );

  else

    private.Subscribe( "market_construct", "Model_Market_Unlocked",
      private.market_construct_first
    );

  end;

end;

function private.market_construct_first ()

  private.Unsubscribe( "market_construct", "Model_Market_Unlocked",
    private.market_construct_first
  );
  
  private.Subscribe( "market_construct", "View_Map_Update_Finished",
    private.market_construct_next1
  );

end;

function private.market_construct_next1 ()
  
  private.Unsubscribe( "market_construct", "View_Map_Update_Finished",
    private.market_construct_next1
  );
  
  private.PendingBegin( "market_construct", "map" );

  v_map.Focus( "obj_map_builds_market", 
  { 
    scale      = 1.0,
    time       = 0.6, 
    func_after = function ()

      local func_close = function ( execute_tap )

        local func_market_construct_tap = private.Restore( "market_construct", "market_construct_tap" );

        common.TapSet( "obj_map_builds_market", { func_true = func_market_construct_tap } );

        private.Dialog_Hide( function ()
        
          if ( execute_tap ) then

            func_market_construct_tap();

          end;
          
          private.market_construct_next2();
         
        end );

      end;

      private.Backup( "market_construct", "market_construct_tap", common.TapGet( "obj_map_builds_market" ).func_true );

      common.TapSet( "obj_map_builds_market", { func_true = function () func_close( true ); end } );

      local dialog_settings =
        private.Dialog_Settings( "obj_map_builds_market" );

      local positions = 
      {
        dlg_start       = dialog_settings.start_x,
        dlg_end         = dialog_settings.pos_x,
        dlg_pos_y       = dialog_settings.pos_y,
        character_scale = dialog_settings.ch_scale
      };

      local hole = 
      {
        type        = "flashlight",  

        res_id      = 3,
        focus       = "obj_map_builds_market",
        scale       = 1,
        offset_x    = 0,
        offset_y    = -20,
      
        lock        = true,
        black       = false,
        hand        = {
          angle     = 0.5 * math.pi,
          offset_x  = 0,
          offset_y  = 0,
          type      = "click"
        }
      };

      private.Dialog_ShowInstantly(
        "market_construct_1",
        positions,
        hole, 
        func_close,
        nil,
        { input = true, active = true }
      );
    end 
  } );

end;

function private.market_construct_next2 ()

  private.SetTimer( 0.5, function ()
  
    if ( int_window.IsOnScreen( "int_dialog_map_build_market" ) ) then
  
      private.market_construct_next3();
      
    else
      
      private.market_construct_last1();
      
    end;
 
  end );

end;

function private.market_construct_next3 ()

  local func_close = function ( execute_tap )

    local func_market_construct_tap = private.Restore( "market_construct", "market_construct_tap" );

    int.Button_EventSet(
      "btn_int_dialog_map_build_market_accept",
      func_market_construct_tap
    );

    private.Dialog_Hide( private.market_construct_last1 );

    if ( execute_tap ) then

      func_market_construct_tap();

    end;

  end;

  private.Backup(
    "market_construct",
    "market_construct_tap",
    int.Button_EventGet( "btn_int_dialog_map_build_market_accept" )
  );

  int.Button_EventSet(
    "btn_int_dialog_map_build_market_accept",
    function () func_close( true ); end
  );
  
  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_map_build_market_accept" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type       = "flashlight",  

    res_id     = 3,
    focus      = "btn_int_dialog_map_build_market_accept",
    scale_x    = 1.6,
    scale_y    = 0.8,
    offset_x   = 0,
    offset_y   = 0,
  
    lock       = true,
    black      = false,
    hand       = {
      angle    = 0.5 * math.pi,
      offset_x = 0,
      offset_y = 0,
      type     = "click"
    }
  };

  private.Dialog_ShowInstantly(
    "market_construct_2",
    positions,
    hole,
    func_close
  );

end;

function private.market_construct_last1 ()

  private.Complete( "market_construct" );
  private.PendingEnd( "market_construct", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_69 ()

  private.Subscribe(
    "stage_69",
    "View_Tutorial_StageOpened",
    private.stage_69_first
  );

end;

function private.stage_69_first ( stage_name )

  if ( stage_name == "stage_69"                 ) and
     ( not m_tutorial.IsCompleted( "stage_69" ) ) then

    private.Unsubscribe(
      "stage_69",
      "View_Tutorial_StageOpened",
      private.stage_69_first
    ); 
    
    private.Subscribe(
      "stage_69",
      "View_Stage_DialogTargetsHided",
      private.stage_69_next1
    );

  end;

end;

function private.stage_69_next1 ()

  private.Unsubscribe(
    "stage_69",
    "View_Stage_DialogTargetsHided",
    private.stage_69_next1
  );

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = 0.5 * private.app_h
  };

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 2 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 8;

  local hole = 
  {
    type        = "arrow",

    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 1,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_69_next2 );
    
  end;

  private.Dialog_ShowInstantly( "stage_69_1", positions, hole, func_close );

end;

function private.stage_69_next2 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h - 250
  };

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 7 - private.cell_size;
  local pos_y = match3_pos[ 2 ];

  local hole = 
  {
    type        = "arrow",

    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 1,
    angle       = 3.1415,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_69_last1 );
    
  end;

  private.Dialog_ShowInstantly( "stage_69_2", positions, hole, func_close );

end;

function private.stage_69_last1 ()

  private.Complete( "stage_69" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.downright ()

  private.Subscribe( "downright", "View_Stage_DialogStartActivated", private.downright_first );

end;

function private.downright_first ( stage_data )

  local stage_name = stage_data.name;

  if ( not m_tutorial.IsCompleted( "downright" ) ) then

    if ( stage_name == "stage_76" ) then

      local index = private.Entity_Index( stage_data.boosters, "downright", "start" );

      private.Unsubscribe( "downright", "View_Stage_DialogStartActivated", private.downright_first );

      private.Entity_Add( "downright", "downright", "booster" );
      private.Entity_Free_Show( "downright", "downright", "btn_int_dialog_stage_start_boosters_"..index );

      private.downright_next1( stage_data.boosters );
      
      --private.SetTimer( 0.1, function () private.downright_next1( stage_data.boosters ) end );

    end;

  end;

end;

function private.downright_next1 ( boosters )

  local index = private.Entity_Index( boosters, "downright", "start" );

  local dialog_settings =
    private.Dialog_Settings( "btn_int_dialog_stage_start_boosters_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "btn_int_dialog_stage_start_boosters_"..index,
    offset_x    = 0,
    offset_y    = - 50,
    angle       = 0,
    scale       = 1,

    lock        = false
  };

  local func_close = function ()

    private.Dialog_Hide();

    private.Entity_Free_Hide( "btn_int_dialog_stage_start_boosters_"..index );

  end;

  private.Dialog_ShowInstantly( "downright", positions, hole, func_close );

  private.downright_last1();

end;

function private.downright_last1 ()

  private.Complete( "downright" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_79_tap ()

  private.Subscribe( "stage_79_tap", "View_Stage_DialogStartActivated", private.stage_79_tap_last );

end;

function private.stage_79_tap_last ( stage_data )

  if ( stage_data.name == "stage_79" and not m_tutorial.IsCompleted( "stage_79_tap" ) ) then

    private.Unsubscribe( "stage_79_tap", "View_Stage_DialogStartActivated", private.stage_79_tap_last ); 

    private.Boosters_Backup( "stage_79_tap", "", false, "btn_int_dialog_stage_start_boosters" );
    
  end;    

end;
--------------------------------------------------------------------------------
function private.stage_79 ()

  private.Subscribe(
    "stage_79",
    "View_Tutorial_StageOpened",
    private.stage_79_first
  );

end;

function private.stage_79_first ( stage_name )

  if ( stage_name == "stage_79"                 ) and
     ( not m_tutorial.IsCompleted( "stage_79" ) ) then

    private.Unsubscribe(
      "stage_79",
      "View_Tutorial_StageOpened",
      private.stage_79_first
    ); 

    private.Subscribe(
      "stage_79",
      "View_Stage_DialogTargetsHided",
      private.stage_79_next1
    );

  end;

end;

function private.stage_79_next1 ()

  private.Unsubscribe( "stage_79", "View_Stage_DialogTargetsHided", private.stage_79_next1 );
  private.Subscribe( "stage_79", "Model_Match3_FieldActivated", private.stage_79_hide1 );
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",

    res_id      = 1,
    pos_x       = pos_x,
    pos_y       = pos_y,
    angle       = - 0.5 * math.pi,
    scale       = private.cell_scale,

    lock        = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "move"
    }
  };

  private.Dialog_ShowInstantly( "stage_79_1", positions, hole );

end;

function private.stage_79_hide1 ()

  private.Dialog_Hide( private.stage_79_next2 );

end;

function private.stage_79_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 7 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",

    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = 0.5 * math.pi,
  
    lock  = false
  };

  local func_close = function ()

    private.Boosters_Restore( "stage_79_tap", "", false, "btn_int_dialog_stage_start_boosters" );
     
    private.Dialog_Hide( private.stage_79_last );

  end;

  private.Dialog_ShowInstantly( "stage_79_2", positions, hole, func_close );

end;

function private.stage_79_last ()

  private.Complete( "stage_79" );
  private.Complete( "stage_79_tap" );  

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_80 ()

  private.Subscribe(
    "stage_80",
    "View_Tutorial_StageOpened",
    private.stage_80_first
  );

end;

function private.stage_80_first ( stage_name )

  if ( stage_name == "stage_80"                 ) and
     ( not m_tutorial.IsCompleted( "stage_80" ) ) then

    private.Unsubscribe(
      "stage_80",
      "View_Tutorial_StageOpened",
      private.stage_80_first
    ); 

    private.Subscribe(
      "stage_80",
      "View_Stage_DialogTargetsHided",
      private.stage_80_next1
    );

  end;

end;

function private.stage_80_next1 ()

  private.Unsubscribe( "stage_80", "View_Stage_DialogTargetsHided", private.stage_80_next1 );

  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "fireburst", "stage" );
  
  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = true,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( function () private.stage_80_next2( index ); end );

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;

  private.Backup( "stage_80", "booster_tap", common.TapGet( "obj_int_panel_stage_booster_"..index ).func_true );

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Dialog_ShowInstantly( "stage_80_1", positions, hole );
  
  private.Entity_Add( "stage_80", "fireburst", "booster" );
  private.Entity_Free_Show( "stage_80", "fireburst", "obj_int_panel_stage_booster_"..index );

end;

function private.stage_80_next2 ( index )

  private.Subscribe( "stage_80", "View_Boosters_BoosterUsed", private.stage_80_last );

  local func_booster_tap = private.Restore( "stage_80", "booster_tap" );

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_booster_tap } );

  if ( func_booster_tap ) then

    func_booster_tap();

  end;

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 5 * 2 * private.cell_size - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 7 * 2 * private.cell_size - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.7,
  
    lock        = true,
    black       = true,
    hand       = {
      offset_x  = 0,
      offset_y  = 0,
      scale     = 1,
      angle     = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "stage_80_2", positions, hole );

  private.Complete( "stage_80" );

end;

function private.stage_80_last ()

  private.Unsubscribe( "stage_80", "View_Boosters_BoosterUsed", private.stage_80_last );

  private.Dialog_Hide();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.dragonspeech ()

  private.Subscribe( "dragonspeech", "View_Map_ZoneAppear", private.dragonspeech_first );

end;

function private.dragonspeech_first ( params )

  if ( params.build_name == "puzzle_1" ) then

    private.Unsubscribe( "dragonspeech", "View_Map_ZoneAppear", private.dragonspeech_first );

    if ( not m_tutorial.IsCompleted( "dragonspeech" ) ) then
    
      private.Subscribe(
        "dragonspeech",
        "View_Map_Update_CompletedStageAnimated",
        private.dragonspeech_next1
      );

    end;

  end;

end;

function private.dragonspeech_next1 ()

  private.Unsubscribe(
    "dragonspeech",
    "View_Map_Update_CompletedStageAnimated",
    private.dragonspeech_next1
  );
  
  private.PendingBegin( "dragonspeech", "map" );
  
  v_map.Focus(
    "obj_map_enemy_reddragon_stage_110",
    {
      scale = 1.0,
      time = 0.6,
      func_after = function ()
      
        int.ShowPopupCloud( 
          "monolog", 
          "obj_map_enemy_reddragon_stage_110", 
          "str_tutorial_dragonspeech",
          nil,
          { -50, -130 },
          nil,
          { 
            func_preclose = function ()
              private.PendingEnd( "dragonspeech", "map" );
            end
          }
        );
      
      end
    }
  );

  private.dragonspeech_last1();

end;

function private.dragonspeech_last1 ()

  private.Complete( "dragonspeech" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.worldmap ()

  local query =
  {
    query      = "find",
    group      = "player",
    collection = "sections",
    indice     = "name",
    criteria   = { like = "section_2" }
  };

  local section = m_storage.Execute( query ).result;

  if ( section ) then

    if ( not section.enabled ) --[[or ( section.enabled and not m_tutorial.IsCompleted( "worldmap" ) )]] then
    
      local section_name = m_map.Section_Current_Name();
      
      if ( section_name == "section_1" ) then
      
        private.Subscribe(
          "worldmap",
          "View_Map_Update_Finished",
          private.worldmap_first
        );
      
      end;
    
    elseif ( not m_tutorial.IsCompleted( "worldmap" ) ) then
    
      private.Complete( "worldmap" );
        
    end;

  else
  
    local function func_resubscribe ( section_name )
    
      if ( section_name == "section_1" ) then
      
        private.Unsubscribe(
          "worldmap",
          "View_Map_Update_PortalUnlocked",
          func_resubscribe
        );
      
        private.Subscribe(
          "worldmap",
          "View_Map_Update_Finished",
          private.worldmap_first
        );
      
      end;
    
    end;

    private.Subscribe(
      "worldmap",
      "View_Map_Update_PortalUnlocked",
      func_resubscribe
    );

  end;

end;

function private.worldmap_first ()

  private.Unsubscribe(
    "worldmap",
    "View_Map_Update_Finished",
    private.worldmap_first
  );
  
  private.PendingBegin( "worldmap", "map" );

  if ( not m_tutorial.IsCompleted( "worldmap" ) ) then

    private.worldmap_next1();

  end;

end;

function private.worldmap_next1 ()

  local dialog_settings =
    private.Dialog_Settings( "btn_map_portal_section_1_next" );
  
  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type           = "flashlight",

    res_id         = 3,
    focus          = "btn_map_portal_section_1_next",
    angle          = 0,
    scale          = 2.00,
    
    hand = {
          offset_x = - 50,
          offset_y = 0,
          scale_x  = - 1,
          type     = "click"
    },

    black          = false,
    lock           = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.worldmap_last1 );

  end;

  private.Backup( "worldmap", "portal_tap", common.TapGet( "btn_map_portal_section_1_next" ).func_true );

  common.TapSet( "btn_map_portal_section_1_next", { func_true = func_close } );

  v_map.Focus( "btn_map_portal_section_1_next",
    {
      time = 0.6,
      func_after = function ()
      
        private.Dialog_ShowInstantly( 
          "worldmap", positions, hole, nil, nil, 
          { active = true, input = true, notify = true }
        );
      
      end
    }
  );

  private.Complete( "worldmap" );

end;

function private.worldmap_last1 ()

  local func_portal_tap = private.Restore( "worldmap", "portal_tap" );

  common.TapSet( "btn_map_portal_section_1_next", { func_true = func_portal_tap } );

  if ( func_portal_tap ) then

    func_portal_tap();

  end;
  
  private.PendingEnd( "worldmap", "map" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_111 ()

  private.Subscribe(
    "stage_111",
    "View_Tutorial_StageOpened",
    private.stage_111_first
  );

end;

function private.stage_111_first ( stage_name )

  if ( stage_name == "stage_111"                 ) and
     ( not m_tutorial.IsCompleted( "stage_111" ) ) then

    private.Unsubscribe(
      "stage_111",
      "View_Tutorial_StageOpened",
      private.stage_111_first
    ); 

    private.Subscribe(
      "stage_111",
      "View_Stage_DialogTargetsHided",
      private.stage_111_next1
    );

  end;

end;

function private.stage_111_next1 ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3 - private.cell_size / 1.5;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "arrow",

    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 1,
    angle       = 0,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_111_next2 );
    
  end;

  local text_param = m_stage.GetCurrentStageData().targets[ 1 ].count;

  private.Dialog_ShowInstantly( "stage_111_1", positions, hole, func_close, text_param );

end;

function private.stage_111_next2 ()

  private.Unsubscribe( "stage_111", "View_Stage_DialogTargetsHided", private.stage_111_next1 ); 
  private.Subscribe( "stage_111", "Model_Match3_FieldActivated", private.stage_111_last1 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = math.pi,
    scale          = private.cell_scale,
    
    hand = {
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    },

    lock           = true
  };

  local func_close = function ()

    --

  end;

  private.Dialog_ShowInstantly( "stage_111_2", positions, hole, func_close );

end;

function private.stage_111_last1 ()

  private.Unsubscribe( "stage_111", "Model_Match3_FieldActivated", private.stage_111_last1 );

  private.Dialog_Hide();

  private.Complete( "stage_111" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_125_tap ()

  private.Subscribe( "stage_125_tap", "View_Stage_DialogStartActivated", private.stage_125_tap_last );

end;

function private.stage_125_tap_last ( stage_data )

  if ( stage_data.name == "stage_125" and not m_tutorial.IsCompleted( "stage_125_tap" ) ) then

    private.Unsubscribe( "stage_125_tap", "View_Stage_DialogStartActivated", private.stage_125_tap_last ); 

    private.Boosters_Backup( "stage_125_tap", "", false, "btn_int_dialog_stage_start_boosters" );
    
  end;    

end;
--------------------------------------------------------------------------------
function private.stage_125 ()

  private.Subscribe(
    "stage_125",
    "View_Tutorial_StageOpened",
    private.stage_125_first
  );

end;

function private.stage_125_first ( stage_name )

  if ( stage_name == "stage_125"                 ) and
     ( not m_tutorial.IsCompleted( "stage_125" ) ) then

    private.Unsubscribe(
      "stage_125",
      "View_Tutorial_StageOpened",
      private.stage_125_first
    ); 

    private.Subscribe(
      "stage_125",
      "View_Stage_DialogTargetsHided",
      private.stage_125_next1
    );

  end;

end;

function private.stage_125_next1 ()

  private.Unsubscribe(
    "stage_125",
    "View_Stage_DialogTargetsHided",
    private.stage_125_next1
  );
  
  private.Subscribe(
    "stage_125",
    "Model_Match3_FieldActivated",
    private.stage_125_hide1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 3.1415,
    scale          = private.cell_scale,
    
    hand = {
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    },

    lock           = true
  };

  private.Dialog_ShowInstantly( "stage_125_1", positions, hole );

end;

function private.stage_125_hide1 ()

  private.Unsubscribe( "stage_125", "Model_Match3_FieldActivated", private.stage_125_hide1 );

  private.Dialog_Hide( private.stage_125_next2 );

end;

function private.stage_125_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 3 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",

    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = math.pi,
  
    lock  = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_125_next3 );
    
  end;

  private.Dialog_ShowInstantly( "stage_125_2", positions, hole, func_close );

end;

function private.stage_125_next3 ()

  private.Subscribe( "stage_125", "Model_Match3_FieldActivated", private.stage_125_hide2 );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = - 0.5 * math.pi,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };


  private.Dialog_ShowInstantly( "stage_125_3", positions, hole );

end;

function private.stage_125_hide2 ()

  private.Unsubscribe( "stage_125", "Model_Match3_FieldActivated", private.stage_125_hide2 );

  private.Boosters_Restore( "stage_125_tap", "", false, "btn_int_dialog_stage_start_boosters" );  
  
  private.Dialog_Hide( private.stage_125_last );

end;

function private.stage_125_last ()
 
  private.Complete( "stage_125" );
  private.Complete( "stage_125_tap" );  

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stage_221 ()
  
  private.Subscribe(
    "stage_221",
    "View_Tutorial_StageOpened",
    private.stage_221_first
  );

end;

function private.stage_221_first ( stage_name )

  if ( stage_name == "stage_221"                 ) and
     ( not m_tutorial.IsCompleted( "stage_221" ) ) then

    private.Unsubscribe(
      "stage_221",
      "View_Tutorial_StageOpened",
      private.stage_221_first
    ); 
  
    private.Subscribe(
      "stage_221",
      "View_Stage_DialogTargetsHided",
      private.stage_221_next1
    );

  end;

end;

function private.stage_221_next1 ()
  
  private.Unsubscribe(
    "stage_221",
    "View_Stage_DialogTargetsHided",
    private.stage_221_next1
  );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 7;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "arrow",

    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.stage_221_next2 );
    
  end;

  private.Dialog_ShowInstantly( "stage_221_1", positions, hole, func_close );

end;

function private.stage_221_next2 ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 7;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = -0.5 * math.pi,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };


  local func_close;
  
  func_close = function ()
  
    private.Unsubscribe(
      "stage_221",
      "Model_Match3_FieldActivated",
      func_close
    );

    private.Dialog_Hide();

  end;
  
  private.Subscribe(
    "stage_221",
    "Model_Match3_FieldActivated",
    func_close
  );

  private.Dialog_ShowInstantly( "stage_221_2", positions, hole );

  private.stage_221_last();
 
end;

function private.stage_221_last ()

  private.Complete( "stage_221" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.count_bomb ()
  
  private.Subscribe(
    "count_bomb",
    "View_Tutorial_StageOpened",
    private.count_bomb_start
  );

end;

function private.count_bomb_start ( stage_name )

  if ( stage_name == "stage_230"                  ) and
     ( not m_tutorial.IsCompleted( "count_bomb" ) ) then

    private.Unsubscribe(
      "count_bomb",
      "View_Tutorial_StageOpened",
      private.count_bomb_start
    ); 
  
    private.Subscribe(
      "count_bomb",
      "View_Stage_DialogTargetsHided",
      private.count_bomb_point_to
    );

  end;

end;

function private.count_bomb_point_to ()

  private.Unsubscribe(
    "count_bomb",
    "View_Stage_DialogTargetsHided",
    private.count_bomb_point_to
  );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;

  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "arrow",

    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.count_bomb_show_match );

  end;

  private.Dialog_ShowInstantly( "count_bomb_1", positions, hole, func_close );

end;

function private.count_bomb_show_match ()

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 3 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5;

  local prefs = {
    portrait  = { nil, nil },
    landscape = { 30, 70 }
  };
  
  local orientation = int.Orientation();
  
  local dialog_settings =
    private.Dialog_Settings(
      { pos_x, pos_y },
      prefs[ orientation ][ 1 ],
      prefs[ orientation ][ 2 ]
    );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = - 0.5 * math.pi,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         scale_y   = - 1, 
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    private.Unsubscribe( "count_bomb",
                         "Model_Match3_FieldActivated", func_close );

    private.Dialog_Hide( private.count_bomb_complete );

  end;

  private.Subscribe( "count_bomb", "Model_Match3_FieldActivated", func_close );
  private.Dialog_ShowInstantly( "count_bomb_2", positions, hole );

end;

function private.count_bomb_complete ()

  private.Complete( "count_bomb" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.market ()

  v_shop.Notify( true );
  
  private.Subscribe( "market", "View_Shop_TabOpened",
    private.market_first
  );
  
end;

function private.market_first ( name )
  
  if not ( name == "market" ) then
    
    return;
    
  end;  

  private.Unsubscribe( "market", "View_Shop_TabOpened", private.market_first );

  private.SetTimer( 0.3, private.market_next1 );

end;

function private.market_next1 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h / 2 + 200
  };
  
  local hole =
  { 
    {
      type     = "arrow",

      focus    = "btn_int_dialog_shop_sell_slot_sell_1",
      offset_y = 20,
      angle    = math.rad( -155 ),
      scale    = 0.8,

      lock     = true
    },
    {
      type     = "arrow",

      focus    = "btn_int_dialog_shop_sell_slot_sell_2",
      offset_y = 20,
      angle    = math.rad( -155 ),
      scale    = 0.8,

      lock     = true
    },
    {
      type     = "arrow",

      focus    = "btn_int_dialog_shop_sell_slot_sell_3",
      offset_y = 20,
      angle    = math.rad( -155 ),
      scale    = 0.8,

      lock     = true
    }
  };

  local func_close = function ()

    private.Dialog_Hide( private.market_next2 );

  end;

  private.Dialog_ShowInstantly( "market_1", positions, hole, func_close );

end;

function private.market_next2 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h / 2 - 200
  };
  
  local offset_x =   40;
  local offset_y = - 40;
  
  local hole =
  { 
    {
      type     = "arrow",

      focus    = "obj_int_dialog_shop_market_buy_slot_1",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,

      lock     = true
    },
    {
      type     = "arrow",

      focus    = "obj_int_dialog_shop_market_buy_slot_2",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,

      lock     = true
    },
    {
      type     = "arrow",

      focus    = "obj_int_dialog_shop_market_buy_slot_3",
      offset_x = offset_x,
      offset_y = offset_y,
      angle    = math.rad( -45 ),
      scale    = 0.8,

      lock     = true
    },
    {
      type     = "arrow",

      focus    = "btn_int_dialog_shop_market_buy_accept",
      offset_x = 120,
      offset_y = 0,
      angle    = math.rad( -90 ),
      scale    = 0.8,

      lock     = true
    }
  };

  local func_close = function ()

    private.Dialog_Hide( private.market_last1 );

  end;

  private.Dialog_ShowInstantly( "market_2", positions, hole, func_close );

end;

--function private.market_next3 ()
--
--  local positions = 
--  {
--    dlg_start   = 1200,
--    dlg_pos_y   = private.app_h - 300
--  };
--  
--  local hole =
--  {
--    type     = "arrow",
--
--    focus    = "btn_int_dialog_shop_close",
--    offset_x = 0,
--    offset_y = 0,
--    angle    = 1.75 * math.pi,
--    scale    = 1.0,
--
--    lock     = true
--  };
--
--  local func_close = function ()
--
--    private.Dialog_Hide( private.market_last1 );
--
--  end;
--
--  private.Dialog_ShowInstantly( "market_3", positions, hole, func_close );
--
--end;

function private.market_last1 ()

  private.Complete( "market" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.dailyquest ()

  if ( m_dailyquest.Countdown_IsNeeded() ) or
     ( m_dailyquest.Countdown_IsActive() ) then

    private.Subscribe(
      "dailyquest",
      "Model_DailyQuest_CountdownEnded",
      private.dailyquest_first
    );

  else

    if ( not m_dailyquest.IsReady() ) then

      private.Subscribe(
        "dailyquest",
        "Model_DailyQuest_Ready",
        private.dailyquest_first
      );

    else

      private.dailyquest_first();

    end;

  end;

end;

function private.dailyquest_first ()

  private.Unsubscribe(
    "dailyquest",
    "Model_DailyQuest_CountdownEnded",
    private.dailyquest_first
  );

  if not ( m_tutorial.IsCompleted( "dailyquest" ) ) then

    if ( int_window.IsOnScreen( "int_dialog_dailyquest" ) ) then

      private.dailyquest_next1();

    else

      private.Subscribe(
        "dailyquest",
        "Interface_Window_WindowOpened",
        private.dailyquest_first1
      );

    end;

  end;

end;

function private.dailyquest_first1 ( window_name )

  if not ( window_name == "int_dialog_dailyquest" ) then

    return;

  end;

  private.Unsubscribe(
    "dailyquest",
    "Interface_Window_WindowOpened",
    private.dailyquest_first1
  );

  private.dailyquest_next1();

end;

function private.dailyquest_next1 ()

  local dialog_settings = private.Dialog_Settings(
    "obj_int_dialog_dailyquest_cloud",
    85
  );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "arrow",
    focus       = "obj_int_dialog_dailyquest_cloud",
    
    offset_x = 0,
    offset_y = 0,
    angle    = math.rad( 180 ),
    scale    = 1.0,

    lock     = true
  };
  
  ObjSet( "btn_int_dialog_dailyquest_close", { input = false } );
  
  int_window.OuterTap_Clear();

  local func_close = function ()

    private.Dialog_Hide( private.dailyquest_next2 );

  end;

  private.Dialog_ShowInstantly( "dailyquest_1", positions, hole, func_close );

end;

function private.dailyquest_next2 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h / 2 + 240
  };

  local hole = 
  {
    type        = "arrow",
    focus       = "anm_int_dialog_dailyquest_challenge_1",
    
    offset_x = 0,
    offset_y = 0,
    angle    = math.pi,
    scale    = 1.0,

    lock     = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.dailyquest_last1 );

  end;

  private.Dialog_ShowInstantly( "dailyquest_2", positions, hole, func_close );

end;

function private.dailyquest_last1 ()

  ObjSet( "btn_int_dialog_dailyquest_close", { input = true } );

  int_window.OuterTap_Set( "int_dialog_dailyquest" );

  private.Complete( "dailyquest" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.dailyquest_win ()

  private.Subscribe( "dailyquest_win", "View_DailyQuest_RewardShown", private.dailyquest_win_first );

end;

function private.dailyquest_win_first ( challenge_num )

  private.Unsubscribe( "dailyquest_win", "View_DailyQuest_RewardShown", private.dailyquest_win_first );

  if not ( m_tutorial.IsCompleted( "dailyquest_win" ) ) then

    private.dailyquest_win_next1( challenge_num );

  end;

end;

function private.dailyquest_win_next1 ( challenge_num )

  local positions = 
  {
    dlg_start   = 1200,
  };

  local challenge_pos = int.Position(
    "anm_int_dialog_dailyquest_challenge_"..challenge_num,
    "anm_int_dialog_dailyquest_window"
  );
  
  local arrow_pos  = { challenge_pos[ 1 ], challenge_pos[ 2 ] - 50 };
  local hole = 
  {
    type     = "arrow",
    focus    = "obj_int_dialog_dailyquest_challenge_"..challenge_num.."_reward",
    offset_x = arrow_pos[ 1 ],
    offset_y = arrow_pos[ 2 ],
    scale    = 0.8,
    angle    = 0,
    lock     = false
  };

  if ( challenge_num == 1 ) or ( challenge_num == 2 ) then

    positions.dlg_pos_y = private.app_h / 2 + 230;

  else

    positions.dlg_pos_y = private.app_h / 2 + 50;

  end;
    
  if ( challenge_num == 2 ) then

    positions.character_start = -135;
    positions.character_end   = -135;

  else

    positions.character_start = 135;
    positions.character_end   = 135;

  end;

  local func_close = function ()

    private.Dialog_Hide( private.dailyquest_win_last1 );

  end;

  private.Dialog_ShowInstantly( "dailyquest_win_1", positions, hole, func_close );

  private.Complete( "dailyquest_win" );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.stickers_duplicates ()

  if not m_tutorial.IsCompleted( "stickers_duplicates" ) then
    
    private.Subscribe(
      "stickers_duplicates",
      "Interface_DialogFireflies_ButtonSellShown",
      private.stickers_duplicates_first
    );
    
  end;

end;

function private.stickers_duplicates_first ( btn_name )
  
  private.Unsubscribe(
    "stickers_duplicates",
    "Interface_DialogFireflies_ButtonSellShown",
    private.stickers_duplicates_first
  );
  
  local pos_btn = int.Position( btn_name );

  local shift_x, shift_y = 0, -215;
  
  if ( private.landscape ) then
    
    shift_x = 46;
    shift_y = -165;
 
  end;
  
  local coords   = pos_btn;

  local coords   = {
    pos_btn[1] + shift_x,
    pos_btn[2] + shift_y
  };

  local pref_v = nil;
  
  if ( not private.landscape ) then
    
    pref_v = 65;
 
  end;
  
  local dialog_settings = private.Dialog_Settings( coords, pref_v );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",
    focus = "",
    
    offset_x = coords[ 1 ],
    offset_y = coords[ 2 ],
    angle    = 0.0,
    scale    = 1.0, 

    lock     = false
  };
  
  private.Dialog_ShowInstantly( "stickers_duplicates_1", positions, hole, function()
 
    private.Dialog_Hide( private.stickers_duplicates_last1 );
 
  end );
  
end;

function private.stickers_duplicates_last1 ()
  
  private.Complete( "stickers_duplicates" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.bonuspopup ()
  
  private.Subscribe( "bonuspopup", "View_Stage_PopupBonus_Activated", private.bonuspopup_first );

end;

function private.bonuspopup_first ()

  private.Unsubscribe( "bonuspopup", "View_Stage_PopupBonus_Activated", private.bonuspopup_first );
  
  local stage_name = m_stage.GetCurrentStageData().name;
  
  if ( stage_name == "stage_6" ) then
    
    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 0,
      level = 6,
      name  = "tut_level_6_damage"
    } );   
    
  end;

  local dialog_settings =
    private.Dialog_Settings( "obj_int_popup_stage_bonus" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "obj_int_popup_stage_bonus",
    offset_y    = 50,
    scale       = 1,
    angle       = 3.1415,

    lock = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.bonuspopup_last );
    
  end;

  private.Dialog_ShowInstantly( "bonuspopup", positions, hole, func_close );
  
  private.Complete( "bonuspopup" );

end;

function private.bonuspopup_last ()

  --
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.chest ()

  private.Subscribe( "chest", "View_Chests_ChestCollected", private.chest_last );

end;

function private.chest_last ( chest_name )

  if ( chest_name == "chest_1" and not m_tutorial.IsCompleted( "chest" ) ) then

    private.Unsubscribe( "chest", "View_Chests_ChestCollected", private.chest_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 0,
      level = 1,
      name  = "tut_present"
    } );  

    private.Complete( "chest" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.fortunewheel ()

  private.Subscribe( "fortunewheel", "View_Stage_DialogContinueOpened", private.fortunewheel_first );

end;

function private.fortunewheel_first ()

  private.Unsubscribe( "fortunewheel", "View_Stage_DialogContinueOpened", private.fortunewheel_first );

  if ( not m_tutorial.IsCompleted( "fortunewheel" ) ) then

    private.fortunewheel_next1();

  end;

end;

function private.fortunewheel_next1 ()
  
  v_stage.Dialog_Continue_SetPopupEnabled( false );

  local dialog_settings =
    private.Dialog_Settings( "obj_int_dialog_stage_continue_wheel" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 6,
    angle       = 1.575707,
    scale       = 1.0,
  
    lock        = true,
    black       = false,
    focus       = "obj_int_dialog_stage_continue_wheel",
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()
    
    private.Subscribe( "fortunewheel", "View_Stage_ContinueWheelReadyToSpin", 
                       private.fortunewheel_spin );
                     
    private.Dialog_Hide();

    local func_fortunewheel_tap = private.Restore( "fortunewheel", "fortunewheel_tap" );

    common.TapSet( "btn_int_dialog_stage_continue_window_open_wheel", { func_true = func_fortunewheel_tap } );

    if ( func_fortunewheel_tap ) then

      func_fortunewheel_tap();

    end;

  end;

  private.Backup( "fortunewheel", "fortunewheel_tap", common.TapGet( "btn_int_dialog_stage_continue_window_open_wheel" ).func_true );

  common.TapSet( "btn_int_dialog_stage_continue_window_open_wheel", { func_true = func_close } );

  private.Dialog_ShowInstantly( "fortunewheel", positions, hole );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 2,
    name  = "tut_wheel"
  } );

end;

function private.fortunewheel_spin ()

  private.Unsubscribe( "fortunewheel", "View_Stage_ContinueWheelReadyToSpin", 
                       private.fortunewheel_spin );  
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 3,
    name  = "tut_wheel_tap"
  } );

  local dialog_settings =
    private.Dialog_Settings( "obj_int_dialog_stage_continue_wheel" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 6,
    angle       = 1.575707,
    scale       = 1.0,
  
    lock        = true,
    black       = false,
    focus       = "obj_int_dialog_stage_continue_wheel",
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    local func_fortunewheelspin_tap = private.Restore( "fortunewheel", "fortunewheelspin_tap" );

    common.TapSet( "btn_int_dialog_stage_continue_wheel_run", { func_true = func_fortunewheelspin_tap } );

    if ( func_fortunewheelspin_tap ) then

      func_fortunewheelspin_tap();

    end;

    private.Dialog_Hide();
    
    v_stage.Dialog_Continue_SetPopupEnabled( true );

  end;

  private.Backup(
    "fortunewheel",
    "fortunewheelspin_tap",
    common.TapGet( "btn_int_dialog_stage_continue_wheel_run" ).func_true
  );

  common.TapSet(
    "btn_int_dialog_stage_continue_wheel_run",
    { func_true = func_close }
  );
  
  private.Dialog_ShowInstantly( "fortunewheel_spin", positions, hole );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 33,
    name  = "tut_wheel_spin"
  } );  

  private.Complete( "fortunewheel" );
  
end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.fortunewheel_activate ()

  private.Subscribe( "fortunewheel_activate", "View_Stage_ContinueWheelTurn", private.fortunewheel_activate_last );

end;

function private.fortunewheel_activate_last ()

  if ( not m_tutorial.IsCompleted( "fortunewheel_activate" ) ) then

    private.Unsubscribe( "fortunewheel_activate", "View_Stage_ContinueWheelTurn", private.fortunewheel_activate_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 0,
      level = 4,
      name  = "tut_wheel_activate"
    } );  

    private.Complete( "fortunewheel_activate" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.fortunewheel_win ()

  private.Subscribe( "fortunewheel_win", "View_Stage_ContinueWheelReward", private.fortunewheel_win_last );

end;

function private.fortunewheel_win_last ()

  if ( not m_tutorial.IsCompleted( "fortunewheel_win" ) ) then

    private.Unsubscribe( "fortunewheel_win", "View_Stage_ContinueWheelReward", private.fortunewheel_win_last ); 

    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 0,
      level = 5,
      name  = "tut_wheel_win"
    } );  

    private.Complete( "fortunewheel_win" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.spiders ()
  
  private.Subscribe(
    "spiders",
    "View_Tutorial_StageOpened", 
    private.spiders_first
  );
  
end;

function private.spiders_first ( stage_name )

  if ( stage_name == "stage_331"               ) and 
     ( not m_tutorial.IsCompleted( "spiders" ) ) then
    
    private.Unsubscribe(
      "spiders",
      "View_Tutorial_StageOpened",
      private.spiders_first
    );
    
    private.Subscribe(
      "spiders",
      "View_Stage_DialogTargetsHided",
      private.spiders_next1
    );

  end;
  
end;

function private.spiders_next1 ()
  
  private.Unsubscribe( "spiders", "View_Stage_DialogTargetsHided", private.spiders_next1 );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 13,
    name  = "tut_spiders"
  } );  
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",

    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = math.pi,
  
    lock  = false
  };

  local func_close = function ()
     
    private.Dialog_Hide( private.spiders_last );

  end;

  private.Dialog_ShowInstantly( "stage_331_1", positions, hole, func_close );

end;

function private.spiders_last ()

  private.Complete( "spiders" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.fans ()
  
  private.Subscribe(
    "fans",
    "View_Tutorial_StageOpened",
    private.fans_first
  );
  
end;

function private.fans_first ( stage_name )

  if ( stage_name == "stage_339"            ) and 
     ( not m_tutorial.IsCompleted( "fans" ) ) then
    
    private.Unsubscribe(
      "fans",
      "View_Tutorial_StageOpened",
      private.fans_first
    );
    
    private.Subscribe(
      "fans",
      "View_Stage_DialogTargetsHided",
      private.fans_next1
    );

  end;
  
end;

function private.fans_next1 ()
  
  private.Unsubscribe( "fans", "View_Stage_DialogTargetsHided", private.fans_next1 );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 14,
    name  = "tut_fans"
  } );
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 9 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type  = "arrow",

    pos_x = pos_x,
    pos_y = pos_y,
    scale = 1,
    angle = 0,
  
    lock  = false
  };

  local func_close = function ()
     
    private.Dialog_Hide( private.fans_last );

  end;

  private.Dialog_ShowInstantly( "stage_339_1", positions, hole, func_close );

end;

function private.fans_last ()

  private.Complete( "fans" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.anticrystal ()

  private.Subscribe(
    "anticrystal",
    "View_Tutorial_StageOpened",
    private.anticrystal_first
  );

end;

function private.anticrystal_first ( stage_name )

  if ( stage_name == "stage_340"                   ) and
     ( not m_tutorial.IsCompleted( "anticrystal" ) ) then

    private.Unsubscribe(
      "anticrystal",
      "View_Tutorial_StageOpened",
      private.anticrystal_first
    ); 

    private.Subscribe(
      "anticrystal",
      "View_Stage_DialogTargetsHided",
      private.anticrystal_next1
    );

  end;

end;

function private.anticrystal_next1 ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 15,
    name  = "tut_anticrystal"
  } );  

  local index = private.Entity_Index( m_stage.GetCurrentStageData().boosters, "anticrystal", "stage" ); 

  private.Unsubscribe( "anticrystal", "View_Stage_DialogTargetsHided", private.anticrystal_next1 );

  private.Backup( "anticrystal", "booster_tap", common.TapGet( "obj_int_panel_stage_booster_"..index ).func_true );

  local dialog_settings =
    private.Dialog_Settings( "obj_int_panel_stage_booster_"..index );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_int_panel_stage_booster_"..index,
    scale       = 1,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()
    
    private.Kontagent_LogEvent( "tutorial", 
    {
      value = 0,
      level = 16,
      name  = "tut_anticrystaldone"
    } );

    private.Dialog_Hide( function () private.anticrystal_next2( index ); end );

  end;

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_close } );

  private.Dialog_ShowInstantly( "stage_343_1", positions, hole );
  
  private.Entity_Add( "anticrystal", "anticrystal", "booster" ); --?? stage_343

  private.Entity_Free_Show( "anticrystal", "anticrystal", "obj_int_panel_stage_booster_"..index );--?? stage_343

end;

function private.anticrystal_next2 ( index )
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 17,
    name  = "tut_anticrystal_activate"
  } );     

  private.Subscribe( "anticrystal", "View_Boosters_BoosterUsed", private.anticrystal_last1 );

  local func_booster_tap = private.Restore( "anticrystal", "booster_tap" ); -- ??stage_343

  common.TapSet( "obj_int_panel_stage_booster_"..index, { func_true = func_booster_tap } );

  if ( func_booster_tap ) then

    func_booster_tap();

    private.Entity_Free_Hide( "obj_int_panel_stage_booster_"..index );

  end;

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 9 - private.cell_size;

  local dialog_settings =
    private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type        = "flashlight",

    res_id      = 3,
    pos_x       = pos_x,
    pos_y       = pos_y,
    scale       = 0.5,
  
    lock        = true,
    black       = false,
    hand       = {
      offset_x  = 0,
      offset_y  = 0,
      scale     = 1,
      angle     = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowInstantly( "stage_343_2", positions, hole );

  private.Complete( "anticrystal" );

end;

function private.anticrystal_last1 ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 18,
    name  = "tut_anticrystal_activatedone"
  } );    

  private.Unsubscribe( "anticrystal", "View_Boosters_BoosterUsed", private.anticrystal_last1 );

  private.Dialog_Hide();

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.candy ()

  private.Subscribe( "candy",
    "View_Tutorial_StageOpened",
    private.candy_first
  );

end;

function private.candy_first ( stage_name )

  if ( stage_name == "stage_441"             ) and
     ( not m_tutorial.IsCompleted( "candy" ) ) then

    private.Unsubscribe( "candy",
      "View_Tutorial_StageOpened",
      private.candy_first
    ); 

    private.Subscribe( "candy",
      "View_Stage_DialogTargetsHided",
      private.candy_show_match
    );

  end;
  
end;
  
function private.candy_show_match ()

  private.Unsubscribe( "candy",
    "View_Stage_DialogTargetsHided",
    private.candy_show_match
  );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 19,
    name  = "tut_candy_match"
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 7;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 6.5;
  
  local orientation = int.Orientation();
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    private.Unsubscribe( "candy",
      "Model_Match3_FieldActivated",
      func_close
    );

    private.Dialog_Hide( private.candy_point_counter );

  end;

  private.Subscribe( "candy",
    "Model_Match3_FieldActivated",
    func_close
  );
  
  private.Dialog_ShowInstantly( "candy_1", positions, hole );

end;

function private.candy_point_counter ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 20,
    name  = "tut_candy_matchdone"
  } );

  local dialog_settings =
    private.Dialog_Settings( "txt_int_panel_stage_targets_target_2_count" );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "txt_int_panel_stage_targets_target_2_count",
    offset_x    = 0,
    offset_y    = 0,
    scale       = 1,
    angle       = 1.25 * math.pi,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.candy_complete );
    
  end;
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 21,
    name  = "tut_candy_goal"
  } );

  private.Dialog_ShowInstantly( 
    "candy_2",
    positions, 
    hole, 
    func_close
  );

end;

function private.candy_complete ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 22,
    name  = "tut_candy_goaldone"
  } );

  private.Complete( "candy" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.bottles ()

  private.Subscribe(
    "bottles",
    "View_Tutorial_StageOpened",
    private.bottles_first
  );

end;

function private.bottles_first ( stage_name )

  if ( stage_name == "stage_441"               ) and
     ( not m_tutorial.IsCompleted( "bottles" ) ) then

    private.Unsubscribe(
      "bottles",
      "View_Tutorial_StageOpened",
      private.bottles_first
    ); 

    private.Subscribe(
      "bottles",
      "View_Stage_DialogTargetsHided",
      private.bottles_point_to
    );

  end;

end;

function private.bottles_point_to ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 23,
    name  = "tut_bottles"
  } );

  private.Unsubscribe(
    "bottles",
    "View_Stage_DialogTargetsHided",
    private.bottles_point_to
  );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5;

  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "arrow",

    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.bottles_show_match );

  end;

  private.Dialog_ShowInstantly( "bottles_1", positions, hole, func_close );

end;

function private.bottles_show_match ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 24,
    name  = "tut_bottlesdone"
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 2.5;
  
  local orientation = int.Orientation();
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );

  local positions = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    private.Unsubscribe( "bottles",
      "Model_Match3_FieldActivated",
      func_close
    );

    private.Dialog_Hide( private.bottles_complete );

  end;

  private.Subscribe( "bottles",
    "Model_Match3_FieldActivated",
    func_close
  );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 25,
    name  = "tut_bottles_match"
  } );
  
  private.Dialog_ShowInstantly( "bottles_2", positions, hole );

end;

function private.bottles_complete ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 26,
    name  = "tut_bottles_matchdone"
  } );

  private.Complete( "bottles" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.paint ()

  private.Subscribe(
    "paint",
    "View_Tutorial_StageOpened",
    private.paint_first
  );

end;

function private.paint_first ( stage_name )

  if ( stage_name == "stage_455"             ) and
     ( not m_tutorial.IsCompleted( "paint" ) ) then

    private.Unsubscribe( "paint",
      "View_Tutorial_StageOpened",
      private.paint_first
    ); 

    private.Subscribe( "paint",
      "View_Stage_DialogTargetsHided",
      private.paint_highlight
    );

  end;

end;

function private.paint_highlight ()

  private.Unsubscribe(
    "paint",
    "View_Stage_DialogTargetsHided",
    private.paint_highlight
  );
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 27,
    name  = "tut_paint"
  } );
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4.5;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 11,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = private.cell_scale,

    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.paint_show_match );

  end;

  private.Dialog_ShowInstantly( "paint_1", positions, hole, func_close );
  
end;

function private.paint_show_match ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 28,
    name  = "tut_paintdone"
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5 - private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 6;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = - 0.5 * math.pi,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0.5 * math.pi,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    private.Unsubscribe(
      "paint",
      "Model_Match3_FieldActivated", 
      func_close
    );

    private.Dialog_Hide( private.paint_highlight_result );

  end;

  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 29,
    name  = "tut_paint_match"
  } );
  
  private.Subscribe( "paint", "Model_Match3_FieldActivated", func_close );
  private.Dialog_ShowInstantly( "paint_2", positions, hole );

end;

function private.paint_highlight_result ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 30,
    name  = "tut_paint_matchdone"
  } );

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 4 + private.cell_size;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5.5;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 11,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = private.cell_scale,

    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.paint_complete );

  end;
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 31,
    name  = "tut_paint_color"
  } );

  private.Dialog_ShowInstantly( "paint_3", positions, hole, func_close );

end;

function private.paint_complete ()
  
  private.Kontagent_LogEvent( "tutorial", 
  {
    value = 0,
    level = 32,
    name  = "tut_paint_colordone"
  } );

  private.Complete( "paint" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.wind ()

  private.Subscribe(
    "wind",
    "View_Tutorial_StageOpened",
    private.wind_start
  );

end;

function private.wind_start ( stage_name )

  if ( stage_name == "stage_551"            ) and
     ( not m_tutorial.IsCompleted( "wind" ) ) then

    private.Unsubscribe(
      "wind",
      "View_Tutorial_StageOpened",
      private.wind_start
    ); 

    private.Subscribe(
      "wind",
      "View_Stage_DialogTargetsHided",
      private.wind_step1
    );

  end;

end;

function private.wind_step1 ()

  private.Unsubscribe(
    "wind",
    "View_Stage_DialogTargetsHided",
    private.wind_step1
  );
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 27,
  --    name  = "tut_wind"
  --  }
  --);
  
  local anm_wind       = "anm_wind";
  local animfunc       = "windflaw";
  local wind_x, wind_y = v_match3.GetFieldCenter();

  m_object.Create(
    anm_wind,
    "anim",
    "obj_match3",
    {
      res      = "assets/content/match3/fx/anm_windflaw",
      animfunc = animfunc,
      pos_x    = wind_x,
      pos_y    = wind_y
    }
  );

  local function wind_blow ( func_end )

    AnimPlay( anm_wind, animfunc, function() func_end( func_end ); end );

  end;

  local pos_x, pos_y = wind_x, wind_y;

  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 3,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 5,

    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    AnimStop( anm_wind );

    m_object.Delete( anm_wind );

    private.Dialog_Hide( private.wind_step2 );

  end;

  private.Dialog_ShowInstantly( "wind_1", positions, hole, func_close );

  wind_blow( wind_blow );
  
end;

function private.wind_step2 ()
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 28,
  --    name  = "tut_winddone"
  --  }
  --);

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 5;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5 - private.cell_size;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    private.Unsubscribe(
      "wind",
      "Model_Match3_FieldActivated", 
      func_close
    );

    private.Dialog_Hide( private.wind_complete );

  end;

  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 29,
  --    name  = "tut_wind_match"
  --  }
  --);
  
  private.Subscribe(
    "wind",
    "Model_Match3_FieldActivated",
    func_close
  );

  private.Dialog_ShowInstantly( "wind_2", positions, hole );

end;

function private.wind_complete ()
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 32,
  --    name  = "tut_wind_complete"
  --  }
  --);

  private.Complete( "wind" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.snowflakes ()

  private.Subscribe(
    "snowflakes",
    "View_Tutorial_StageOpened",
    private.snowflakes_start
  );

end;

function private.snowflakes_start ( stage_name )

  if ( stage_name == "stage_559"                  ) and
     ( not m_tutorial.IsCompleted( "snowflakes" ) ) then

    private.Unsubscribe(
      "snowflakes",
      "View_Tutorial_StageOpened",
      private.snowflakes_start
    ); 

    private.Subscribe(
      "snowflakes",
      "View_Stage_DialogTargetsHided",
      private.snowflakes_step1
    );

  end;

end;

function private.snowflakes_step1 ()

  private.Unsubscribe(
    "snowflakes",
    "View_Stage_DialogTargetsHided",
    private.snowflakes_step1
  );
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 27,
  --    name  = "tut_snowflakes"
  --  }
  --);
  
  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 1;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 6;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 15,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,
    scale  = 1,

    lock   = false,
    black  = true,
    input  = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.snowflakes_step2 );

  end;

  private.Dialog_ShowInstantly( "snowflakes_1", positions, hole, func_close );

end;

function private.snowflakes_step2 ()
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 28,
  --    name  = "tut_snowflakesdone"
  --  }
  --);

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 1;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 5.5;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type           = "flashlight",

    res_id         = 1,
    pos_x          = pos_x,
    pos_y          = pos_y,
    angle          = 0,
    scale          = private.cell_scale,

    lock           = true,
    hand           = {
         angle     = 0,
         offset_x  = 0,
         offset_y  = 0,
         type      = "move"
    }
  };

  local function func_close ()

    int.Lock( true );

    private.Unsubscribe(
      "snowflakes",
      "Model_Match3_FieldActivated",
      func_close
    );

    private.Dialog_Hide();

    local function OnGoalReceived ()

      private.Unsubscribe(
        "snowflakes",
        "Interface_PanelStageTop_GoalReceived",
        OnGoalReceived
      );      

      private.snowflakes_step3();

      int.Lock( false );

    end;

    private.Subscribe(
      "snowflakes",
      "Interface_PanelStageTop_GoalReceived",
      OnGoalReceived
    );

  end;

  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 29,
  --    name  = "tut_wind_match"
  --  }
  --);
  
  private.Subscribe(
    "snowflakes",
    "Model_Match3_FieldActivated",
    func_close
  );

  private.Dialog_ShowInstantly( "snowflakes_2", positions, hole );

end;

function private.snowflakes_step3 ()
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 28,
  --    name  = "tut_snowflakesdone"
  --  }
  --);

  local match3_pos = GetObjPosByObj( "match" );

  local pos_x = match3_pos[ 1 ] + 2 * private.cell_size * 8;
  local pos_y = match3_pos[ 2 ] + 2 * private.cell_size * 4;
  
  local dialog_settings = private.Dialog_Settings( { pos_x, pos_y } );
  local positions       = 
  {
    dlg_start       = dialog_settings.start_x,
    dlg_end         = dialog_settings.pos_x,
    dlg_pos_y       = dialog_settings.pos_y,
    character_scale = dialog_settings.ch_scale
  };
  
  local hole = 
  {
    type   = "flashlight",

    res_id = 15,
    pos_x  = pos_x,
    pos_y  = pos_y,
    angle  = 0,

    lock   = false,
    black  = true,
    input  = true
  };

  local function func_close ()

    private.Dialog_Hide( private.snowflakes_complete );

  end;

  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 29,
  --    name  = "tut_wind_match"
  --  }
  --);

  private.Dialog_ShowInstantly( "snowflakes_3", positions, hole, func_close );

end;

function private.snowflakes_complete ()
  
  --private.Kontagent_LogEvent(
  --  "tutorial", 
  --  {
  --    value = 0,
  --    level = 32,
  --    name  = "tut_snowflakes_complete"
  --  }
  --);

  private.Complete( "snowflakes" );

end;
--------------------------------------------------------------------------------
-- function ...unused... () end;
--------------------------------------------------------------------------------
function private.resources ()

  private.Subscribe( "resources", "View_Tutorial_MapOpened", private.resources_first );

end;

function private.resources_first ()

  if ( not m_tutorial.IsCompleted( "resources" ) ) then

    if ( ( m_stage.GetSavedData( "stage_4" ) or {} ).completed ) then

      private.Unsubscribe( "resources", "View_Tutorial_MapOpened", private.resources_first ); 

      private.SetTimer( 0.5, private.resources_next1 );

    end;

  end;

end;

function private.resources_next1 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = private.app_h / 2 - 200
  };

  local hole = 
  {
    type        = "arrow",

    focus       = "obj_int_panel_map_resource1",
    offset_x    = - 65,
    offset_y    = 0,
    angle       = 3.1415,
    scale       = 1.0,

    lock        = true
  };

  local func_close = function ( execute_tap )

    private.Dialog_Hide( 

      private.resources_last1

    );

  end;

  private.Dialog_ShowFromQueue( "resources_1", positions, hole, func_close );

  private.Complete( "resources" );

end;

function private.resources_last1 ()

  v_map.Focus( "obj_map_marker" );

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.replay ()

  private.Subscribe( "replay", "View_Tutorial_MapOpened", private.replay_first );

end;

function private.replay_first ()

  if ( not m_tutorial.IsCompleted( "replay" ) ) then

    if ( (m_stage.GetSavedData( "stage_7" ) or {}).completed ) then

      private.Unsubscribe( "replay", "View_Tutorial_MapOpened", private.replay_first );
      
      if ( (m_stage.GetSavedData( "stage_5" ) or {}).state < 3 ) then

        private.SetTimer( 0.5, private.replay_next1 );

      end;

    end;

  end;

end;

function private.replay_next1 ()

  local func_close = function ( execute_tap )

    local func_stage_tap = private.Restore( "replay", "stage_tap" );

    common.TapSet( "btn_map_point_stage_5", { func_true = func_stage_tap } );

    private.Dialog_Hide( private.replay_next2 );

    if ( execute_tap ) then

      func_stage_tap();

    end;

  end;

  private.Backup( "replay", "stage_tap", common.TapGet( "btn_map_point_stage_5" ).func_true );

  common.TapSet( "btn_map_point_stage_5", { func_true = function () func_close( true ); end } );

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = 0.5 * private.app_h + 100
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 3,
    focus       = "obj_map_point_stage_5",
    scale       = 0.8,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  private.Dialog_ShowFromQueue( "replay_1", positions, hole, func_close );

end;

function private.replay_next2 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = 0.5 * private.app_h + 100
  };

  local hole = 
  {
    type        = "arrow",  

    focus       = "obj_int_dialog_stage_start_states_3",
    scale       = 1.0,
    offset_x    = - 50,
    offset_y    = 0,
    angle       = 1.575707,
  
    lock        = true
  };

  local func_close = function ()

    private.Dialog_Hide( private.replay_next3 );

  end;

  private.Dialog_ShowInstantly( "replay_2", positions, hole, func_close );

end;

function private.replay_next3 ()

  local positions = 
  {
    dlg_start   = 1200,
    dlg_pos_y   = 400
  };

  local hole = 
  {
    type        = "flashlight",  

    res_id      = 4,
    focus       = "btn_int_dialog_stage_start_play",
    scale       = 1.5,
  
    lock        = true,
    black       = false,
    hand        = {
      angle     = 0.5 * math.pi,
      offset_x  = 0,
      offset_y  = 0,
      type      = "click"
    }
  };

  local func_close = function ()

    private.Dialog_Hide( private.replay_last1 );

  end;

  local func_tap = common.TapGet( "btn_int_dialog_stage_start_play" ).func_true;

  common.TapSet( "btn_int_dialog_stage_start_play", { func_true = function ()

    func_close();
    func_tap();

    common.TapSet( "btn_int_dialog_stage_start_play", { func_true = func_tap } );

  end } );

  private.Dialog_ShowInstantly( "replay_3", positions, hole, func_close );

  private.Complete( "replay" );

end;

function private.replay_last1 ()

  --

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.robber_cloud ()

  private.Subscribe( "robber_cloud", "View_Map_HeroPopupActivated", private.robber_cloud_last );

end;

function private.robber_cloud_last ( stage_name )

  if ( stage_name == "stage_6" and not m_tutorial.IsCompleted( "robber_cloud" ) ) then

    private.Unsubscribe( "robber_cloud", "View_Map_HeroPopupActivated", private.robber_cloud_last ); 

    private.Complete( "robber_cloud" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.swordstone_cloud ()

  private.Subscribe( "swordstone_cloud", "View_Map_HeroPopupActivated", private.swordstone_cloud_last );

end;

function private.swordstone_cloud_last ( stage_name )

  if ( stage_name == "stage_2" and not m_tutorial.IsCompleted( "swordstone_cloud" ) ) then

    private.Unsubscribe( "swordstone_cloud", "View_Map_HeroPopupActivated", private.swordstone_cloud_last ); 

    private.Complete( "swordstone_cloud" );

  end;    

end;
--------------------------------------------------------------------------------
-- function ... () end;
--------------------------------------------------------------------------------
function private.prisoner_cloud ()

  private.Subscribe( "prisoner_cloud", "View_Map_HeroPopupActivated", private.prisoner_cloud_last );

end;

function private.prisoner_cloud_last ( stage_name )

  if ( stage_name == "stage_3" and not m_tutorial.IsCompleted( "prisoner_cloud" ) ) then

    private.Unsubscribe( "prisoner_cloud", "View_Map_HeroPopupActivated", private.prisoner_cloud_last );

    private.Complete( "prisoner_cloud" );

  end;    

end;
--------------------------------------------------------------------------------